SystemOrganization addCategory: #'Scriptaculous-Core'!
SystemOrganization addCategory: #'Scriptaculous-Testing'!
SystemOrganization addCategory: #'Scriptaculous-Platform'!

!Object methodsFor: '*scriptaculous' stamp: 'lr 4/6/2006 22:53'!
asExpression
	^ SUJavascript on: self asJavascript! !

!Object methodsFor: '*scriptaculous' stamp: 'lr 4/1/2006 11:28'!
asFunction
	^ SUFunction on: self! !

!Object methodsFor: '*scriptaculous' stamp: 'lr 4/1/2006 11:29'!
asJavascript
	^ String streamContents: [ :stream | self printOn: stream ]! !

Object subclass: #SUFunction
	instanceVariableNames: 'body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUFunction class methodsFor: 'instance-creation' stamp: 'lr 4/1/2006 11:27'!
on: anObject
	^ self new body: anObject! !

!SUFunction methodsFor: 'converting' stamp: 'lr 4/6/2006 08:11'!
asJavascript
	^ String streamContents: [ :stream |
		stream
			nextPutAll: 'function(){';
			nextPutAll: self body asJavascript;
			nextPut: $} ]! !

!SUFunction methodsFor: 'accessing' stamp: 'lr 4/1/2006 11:26'!
body
	^ body! !

!SUFunction methodsFor: 'accessing' stamp: 'lr 4/1/2006 11:26'!
body: anObject
	body := anObject! !

Object subclass: #SUJavascript
	instanceVariableNames: 'source'
	classVariableNames: 'JavascriptCharacters'
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUJavascript class methodsFor: 'instance-creation' stamp: 'lr 4/7/2006 13:52'!
arguments
	^ self on: 'arguments'! !

!SUJavascript class methodsFor: 'utilities' stamp: 'lr 3/30/2006 22:10'!
encode: aString
	| charOrString |
	^ String streamContents: [ :stream |
		stream nextPut: $'.
		aString do: [ :char |
			charOrString := JavascriptCharacters
				at: char asInteger + 1
				ifAbsent: [ '\u' , ((char asInteger printStringBase: 16) padded: #left to: 4 with: $0) ].
			charOrString isString
				ifTrue: [ stream nextPutAll: charOrString ]
				ifFalse: [ stream nextPut: charOrString ] ].
		stream nextPut: $' ]! !

!SUJavascript class methodsFor: 'utilities' stamp: 'lr 4/6/2006 21:26'!
initialize
	JavascriptCharacters := Array new: 127.
	0 to: 31 do: [ :each |
		JavascriptCharacters
			at: each + 1
			put: '\x' , ((each printStringBase: 16)
				padded: #left to: 2 with: $0) ].
	32 to: 126 do: [ :each |
		JavascriptCharacters
			at: each + 1
			put: each asCharacter ].
	#( $\ '\\' $' '\''' $" '\"') pairsDo: [ :char :string |
		JavascriptCharacters at: (char asInteger + 1) put: string ]! !

!SUJavascript class methodsFor: 'instance-creation' stamp: 'lr 4/1/2006 11:24'!
on: anObject
	^ self new source: anObject! !

!SUJavascript class methodsFor: 'instance-creation' stamp: 'lr 4/2/2006 14:20'!
return: anObject
	^ self on: 'return ' , anObject asJavascript! !

!SUJavascript methodsFor: 'converting' stamp: 'lr 2/21/2006 20:38'!
asJavascript
	^ self source! !

!SUJavascript methodsFor: 'dispatching' stamp: 'lr 4/6/2006 21:35'!
at: aKey
	^ self class on: self source , '[' , aKey asJavascript , ']'! !

!SUJavascript methodsFor: 'dispatching' stamp: 'lr 4/6/2006 21:35'!
at: aKey put: aValue
	^ self class on: self source , '[' , aKey asJavascript , ']=' , aValue asJavascript! !

!SUJavascript methodsFor: 'private' stamp: 'lr 4/6/2006 21:38'!
doesNotUnderstand: aMessage
	^ self class on: (String streamContents: [ :stream |
		stream nextPutAll: self source.
		aMessage selector isInfix
			ifTrue: [ stream nextPutAll: aMessage selector; nextPutAll: aMessage argument asJavascript ]
			ifFalse: [
				stream nextPut: $.; nextPutAll: (aMessage selector copyUpTo: $:); nextPut: $(.
				aMessage arguments
					do: [ :each | stream nextPutAll: each asJavascript ]
					separatedBy: [ stream nextPut: $, ].
				stream nextPut: $) ] ])! !

!SUJavascript methodsFor: 'dispatching' stamp: 'lr 4/6/2006 21:48'!
do: aBlock
	^ self class on: self source , '.each(' , aBlock asJavascript , ')'! !

!SUJavascript methodsFor: 'accessing' stamp: 'lr 2/21/2006 20:38'!
source
	^ source! !

!SUJavascript methodsFor: 'accessing' stamp: 'lr 2/21/2006 20:38'!
source: aString
	source := aString! !

!SUJavascript methodsFor: 'dispatching' stamp: 'lr 4/6/2006 21:34'!
= anObject
	^ self class on: self source , '==' , anObject asJavascript! !

!SUJavascript methodsFor: 'dispatching' stamp: 'lr 4/6/2006 21:34'!
~= anObject
	^ self class on: self source , '!!=' , anObject asJavascript! !

Object subclass: #SUJoin
	instanceVariableNames: 'collection joiner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUJoin class methodsFor: 'instance-creation' stamp: 'avi 9/27/2005 23:29'!
join: aCollection with: aString
	^ self new
		collection: aCollection;
		joiner: aString;
		yourself! !

!SUJoin methodsFor: 'adding' stamp: 'lr 3/30/2006 14:46'!
add: anExpression
	self collection add: anExpression! !

!SUJoin methodsFor: 'converting' stamp: 'lr 4/1/2006 11:47'!
asJavascript
	^ String streamContents: [ :stream |
		stream
			nextPutAll: collection asJavascript;
			nextPutAll: '.join(';
			nextPutAll: joiner asJavascript;
			nextPutAll: ')' ]! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:40'!
collection
	^ collection! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:28'!
collection: aCollection
	collection _ aCollection! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:40'!
joiner
	^ joiner! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:28'!
joiner: aString
	joiner _ aString! !

Object subclass: #SUPrototype
	instanceVariableNames: 'effect id args options before condition after'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

SUPrototype subclass: #SUAjax
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUAjax class methodsFor: 'instance-creation' stamp: 'lr 3/30/2006 18:58'!
on: aCanvas
	^ self basicNew initializeWithCanvas: aCanvas! !

!SUAjax methodsFor: 'parameters' stamp: 'avi 9/27/2005 23:38'!
addParameters: aCollection
	self parameters addAll: aCollection associations! !

!SUAjax methodsFor: 'parameters' stamp: 'avi 9/27/2005 23:39'!
addParameter: anAssociation
	self parameters add: anAssociation! !

!SUAjax methodsFor: 'options' stamp: 'lr 3/12/2006 16:22'!
asynchronous: aBoolean
	"Indicates if the AJAX call will be made asynchronously."

	self optionAt: 'asynchronous' put: aBoolean! !

!SUAjax methodsFor: 'callbacks' stamp: 'lr 4/2/2006 14:26'!
callback: aBlock
	self addParameter: (canvas callbacks registerActionCallback: [ self performAjax: aBlock ])! !

!SUAjax methodsFor: 'callbacks' stamp: 'lr 4/2/2006 14:26'!
callback: aBlock value: anObject
	self addParameter: (canvas callbacks registerCallback: aBlock) -> anObject! !

!SUAjax methodsFor: 'private' stamp: 'lr 3/30/2006 18:50'!
defaultEffect
	^ 'Updater'! !

!SUAjax methodsFor: 'options' stamp: 'lr 3/12/2006 16:22'!
evalScripts: aBoolean
	"Evaluate javascript-code within responses."

	self optionAt: 'evalScripts' put: aBoolean! !

!SUAjax methodsFor: 'initialization' stamp: 'lr 4/1/2006 18:04'!
initializeWithCanvas: aCanvas
	self args: (Array with: aCanvas context actionUrl urlString).
	self addParameters: aCanvas context actionUrl parameters.
	canvas := aCanvas! !

!SUAjax methodsFor: 'options' stamp: 'lr 3/12/2006 16:22'!
insertAfter
	"Insert content after an element."

	self insert: 'After'! !

!SUAjax methodsFor: 'options' stamp: 'lr 3/12/2006 16:22'!
insertBefore
	"Insert content before an element."

	self insert: 'Before'! !

!SUAjax methodsFor: 'options' stamp: 'lr 3/12/2006 16:22'!
insertBottom
	"Insert content as the last child under an element, right before the element's closing tag."

	self insert: 'Bottom'! !

!SUAjax methodsFor: 'options' stamp: 'lr 3/12/2006 16:22'!
insertTop
	"Insert the content as the first child under an element, right after the opening tag of the element."

	self insert: 'Top'! !

!SUAjax methodsFor: 'options' stamp: 'lr 3/12/2006 16:22'!
insert: aString
	"Option to be used to inject the returned text into an element."

	self optionAt: 'insertion' put: (SUJavascript on: 'Insertion.' , aString)! !

!SUAjax methodsFor: 'events' stamp: 'lr 4/1/2006 11:16'!
onComplete: anObject
	"Called when the XMLHttpRequest is complete (fires after success/failure, if they are present)."

	self optionAt: 'onComplete' put: anObject asFunction! !

!SUAjax methodsFor: 'events' stamp: 'lr 4/1/2006 11:16'!
onFailure: anObject
	"Called when the XMLHttpRequest is completed, and the HTTP status code is not in the 2XX range."

	self optionAt: 'onFailure' put: anObject asFunction! !

!SUAjax methodsFor: 'events' stamp: 'lr 4/1/2006 11:16'!
onInteractive: anObject
	"Called when the user can interact with the remote document, even though it has not finished loading."

	self optionAt: 'onInteractive' put: anObject asFunction! !

!SUAjax methodsFor: 'events' stamp: 'lr 4/1/2006 11:16'!
onLoaded: anObject
	"Called when the browser has finished loading the remote document."

	self optionAt: 'onLoaded' put: anObject asFunction! !

!SUAjax methodsFor: 'events' stamp: 'lr 4/1/2006 11:16'!
onLoading: anObject
	"Called when the remote document is being loaded with data by the browser."

	self optionAt: 'onLoading' put: anObject asFunction! !

!SUAjax methodsFor: 'events' stamp: 'lr 4/1/2006 11:16'!
onSuccess: anObject
	"Called when the XMLHttpRequest is completed, and the HTTP status code is in the 2XX range."

	self optionAt: 'onSuccess' put: anObject asFunction! !

!SUAjax methodsFor: 'callbacks' stamp: 'lr 3/30/2006 20:06'!
on: aSelector of: anObject
	self callback: (MessageSend receiver: anObject selector: aSelector)! !

!SUAjax methodsFor: 'callbacks' stamp: 'lr 4/2/2006 14:26'!
on: aSelector of: anObject value: anotherObject
	self callback: (MessageSend receiver: anObject selector: aSelector) value: anotherObject! !

!SUAjax methodsFor: 'parameters' stamp: 'avi 9/27/2005 23:39'!
parameters
	^ (self options at: 'parameters' ifAbsentPut: (SUJoin join: OrderedCollection new with: '&'))
		collection! !

!SUAjax methodsFor: 'private' stamp: 'lr 4/1/2006 11:45'!
performAjax: aBlock
	| response document inner |
	response := WAResponse new.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document := SUDocument new initialize.
	document stream: response stream.
	canvas context document: document.
	inner := canvas species context: canvas context callbacks: canvas callbacks.
	aBlock value: inner.
	inner flush.
	document close.
	self session returnResponse: response! !

!SUAjax methodsFor: 'triggers' stamp: 'lr 4/7/2006 14:20'!
triggerFormElement: aString
	"Serializing form elements does not always work as one would expect, since Seaside sometimes depends on extra hidden-fields to be triggered to be able to perform your callback-block. When encountering a problem (check-boxes, multi-select lists) try using #triggerForm: instead."

	self addParameter: (SUFormElement new
		id: aString;
		serialize)! !

!SUAjax methodsFor: 'triggers' stamp: 'lr 3/30/2006 22:10'!
triggerForm: aString
	"When triggering a form we don't want seaside related keys in the URL, as they are already present as hidden-fields within the form."

	self parameters copy do: [ :each |
		(each key beginsWith: '_')
			ifTrue: [ self parameters remove: each ] ].
	self addParameter: (SUForm new
		id: aString;
		serialize)! !

!SUAjax methodsFor: 'triggers' stamp: 'lr 4/7/2006 14:10'!
triggerPassenger: aBlock
	self
		callback: [ :value |
			aBlock value: (canvas context callbacks
				at: value ifAbsent: [ nil ]) ]
		value: ((((SUJavascript arguments at: 0) at: 'id')
			match: SUSortable passengerRegexp) at: 1)! !

!SUAjax methodsFor: 'triggers' stamp: 'lr 4/7/2006 14:09'!
triggerSliderCallback: aBlock
	self
		callback: [ :value | aBlock value: value asNumber ]
		value: (SUJavascript arguments at: 0)! !

!SUAjax methodsFor: 'triggers' stamp: 'lr 4/7/2006 00:42'!
triggerSortable: aString callback: aBlock
	self
		callback: [ :value |
			aBlock value: ((value findTokens: $,) collect: [ :each |
				canvas context callbacks at: each ifAbsent: [ nil ] ]) ]
		value: (SUSortable new id: aString; sequence)! !

!SUAjax methodsFor: 'triggers' stamp: 'lr 4/7/2006 11:13'!
triggerTree: aString callback: aBlock
	| mapping relation |
	self
		callback: [ :values |
			mapping := IdentityDictionary new.
			(values findTokens: ',') do: [ :pair |
				relation := (pair findTokens: ':')
					collect: [ :each | canvas context callbacks at: each ifAbsent: [ nil ] ].
				(mapping at: relation first ifAbsentPut: [ relation first -> OrderedCollection new ])
					value add: (mapping at: relation second put: (relation second -> OrderedCollection new)) ].
			aBlock value: (mapping at: nil ifAbsent: [ nil -> OrderedCollection new ]) ]
		value: (SUSortable new id: aString; effect: 'treeSequence')! !

!SUAjax methodsFor: 'private' stamp: 'avi 6/30/2005 13:47'!
type
	^ 'Ajax'! !

SUAjax subclass: #SUAutocompleter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUAutocompleter methodsFor: 'private' stamp: 'lr 3/1/2006 21:22'!
defaultEffect
	^ 'Autocompleter'! !

!SUAutocompleter methodsFor: 'options' stamp: 'lr 3/12/2006 16:21'!
frequency: aNumber
	self optionAt: 'frequency' put: aNumber! !

!SUAutocompleter methodsFor: 'options' stamp: 'lr 3/12/2006 16:21'!
minChars: aNumber
	self optionAt: 'minChars' put: aNumber! !

!SUAutocompleter methodsFor: 'events' stamp: 'lr 4/6/2006 20:34'!
onHide: anObject
	self optionAt: 'onHide' put: anObject asFunction! !

!SUAutocompleter methodsFor: 'events' stamp: 'lr 4/6/2006 20:34'!
onShow: anObject
	self optionAt: 'onShow' put: anObject asFunction! !

!SUAutocompleter methodsFor: 'initialization' stamp: 'lr 3/30/2006 20:31'!
setTarget: aString
	self args: (Array with: aString) , self args! !

!SUAutocompleter methodsFor: 'options' stamp: 'lr 3/12/2006 16:21'!
tokens: anArray
	self optionAt: 'tokens' put: anArray! !

SUAjax subclass: #SUInPlaceEditor
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUInPlaceEditor methodsFor: 'callbacks' stamp: 'lr 4/2/2006 14:22'!
callback: aBlock
	super callback: [ :html | aBlock value: contents value: html ].
	self callback: [ :value | contents := value ] value: (SUJavascript on: 'escape(arguments[1])').
	self optionAt: 'callback' put: (SUJavascript return: (self options removeKey: 'parameters')) asFunction! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 12:39'!
cancelText: aString
	"The text of the link that cancels editing."

	self optionAt: 'cancelText' put: aString! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 13:08'!
cols: aNumber
	"The number of columns the text area should span (works for both single line or multi line)."

	self optionAt: 'cols' put: aNumber! !

!SUInPlaceEditor methodsFor: 'private' stamp: 'lr 4/2/2006 12:37'!
defaultEffect
	^ 'InPlaceEditor'! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 12:40'!
externalControl: aString
	"Id of an element that acts as an external control used to enter edit mode. The external control will be hidden when entering edit mode and shown again when leaving edit mode."

	self optionAt: 'externalControl' put: aString! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 13:23'!
formClass: aString
	"CSS class used for the in place edit form."

	self optionAt: 'formClassName' put: aString! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 13:23'!
formId: aString
	"The id given to the element."

	self optionAt: 'formId' put: aString! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 13:10'!
loadingText: aString
	"If the loadText URL option is specified then this text is displayed while the text is being loaded from the server."

	self optionAt: 'loadingText' put: aString! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 12:38'!
okText: aString
	"The text of the submit button that submits the changed value to the server."

	self optionAt: 'okText' put: aString! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 13:08'!
rows: aNumber
	"The row height of the input field (anything greater than 1 uses a multiline textarea for input)."

	self optionAt: 'rows' put: aNumber! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 13:22'!
savingClass: aString
	"CSS class added to the element while displaying 'Saving' (removed when server responds)."

	self optionAt: 'savingClassName' put: aString! !

!SUInPlaceEditor methodsFor: 'options' stamp: 'lr 4/2/2006 12:39'!
savingText: aString
	"The text shown while the text is sent to the server."

	self optionAt: 'savingText' put: aString! !

SUAjax subclass: #SUPeriodical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUPeriodical methodsFor: 'options' stamp: 'lr 3/12/2006 16:21'!
decay: aNumber
	"Determines the progressive slowdown in a PeriodicalUpdater object refresh rate when the received response is the same as the last one. For example, if you use 2, after one of the refreshes produces the same result as the previous one, the object will wait twice as much time for the next refresh. If it repeats again, the object will wait four times as much, and so on. Leave it undefined or use 1 to avoid the slowdown."

	self optionAt: 'decay' put: aNumber! !

!SUPeriodical methodsFor: 'private' stamp: 'lr 3/1/2006 21:11'!
defaultEffect
	^ 'PeriodicalUpdater'! !

!SUPeriodical methodsFor: 'options' stamp: 'lr 3/12/2006 16:21'!
frequency: aNumber
	"Interval (not frequency) between refreshes, in seconds. This number will be multiplied by the current decay."

	self optionAt: 'frequency' put: aNumber! !

SUAjax subclass: #SURequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SURequest methodsFor: 'private' stamp: 'lr 3/30/2006 18:51'!
defaultEffect
	^ 'Request'! !

!SURequest methodsFor: 'private' stamp: 'lr 3/30/2006 19:58'!
defaultId
	^ nil! !

!SURequest methodsFor: 'private' stamp: 'lr 3/30/2006 18:51'!
performAjax: aBlock
	aBlock value! !

SUPrototype subclass: #SUDraggable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:48'!
constraintHorizontal
	self constraint: #horizontal! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:48'!
constraintVertical
	self constraint: #vertical! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:48'!
constraint: aSymbol
	"If set to #horizontal or #vertical the drag will be constrained to take place only horizontally or vertically."

	self optionAt: 'constraint' put: aSymbol! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:44'!
ghosting: aBoolean
	"Clones the element and drags the clone, leaving the original in place until the clone is dropped."

	self optionAt: 'ghosting' put: aBoolean! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:45'!
handle: aString
	"Sets whether the element should only be draggable by an embedded handle. The value must be an element reference or element id."

	self optionAt: 'handle' put: aString! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:54'!
hoverclass: aString
	"Gives the created Droppables a hoverclass."

	self optionAt: 'hoverclass' put: aString! !

!SUDraggable methodsFor: 'events' stamp: 'lr 4/1/2006 11:17'!
onChange: anObject
	"Called whenever the Draggable is moved by dragging."

	self optionAt: 'change' put: anObject asFunction! !

!SUDraggable methodsFor: 'events' stamp: 'lr 4/7/2006 13:47'!
onEnd: anObject
	self optionAt: 'endeffect' put: anObject asFunction! !

!SUDraggable methodsFor: 'events' stamp: 'lr 4/7/2006 13:47'!
onRevert: anObject
	self optionAt: 'reverteffect' put: anObject asFunction! !

!SUDraggable methodsFor: 'events' stamp: 'lr 4/7/2006 13:47'!
onStart: anObject
	self optionAt: 'starteffect' put: anObject asFunction! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:45'!
revert: aBoolean
	"If set to true, the element returns to its original position when the drags ends."

	self optionAt: 'revert' put: aBoolean! !

!SUDraggable methodsFor: 'options' stamp: 'lr 4/7/2006 13:48'!
scrollSensitivity: anInteger
	self optionAt: 'scrollSensitivity' put: anInteger! !

!SUDraggable methodsFor: 'options' stamp: 'lr 4/7/2006 13:48'!
scrollSpeed: anInteger
	self optionAt: 'scrollSpeed' put: anInteger! !

!SUDraggable methodsFor: 'options' stamp: 'lr 4/7/2006 13:48'!
scroll: aBoolean
	self optionAt: 'scroll' put: aBoolean! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:45'!
snap: aBooleanOrPoint
	"If set to false no snapping occurs. Otherwise takes the forms [x,y]."

	self optionAt: 'snap' put: aBooleanOrPoint! !

!SUDraggable methodsFor: 'private' stamp: 'avi 6/22/2005 16:41'!
type
	^ 'Draggable'! !

!SUDraggable methodsFor: 'options' stamp: 'lr 3/7/2006 13:45'!
zindex: anInteger
	"The css zindex of the draggable item."

	self optionAt: 'zindex' put: anInteger! !

SUPrototype subclass: #SUDroppable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUDroppable methodsFor: 'options' stamp: 'lr 3/12/2006 16:26'!
accept: aStringOrArray
	"Set accept to a string or an array of strings describing CSS classes. The Droppable will only accept Draggables that have one or more of these CSS classes."

	self optionAt: 'accept' put: aStringOrArray! !

!SUDroppable methodsFor: 'options' stamp: 'lr 3/12/2006 16:26'!
containment: aStringOrArray
	"The droppable will only accept the Draggable if the Draggable is contained in the given elements (or element ids). Can be a single element or an array of elements."

	self optionAt: 'containment' put: aStringOrArray! !

!SUDroppable methodsFor: 'private' stamp: 'lr 2/14/2006 13:54'!
defaultEffect
	^ 'add'! !

!SUDroppable methodsFor: 'options' stamp: 'lr 3/12/2006 16:26'!
greedy: aBoolean
	"If true stops processing hovering (don't look for other Droppables that are under the Draggable)."

	self optionAt: 'greedy' put: aBoolean! !

!SUDroppable methodsFor: 'options' stamp: 'lr 3/12/2006 16:26'!
hoverclass: aString
	"If set, the Droppable will have this additional CSS class when an accepted Draggable is hovered over it."

	self optionAt: 'hoverclass' put: aString! !

!SUDroppable methodsFor: 'events' stamp: 'lr 4/1/2006 11:17'!
onDrop: anObject
	"Called whenever a Draggable is released over the Droppable and the Droppable is accepts it."

	self optionAt: 'onDrop' put: anObject asFunction! !

!SUDroppable methodsFor: 'events' stamp: 'lr 4/1/2006 11:17'!
onHover: anObject
	"Called whenever a Draggable is moved over the Droppable and the Droppable is affected (would accept it). The callback gets 2 parameters, the passenger of the draggable and the percentage of overlapping as defined by the overlap option."

	self optionAt: 'onHover' put: anObject asFunction! !

!SUDroppable methodsFor: 'options' stamp: 'lr 3/12/2006 16:26'!
overlapHorizontal
	self overlap: 'horizontal'! !

!SUDroppable methodsFor: 'options' stamp: 'lr 3/12/2006 16:26'!
overlapVertical
	self overlap: 'vertical'! !

!SUDroppable methodsFor: 'options' stamp: 'lr 3/12/2006 16:26'!
overlap: aString
	"If set to 'horizontal' or 'vertical' the droppable will only react to a Draggable if its overlapping by more than 50% in the given direction."

	self optionAt: 'overlap' put: aString! !

!SUDroppable methodsFor: 'private' stamp: 'lr 2/14/2006 13:52'!
shouldCreateInstance
	^ false! !

!SUDroppable methodsFor: 'private' stamp: 'lr 2/14/2006 13:52'!
type
	^ 'Droppables'! !

SUPrototype subclass: #SUEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:21'!
appear
	self effect: 'Appear'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:22'!
blindDown
	self effect: 'BlindDown'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:22'!
blindUp
	self effect: 'BlindUp'! !

!SUEffect methodsFor: 'private' stamp: 'avi 6/22/2005 16:21'!
defaultEffect
	^ 'Fade'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 2/21/2006 22:26'!
dropOut
	self effect: 'DropOut'! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
duration: aNumber
	"Duration of the effect in seconds, given as a float. Defaults to 1.0."

	self optionAt: 'duration' put: aNumber! !

!SUEffect methodsFor: 'options-highlight' stamp: 'lr 3/7/2006 21:57'!
endColor: aColor
	"Sets the color of the last frame of the highlight. This is best set to the background color of the highlighted element."

	self optionAt: 'endcolor' put: aColor! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:21'!
fade
	self effect: 'Fade'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 2/21/2006 22:27'!
fold
	self effect: 'Fold'! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
fps: aNumber
	"Target this many frames per second. Default to 25. Can't be higher than 100."

	self optionAt: 'fps' put: aNumber! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
from: aNumber
	"Sets the starting point of the transition, a float between 0.0 and 1.0. Defaults to 0.0."

	self optionAt: 'from' put: aNumber! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 2/21/2006 22:27'!
grow
	self effect: 'Grow'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 9/21/2005 22:58'!
highlight
	self effect: 'Highlight'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 3/7/2006 22:00'!
highlight: aColor
	self startColor: aColor; effect: 'Highlight'! !

!SUEffect methodsFor: 'effects' stamp: 'lr 3/4/2006 13:09'!
moveBy: aPoint
	self effect: 'MoveBy'; args: (Array with: aPoint x with: aPoint y)! !

!SUEffect methodsFor: 'events' stamp: 'lr 4/1/2006 11:17'!
onAfterFinish: anObject
	"Called after the last redraw of the effect was made."

	self optionAt: 'afterFinish' put: anObject asFunction! !

!SUEffect methodsFor: 'events' stamp: 'lr 4/1/2006 11:18'!
onAfterUpdate: anObject
	"Called on each iteration of the effects rendering loop, after the redraw takes places."

	self optionAt: 'afterUpdate' put: anObject asFunction! !

!SUEffect methodsFor: 'events' stamp: 'lr 4/1/2006 11:18'!
onBeforeStart: anObject
	"Called before the main effects rendering loop is started."

	self optionAt: 'beforeStart' put: anObject asFunction! !

!SUEffect methodsFor: 'events' stamp: 'lr 4/1/2006 11:18'!
onBeforeUpdate: anObject
	"Called on each iteration of the effects rendering loop, before the redraw takes places."

	self optionAt: 'beforeUpdate' put: anObject asFunction! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:18'!
opacity
	self effect: 'Opacity'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:21'!
puff
	self effect: 'Puff'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 2/21/2006 22:26'!
pulsate
	self effect: 'Pulsate'! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
queueEnd
	self queue: 'end'! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
queueFront
	self queue: 'front'! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
queue: aString
	"Sets queuing options. When used with a string, can be 'front' or 'end' to queue the effect in the global effects queue at the beginning or end, or a queue parameter object that can have {position: 'front/end', scope: 'scope', limit:1}. For more info on this, see Effect.Queues."

	self optionAt: 'queue' put: aString! !

!SUEffect methodsFor: 'options-highlight' stamp: 'lr 3/7/2006 21:57'!
restoreColor: aColor
	"Sets the background color of the element after the highlight has finished."

	self optionAt: 'restorecolor' put: aColor! !

!SUEffect methodsFor: 'effects' stamp: 'lr 3/4/2006 13:08'!
scale: aNumber
	self effect: 'Scale'; args: (Array with: aNumber)! !

!SUEffect methodsFor: 'effects' stamp: 'avi 9/24/2005 19:35'!
scrollTo
	self effect: 'ScrollTo'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 2/21/2006 22:26'!
shake
	self effect: 'Shake'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 2/21/2006 22:27'!
shrink
	self effect: 'Shrink'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:22'!
slideDown
	self effect: 'SlideDown'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:22'!
slideUp
	self effect: 'SlideUp'! !

!SUEffect methodsFor: 'effects-combination' stamp: 'lr 2/21/2006 22:27'!
squish
	self effect: 'Squish'! !

!SUEffect methodsFor: 'options-highlight' stamp: 'lr 3/7/2006 21:56'!
startColor: aColor
	"Sets the color of first frame of the highlight the highlight."

	self optionAt: 'startcolor' put: aColor! !

!SUEffect methodsFor: 'effects-combination' stamp: 'avi 6/22/2005 16:21'!
switchOff
	self effect: 'SwitchOff'! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
sync: aBoolean
	"Sets whether the effect should render new frames automatically (which it does by default). If true, you can render frames manually by calling the render() instance method of an effect. This is used by Effect.Parallel()."

	self optionAt: 'sync' put: aBoolean! !

!SUEffect methodsFor: 'effects-toggle' stamp: 'lr 3/12/2006 16:26'!
toggleAppear
	self toggle: 'appear'! !

!SUEffect methodsFor: 'effects-toggle' stamp: 'lr 3/12/2006 16:26'!
toggleBlind
	self toggle: 'blind'! !

!SUEffect methodsFor: 'effects-toggle' stamp: 'lr 3/12/2006 16:26'!
toggleSlide
	self toggle: 'slide'! !

!SUEffect methodsFor: 'effects-toggle' stamp: 'lr 3/12/2006 16:26'!
toggle: aString
	self effect: 'toggle'; args: (Array with: aString)! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
to: aNumber
	"Sets the end point of the transition, a float between 0.0 and 1.0. Defaults to 1.0."

	self optionAt: 'to' put: aNumber! !

!SUEffect methodsFor: 'options' stamp: 'lr 3/12/2006 16:27'!
transition: aString
	"Sets a function that modifies the current point of the animation, which is between 0 and 1. Following transitions are supplied: Effect.Transitions.sinoidal (default), Effect.Transitions.linear, Effect.Transitions.reverse, Effect.Transitions.wobble and Effect.Transitions.flicker."

	self optionAt: 'transition' put: aString! !

!SUEffect methodsFor: 'private' stamp: 'avi 9/21/2005 22:57'!
type
	^ 'Effect'! !

SUPrototype subclass: #SUElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUElement methodsFor: 'modifying' stamp: 'lr 3/31/2006 15:27'!
addClass: aString
	self effect: 'addClassName'; args: (Array with: aString)! !

!SUElement methodsFor: 'querying' stamp: 'lr 3/31/2006 15:26'!
classes
	self effect: 'classNames'! !

!SUElement methodsFor: 'private' stamp: 'avi 9/24/2005 19:31'!
defaultEffect
	^ 'toggle'! !

!SUElement methodsFor: 'testing' stamp: 'lr 3/31/2006 15:28'!
hasClass: aString
	self effect: 'hasClassName'; args: (Array with: aString)! !

!SUElement methodsFor: 'querying' stamp: 'lr 3/31/2006 15:26'!
height
	self effect: 'getHeight'! !

!SUElement methodsFor: 'displaying' stamp: 'lr 3/12/2006 16:27'!
hide
	self effect: 'hide'! !

!SUElement methodsFor: 'testing' stamp: 'lr 3/31/2006 15:22'!
isVisible
	self effect: 'visible'! !

!SUElement methodsFor: 'modifying' stamp: 'lr 3/12/2006 16:27'!
remove
	self effect: 'remove'! !

!SUElement methodsFor: 'modifying' stamp: 'lr 3/31/2006 15:27'!
removeClass: aString
	self effect: 'removeClassName'; args: (Array with: aString)! !

!SUElement methodsFor: 'modifying' stamp: 'lr 3/31/2006 15:24'!
replace: anObject
	self effect: 'replace'; args: (Array with: anObject)! !

!SUElement methodsFor: 'displaying' stamp: 'lr 3/12/2006 16:27'!
scrollTo
	self effect: 'scrollTo'! !

!SUElement methodsFor: 'private' stamp: 'avi 9/24/2005 19:31'!
shouldCreateInstance
	^ false! !

!SUElement methodsFor: 'displaying' stamp: 'lr 3/12/2006 16:28'!
show
	self effect: 'show'! !

!SUElement methodsFor: 'displaying' stamp: 'lr 3/12/2006 16:28'!
toggle
	self effect: 'toggle'! !

!SUElement methodsFor: 'private' stamp: 'avi 9/27/2005 23:54'!
type
	^ 'Element'! !

!SUElement methodsFor: 'modifying' stamp: 'lr 3/31/2006 15:24'!
update: anObject
	self effect: 'update'; args: (Array with: anObject)! !

!SUElement methodsFor: 'querying' stamp: 'lr 3/31/2006 15:32'!
width
	self effect: 'getWidth'! !

SUPrototype subclass: #SUEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUEvent methodsFor: 'private' stamp: 'lr 3/30/2006 16:50'!
defaultEffect
	^ 'element'! !

!SUEvent methodsFor: 'private' stamp: 'lr 3/30/2006 22:25'!
defaultId
	^ SUJavascript on: 'event'! !

!SUEvent methodsFor: 'querying' stamp: 'lr 3/30/2006 16:50'!
element
	self effect: 'element'! !

!SUEvent methodsFor: 'testing' stamp: 'lr 3/30/2006 16:50'!
isLeftClick
	self effect: 'isLeftClick'! !

!SUEvent methodsFor: 'querying' stamp: 'lr 3/30/2006 16:51'!
pointerX
	self effect: 'pointerX'! !

!SUEvent methodsFor: 'querying' stamp: 'lr 3/30/2006 16:51'!
pointerY
	self effect: 'pointerY'! !

!SUEvent methodsFor: 'private' stamp: 'lr 3/30/2006 16:44'!
shouldCreateInstance
	^ false! !

!SUEvent methodsFor: 'actions' stamp: 'lr 3/30/2006 16:50'!
stop
	self effect: 'stop'! !

!SUEvent methodsFor: 'private' stamp: 'lr 3/30/2006 16:44'!
type
	^ 'Event'! !

SUPrototype subclass: #SUForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUForm methodsFor: 'private' stamp: 'lr 3/28/2006 22:06'!
defaultEffect
	^ 'serialize'! !

!SUForm methodsFor: 'actions' stamp: 'lr 3/28/2006 21:43'!
disable
	self effect: 'disable'! !

!SUForm methodsFor: 'actions' stamp: 'lr 3/28/2006 21:43'!
enable
	self effect: 'enable'! !

!SUForm methodsFor: 'actions' stamp: 'lr 3/28/2006 21:43'!
focus
	self effect: 'focusFirstElement'! !

!SUForm methodsFor: 'actions' stamp: 'lr 3/28/2006 21:44'!
reset
	self effect: 'reset'! !

!SUForm methodsFor: 'actions' stamp: 'lr 3/28/2006 22:07'!
serialize
	self effect: 'serialize'! !

!SUForm methodsFor: 'private' stamp: 'lr 3/28/2006 21:41'!
shouldCreateInstance
	^ false! !

!SUForm methodsFor: 'private' stamp: 'lr 3/28/2006 21:41'!
type
	^ 'Form'! !

SUPrototype subclass: #SUFormElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUFormElement methodsFor: 'private' stamp: 'lr 3/28/2006 22:04'!
defaultEffect
	^ 'getValue'! !

!SUFormElement methodsFor: 'actions' stamp: 'lr 3/12/2006 16:28'!
getValue
	self effect: 'getValue'! !

!SUFormElement methodsFor: 'actions' stamp: 'lr 3/12/2006 16:28'!
serialize
	self effect: 'serialize'! !

!SUFormElement methodsFor: 'private' stamp: 'avi 9/27/2005 23:21'!
shouldCreateInstance
	^ false! !

!SUFormElement methodsFor: 'private' stamp: 'avi 9/27/2005 23:54'!
type
	^ 'Form.Element'! !

!SUPrototype methodsFor: 'logical' stamp: 'lr 4/1/2006 11:48'!
after: anObject
	"Called directly after the request is initated."

	after ifNil: [ after := OrderedCollection new ].
	after add: anObject! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 3/7/2006 20:24'!
args
	^ args ifNil: [ self defaultArgs ]! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 3/30/2006 14:42'!
args: aCollection
	args := aCollection! !

!SUPrototype methodsFor: 'private' stamp: 'lr 3/30/2006 22:10'!
arguments
	^ Array streamContents: [ :stream |
		self id isNil
			ifFalse: [ stream nextPut: self id ].
		stream nextPutAll: self args.
		self options isEmpty
			ifFalse: [ stream nextPut: self options ] ]! !

!SUPrototype methodsFor: 'logical' stamp: 'lr 4/1/2006 11:48'!
before: anObject
	"Called directly before the request is initated."

	before ifNil: [ before := OrderedCollection new ].
	before add: anObject! !

!SUPrototype methodsFor: 'logical' stamp: 'lr 4/1/2006 11:48'!
condition: anObject
	"Perform remote request conditionally by anExpression. Use this to describe browser-side conditions when request should not be initiated."

	condition ifNil: [ condition := OrderedCollection new ].
	condition add: anObject! !

!SUPrototype methodsFor: 'logical' stamp: 'lr 4/1/2006 11:50'!
confirm: anObject
	"Adds a confirmation dialog with aString."

	self condition: (SUJavascript on: 'confirm(' , anObject asJavascript , ')')! !

!SUPrototype methodsFor: 'private' stamp: 'avi 6/22/2005 16:16'!
defaultArgs
	^ #()! !

!SUPrototype methodsFor: 'private' stamp: 'avi 6/22/2005 16:38'!
defaultEffect
	^ ''! !

!SUPrototype methodsFor: 'private' stamp: 'lr 3/30/2006 19:51'!
defaultId
	^ SUJavascript on: 'this'! !

!SUPrototype methodsFor: 'private' stamp: 'lr 4/7/2006 00:20'!
defaultOptions
	^ Dictionary new! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 3/7/2006 20:24'!
effect
	^ effect ifNil: [ self defaultEffect ]! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 3/30/2006 14:42'!
effect: aString
	effect := aString! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 3/30/2006 19:52'!
id
	^ id ifNil: [ self defaultId ] ifNotNil: [ id ]! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 3/30/2006 14:42'!
id: aString
	id := aString! !

!SUPrototype methodsFor: 'options' stamp: 'lr 3/7/2006 20:22'!
optionAt: key put: value
	self options at: key put: value! !

!SUPrototype methodsFor: 'options' stamp: 'lr 4/7/2006 00:20'!
options
	^ options ifNil: [ options := self defaultOptions ]! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 4/6/2006 08:13'!
printAfterOn: aStream
	after ifNil: [ ^ self ].
	after do: [ :each | aStream nextPut: $;; nextPutAll: each asJavascript ]! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 4/6/2006 14:56'!
printArgsOn: aStream
	aStream nextPut: $(.
	self arguments
		do: [ :each | aStream nextPutAll: each asJavascript ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 4/6/2006 08:13'!
printBeforeOn: aStream
	before ifNil: [ ^ self ].
	before do: [ :each | aStream nextPutAll: each asJavascript; nextPut: $; ]! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 4/6/2006 08:13'!
printCloseOn: aStream
	condition ifNotNil: [ aStream nextPut: $} ]! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 4/6/2006 08:13'!
printConditionOn: aStream
	condition ifNil: [ ^ self ].
	aStream nextPutAll: 'if('.
	condition size > 1 ifTrue: [ aStream nextPut: $( ].
	condition
		do: [ :each | aStream nextPutAll: each asJavascript ]
		separatedBy: [ aStream nextPutAll: ') && (' ].
	condition size > 1 ifTrue: [ aStream nextPut: $) ].
	aStream nextPutAll: '){'! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 3/7/2006 20:23'!
printEffectOn: aStream
	self effect isEmpty ifFalse: [ aStream nextPut: $.; nextPutAll: self effect ]! !

!SUPrototype methodsFor: 'printing' stamp: 'lr 4/6/2006 14:56'!
printOn: aStream
	self
		printConditionOn: aStream;
		printBeforeOn: aStream;
		printTypeOn: aStream;
		printEffectOn: aStream;
		printArgsOn: aStream;
		printAfterOn: aStream;
		printCloseOn: aStream! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 3/30/2006 22:10'!
printTypeOn: aStream
	self shouldCreateInstance
		ifTrue: [ aStream nextPutAll: 'new ' ].
	aStream nextPutAll: self type! !

!SUPrototype methodsFor: 'conveniance' stamp: 'lr 3/30/2006 14:42'!
returnFalse
	self after: (SUJavascript on: 'return false')! !

!SUPrototype methodsFor: 'private' stamp: 'lr 3/7/2006 17:34'!
session
	^ WACurrentSession value! !

!SUPrototype methodsFor: 'private' stamp: 'avi 9/24/2005 19:30'!
shouldCreateInstance
	^ true! !

!SUPrototype methodsFor: 'conveniance' stamp: 'lr 3/30/2006 16:52'!
stopPropagation
	self after: SUEvent new stop! !

!SUPrototype methodsFor: 'private' stamp: 'avi 6/22/2005 15:53'!
type
	^ self subclassResponsibility! !

SUPrototype subclass: #SUSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUSelector methodsFor: 'options' stamp: 'lr 4/6/2006 15:09'!
all
	self append: '*'! !

!SUSelector methodsFor: 'actions' stamp: 'lr 4/6/2006 15:19'!
and
	self arguments add: ''! !

!SUSelector methodsFor: 'actions' stamp: 'lr 4/6/2006 15:12'!
append: aString
	self append: aString separator: ''! !

!SUSelector methodsFor: 'actions' stamp: 'lr 4/6/2006 15:28'!
append: aString separator: separatorString
	self arguments 
		at: self arguments size
		put: (self arguments last isEmpty
			ifTrue: [ aString ]
			ifFalse: [ self arguments last , separatorString , aString ])! !

!SUSelector methodsFor: 'private' stamp: 'lr 4/6/2006 15:18'!
arguments
	^ args ifNil: [ args := self defaultArgs ]! !

!SUSelector methodsFor: 'options' stamp: 'lr 4/6/2006 15:28'!
class: aString
	self append: '.' , aString separator: ' '! !

!SUSelector methodsFor: 'options' stamp: 'lr 4/6/2006 15:17'!
condition: aString
	self append: '[' , aString , ']'! !

!SUSelector methodsFor: 'private' stamp: 'lr 4/6/2006 15:18'!
defaultArgs
	^ OrderedCollection with: ''! !

!SUSelector methodsFor: 'options' stamp: 'lr 4/6/2006 15:29'!
id: aString
	self append: '#' , aString separator: ' '! !

!SUSelector methodsFor: 'private' stamp: 'lr 4/6/2006 14:57'!
shouldCreateInstance
	^ false! !

!SUSelector methodsFor: 'options' stamp: 'lr 4/6/2006 15:24'!
tag: aString
	self append: aString separator: ' '! !

!SUSelector methodsFor: 'options' stamp: 'lr 4/6/2006 15:29'!
tag: aString class: classString
	self 
		append: aString separator: ' '; 
		append: classString separator: '.'! !

!SUSelector methodsFor: 'options' stamp: 'lr 4/6/2006 15:24'!
tag: aString id: idString
	self
		append: aString separator: ' ';
		append: idString separator: '#'! !

!SUSelector methodsFor: 'private' stamp: 'lr 4/6/2006 14:58'!
type
	^ '$$'! !

SUPrototype subclass: #SUSlider
	instanceVariableNames: 'handleId trackId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:16'!
alignX: anNumber
	"This will move the starting point on the x-axis for the handle in relation to the track. It is often used to move the 'point' of the handle to where 0 should be. It can also be used to set a different starting point on the track."

	self optionAt: 'alignX' put: anNumber! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:17'!
alignY: anNumber
	"This will move the starting point on the y-axis for the handle in relation to the track. It is often used to move the 'point' of the handle to where 0 should be. It can also be used to set a different starting point on the track."

	self optionAt: 'alignY' put: anNumber! !

!SUSlider methodsFor: 'private' stamp: 'lr 3/30/2006 20:19'!
arguments
	^ Array with: self handleId with: self trackId with: self options! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:13'!
axis: aSymbol
	"Sets the direction that the slider will move in. It should either be horizontal or vertical."

	self optionAt: 'axis' put: aSymbol! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:17'!
disabled: aBoolean
	"This will lock the slider so that it will not move and thus is disabled."

	self optionAt: 'disabled' put: aBoolean! !

!SUSlider methodsFor: 'accessing' stamp: 'lr 3/30/2006 20:18'!
handleId
	^ handleId! !

!SUSlider methodsFor: 'accessing' stamp: 'lr 3/30/2006 20:18'!
handleId: aString
	^ handleId := aString! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:14'!
increment: aNumber
	"Defines the relationship of value to pixels. Setting this to 1 will mean each movement of 1 pixel equates to 1 value."

	self optionAt: 'increment' put: aNumber! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:14'!
maximum: aNumber
	"The maximum value that the slider will move to. For horizontal this is to the right while vertical it is down."

	self optionAt: 'maximum' put: aNumber! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:14'!
minimum: aNumber
	"The minimum value that the slider can move to. For horizontal this is to the left while vertical it is up."

	self optionAt: 'minimum' put: aNumber! !

!SUSlider methodsFor: 'events' stamp: 'lr 4/1/2006 11:19'!
onChange: anObject
	"Called whenever the Slider has finished moving or has had its value changed. The called function gets the slider value as its parameter."

	self optionAt: 'onChange' put: anObject asFunction! !

!SUSlider methodsFor: 'events' stamp: 'lr 4/1/2006 11:19'!
onSlide: anObject
	"Called whenever the Slider is moved by dragging. The called function gets the slider value as its parameter."

	self optionAt: 'onSlide' put: anObject asFunction! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:15'!
range: anInterval
	self optionAt: 'range' put: anInterval! !

!SUSlider methodsFor: 'accessing' stamp: 'lr 3/30/2006 20:16'!
trackId
	^ trackId! !

!SUSlider methodsFor: 'accessing' stamp: 'lr 3/30/2006 20:16'!
trackId: aString
	trackId := aString! !

!SUSlider methodsFor: 'private' stamp: 'lr 3/13/2006 20:12'!
type
	^ 'Control.Slider'! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/13/2006 20:18'!
values: anArray
	"Accepts an array of integers. If set these will be the only legal values for the slider to be at. Thus you can set specific slider values that the user can move the slider to."

	self optionAt: 'values' put: anArray! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/20/2006 19:39'!
value: aNumber
	"Will set the initial slider value. The handle will be set to this value, assuming it is within the minimum and maxium values."

	self optionAt: 'sliderValue' put: aNumber! !

SUPrototype subclass: #SUSortable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUSortable class methodsFor: 'private' stamp: 'lr 4/7/2006 13:56'!
passengerPrefix
	^ 'pid'! !

!SUSortable class methodsFor: 'private' stamp: 'lr 4/7/2006 13:57'!
passengerRegexp
	^ SUJavascript on: '/^' , self passengerPrefix , '([0-9]+)$/'! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/1/2006 11:53'!
constraintHorizontal
	self constraint: #horizontal! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/1/2006 11:53'!
constraintVertical
	self constraint: #vertical! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/1/2006 11:53'!
constraint: aString
	"If set to #horizontal or #vertical the drag will be constrained to take place only horizontally or vertically."

	self optionAt: 'constraint' put: aString! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 13:54'!
containment: aStringOrArray
	"Enables dragging and dropping between Sortables. Takes an array of elements or element-ids (of the containers)."

	self optionAt: 'containment' put: aStringOrArray! !

!SUSortable methodsFor: 'actions' stamp: 'lr 3/31/2006 15:44'!
create
	self effect: 'create'! !

!SUSortable methodsFor: 'private' stamp: 'lr 2/22/2006 07:32'!
defaultEffect
	^ 'create'! !

!SUSortable methodsFor: 'private' stamp: 'lr 4/7/2006 13:57'!
defaultOptions
	^ super defaultOptions
		at: 'format' put: self class passengerRegexp;
		yourself! !

!SUSortable methodsFor: 'actions' stamp: 'lr 3/31/2006 15:43'!
destroy
	self effect: 'destroy'! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 13:55'!
dropOnEmpty: aBoolean
	"If set to true, the Sortable container will be made into a Droppable, that can receive a Draggable (as according to the containment rules) as a child element when there are no more elements inside."

	self optionAt: 'dropOnEmpty' put: aBoolean! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 13:55'!
ghosting: aBoolean
	"If set to true, dragged elements of the Sortable will e cloned and appear as 'ghost', i.e. a representation of their original element, instead of directly dragging the original element."

	self optionAt: 'ghosting' put: aBoolean! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 16:50'!
handle: aString
	"Further restricts the selection of child elements to only encompass elements with the given CSS class (or, if you provide an array of strings, on any of the classes)."

	self optionAt: 'handle' put: aString! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 13:54'!
hoverclass: aString
	"Gives the created Droppables a hoverclass."

	self optionAt: 'hoverclass' put: aString! !

!SUSortable methodsFor: 'events' stamp: 'lr 4/1/2006 11:19'!
onChange: anObject
	"Called whenever the sort order changes while dragging. When dragging from one Sortable to another, the callback is called once on each Sortable."

	self optionAt: 'onChange' put: anObject asFunction! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 13:44'!
only: aString
	"Further restricts the selection of child elements to only encompass elements with the given CSS class (or, if you provide an array of strings, on any of the classes)."

	self optionAt: 'only' put: aString! !

!SUSortable methodsFor: 'events' stamp: 'lr 4/1/2006 11:19'!
onUpdate: anObject
	"Called when the drag ends and the Sortable's order is changed in any way. When dragging from one Sortable to another, the callback is called once on each Sortable."

	self optionAt: 'onUpdate' put: anObject asFunction! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/1/2006 11:53'!
overlapHorizontal
	self overlap: #horizontal! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/8/2006 09:39'!
overlapVertical
	self overlap: #vertical! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 13:48'!
overlap: aSymbol
	"Either #vertical or #horizontal. For floating sortables or horizontal lists, choose #horizontal. Vertical lists should use #vertical."

	self optionAt: 'overlap' put: aSymbol! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/6/2006 23:38'!
scrollSensitivity: aNumber
	self optionAt: 'scrollSensitivity' put: aNumber! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/6/2006 23:38'!
scrollSpeed: aNumber
	self optionAt: 'scrollSpeed' put: aNumber! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/6/2006 23:37'!
scroll: aBoolean
	self optionAt: 'scroll' put: aBoolean! !

!SUSortable methodsFor: 'actions' stamp: 'lr 3/31/2006 15:43'!
sequence
	self effect: 'sequence'! !

!SUSortable methodsFor: 'actions' stamp: 'lr 3/31/2006 15:43'!
serialize
	self effect: 'serialize'! !

!SUSortable methodsFor: 'private' stamp: 'lr 2/22/2006 07:02'!
shouldCreateInstance
	^ false! !

!SUSortable methodsFor: 'options' stamp: 'lr 3/7/2006 13:44'!
tag: aString
	"Sets the kind of tag (of the child elements of the container) that will be made sortable. For UL and OL containers, this is 'LI', you have to provide the tag kind for other sorts of child tags."

	self optionAt: 'tag' put: aString! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/6/2006 23:37'!
treeTag: aString
	self optionAt: 'treeTag' put: aString! !

!SUSortable methodsFor: 'options' stamp: 'lr 4/6/2006 23:37'!
tree: aBoolean
	self optionAt: 'tree' put: aBoolean! !

!SUSortable methodsFor: 'private' stamp: 'lr 2/22/2006 07:31'!
type
	^ 'Sortable'! !

!Color methodsFor: '*scriptaculous' stamp: 'lr 3/30/2006 22:10'!
asJavascript
	^ String streamContents: [ :stream |
		stream nextPut: $'; nextPut: $#.
		stream nextPutAll: (((self red * 255) asInteger printStringBase: 16)
			padded: #left to: 2 with: $0).
		stream nextPutAll: (((self green * 255) asInteger printStringBase: 16)
			padded: #left to: 2 with: $0).
		stream nextPutAll: (((self blue * 255) asInteger printStringBase: 16)
			padded: #left to: 2 with: $0).
		stream nextPut: $' ]! !

WAHtmlStreamDocument subclass: #SUDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUDocument methodsFor: 'actions' stamp: 'lr 4/6/2006 14:10'!
close
	| session attributes |
	session := WACurrentSession value.
	(session isNil or: [ session onLoadScripts isEmpty ])
		ifTrue: [ ^ self ].
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	self openTag: 'script' attributes: attributes.
	session onLoadScripts
		do: [ :each | self text: each ]
		separatedBy: [ self text: ';' ].
	self closeTag: 'script'.
	session clearLoadScripts! !

!SUDocument methodsFor: 'initialization' stamp: 'lr 4/1/2006 11:43'!
initialize
	state := #body! !

TestCase subclass: #SUJavascriptTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 18:43'!
testArray
	self assert: #(1 2 3) asJavascript = '[1,2,3]'! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 22:05'!
testAssociation
	self assert: ('a' -> 'b') asJavascript = '''a=b'''.
	self assert: ('a' -> 1) asJavascript = '''a=''+1'.
	self assert: ('a' -> nil) asJavascript = '''a'''! !

!SUJavascriptTest methodsFor: 'testing-messages' stamp: 'lr 4/6/2006 21:37'!
testAtPut
	self assert: ((SUJavascript on: 'a') at: 'b') asJavascript
		= 'a[''b'']'.
	self assert: ((SUJavascript on: 'a') at: 'b' put: 'c') asJavascript
		= 'a[''b'']=''c'''! !

!SUJavascriptTest methodsFor: 'testing-messages' stamp: 'lr 4/6/2006 22:01'!
testBinary
	self assert: ((SUJavascript on: '1') + 2) asJavascript
		= '1+2'.
	self assert: ((SUJavascript on: '1') + 2 - 3) asJavascript 
		= '1+2-3'! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 18:40'!
testBlockContext
	self assert: [ :a | 0 ] asJavascript = 'function(){return 0}'.

	self assert: [ :a :b | a ] asJavascript = 'function(){return arguments[0]}'.
	self assert: [ :a :b | b ] asJavascript = 'function(){return arguments[1]}'.

	self assert: [ :a :b :c | a + b ] asJavascript = 'function(){return arguments[0]+arguments[1]}'.
	self assert: [ :a :b :c | b + c ] asJavascript = 'function(){return arguments[1]+arguments[2]}'.
	self assert: [ :a :b :c | c + a ] asJavascript = 'function(){return arguments[2]+arguments[0]}'.! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 22:05'!
testColor
	self assert: Color red asJavascript = '''#FF0000'''! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 18:44'!
testDictionary
	self assert: (Dictionary new at: 1 put: 2; at: 3 put: 4; yourself) asJavascript
		= '{1:2,3:4}'! !

!SUJavascriptTest methodsFor: 'testing-messages' stamp: 'lr 4/6/2006 21:35'!
testEqualitiy
	self assert: ((SUJavascript on: 'element') = 1) asJavascript
		= 'element==1'.
	self assert: ((SUJavascript on: 'element') ~= 1) asJavascript
		= 'element!!=1'! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 19:07'!
testInterval
	self assert: (1 to: 2) asJavascript = '$R(1,2)'! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 19:54'!
testJoin
	self assert: (SUJoin join: #( 'a' 'b' ) with: '&') asJavascript 
		= '[''a'',''b''].join(''&'')'! !

!SUJavascriptTest methodsFor: 'testing-messages' stamp: 'lr 4/6/2006 21:58'!
testKeyword
	self assert: ((SUJavascript on: 'a') with: 1) asJavascript
		= 'a.with(1)'.
	self assert: ((SUJavascript on: 'a') with: 1 with: 2) asJavascript
		= 'a.with(1,2)'.
	self assert: ((SUJavascript on: 'a') with: 1 with: 2 with: 3) asJavascript
		= 'a.with(1,2,3)'.

	self assert: ((SUJavascript on: 'a') select: [ :a | a id = 'foo' ]) asJavascript
		= 'a.select(function(){return arguments[0].id()==''foo''})'.
	self assert: ((SUJavascript on: 'a') inject: 0 into: [ :a :b | a + b ]) asJavascript
		= 'a.inject(0,function(){return arguments[0]+arguments[1]})'
	! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 18:42'!
testLiteral
	self assert: true asJavascript = 'true'.
	self assert: false asJavascript = 'false'.
	self assert: nil asJavascript = 'null'! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 18:42'!
testPoint
	self assert: (1 @ 2) asJavascript = '[1,2]'! !

!SUJavascriptTest methodsFor: 'testing-convertion' stamp: 'lr 4/6/2006 22:05'!
testString
	self assert: 'abc' asJavascript = '''abc'''.
	self assert: '123' asJavascript = '''123'''.
	self assert: '''' asJavascript = '''\'''''.
	self assert: '"' asJavascript = '''\"'''.
	self assert: '\' asJavascript = '''\\'''! !

!SUJavascriptTest methodsFor: 'testing-messages' stamp: 'lr 4/6/2006 23:15'!
testUnary
	self assert: (SUJavascript on: 'a') id asJavascript
		= 'a.id()'.
	self assert: (SUJavascript on: 'a') serialize asJavascript
		= 'a.serialize()'! !

TestCase subclass: #SUSelectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:01'!
testAll
	self assert: (SUSelector new all) asJavascript = '$$(''*'')'! !

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:06'!
testAnd
	self assert: (SUSelector new all; and; id: 'foo'; class: 'bar') asJavascript = '$$(''*'',''#foo .bar'')'.	
	self assert: (SUSelector new id: 'foo'; and; id: 'bar') asJavascript = '$$(''#foo'',''#bar'')'! !

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:01'!
testClass
	self assert: (SUSelector new class: 'class1') asJavascript = '$$(''.class1'')'.
	self assert: (SUSelector new class: 'class1'; class: 'class2') asJavascript = '$$(''.class1 .class2'')'! !

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:03'!
testCondition
	self assert: (SUSelector new all; condition: 'id') asJavascript = '$$(''*[id]'')'.
	self assert: (SUSelector new tag: 'input'; condition: 'type=submit') asJavascript = '$$(''input[type=submit]'')'! !

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:05'!
testId
	self assert: (SUSelector new id: 'foo') asJavascript = '$$(''#foo'')'.
	self assert: (SUSelector new id: 'foo'; id: 'bar') asJavascript = '$$(''#foo #bar'')'! !

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:04'!
testTag
	self assert: (SUSelector new tag: 'div') asJavascript = '$$(''div'')'.
	self assert: (SUSelector new tag: 'div'; tag: 'span') asJavascript = '$$(''div span'')'! !

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:04'!
testTagClass
	self assert: (SUSelector new tag: 'div' class: 'foo') asJavascript = '$$(''div.foo'')'.
	self assert: (SUSelector new tag: 'div' class: 'foo'; tag: 'span' class: 'bar') asJavascript = '$$(''div.foo span.bar'')'! !

!SUSelectorTest methodsFor: 'testing' stamp: 'lr 4/6/2006 23:05'!
testTagId
	self assert: (SUSelector new tag: 'div' id: 'foo') asJavascript = '$$(''div#foo'')'.
	self assert: (SUSelector new tag: 'div' id: 'foo'; tag: 'span' id: 'bar') asJavascript = '$$(''div#foo span#bar'')'! !

!WARenderingContext methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 20:55'!
callbacks
	^ callbacks! !

!WARenderingContext methodsFor: '*scriptaculous' stamp: 'lr 4/7/2006 13:40'!
storePassenger: anObject
	| key |
	callbacks at: (key := self advanceKey) put: anObject.
	^ key! !

!WAIframeTag methodsFor: '*scriptaculous' stamp: 'lr 3/10/2006 12:18'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock)! !

!UndefinedObject methodsFor: '*scriptaculous' stamp: 'lr 4/2/2006 14:25'!
asJavascript
	^ 'null'! !

!Dictionary methodsFor: '*scriptaculous' stamp: 'lr 4/6/2006 08:10'!
asJavascript
	^ String streamContents: [ :stream |
		stream nextPut: ${.
		self associations do: [ :assoc |
			stream
				nextPutAll: assoc key asJavascript;
				nextPut: $:;
				nextPutAll: assoc value asJavascript ]
			separatedBy: [ stream nextPut: $, ].
		stream nextPut: $} ]! !

!Point methodsFor: '*scriptaculous' stamp: 'lr 4/6/2006 08:11'!
asJavascript
	^ String streamContents: [ :stream |
		stream
			nextPut: $[;
			nextPutAll: self x asJavascript;
			nextPut: $,;
			nextPutAll: self y asJavascript;
			nextPut: $] ]! !

!BlockContext methodsFor: '*scriptaculous' stamp: 'lr 4/6/2006 18:35'!
asJavascript
	^ String streamContents: [ :stream |
		stream
			nextPutAll: 'function(){return ';
			nextPutAll: (self valueWithArguments: ((0 to: self numArgs - 1)
				collect: [ :each | SUJavascript on: 'arguments[' , each printString , ']' ]))
					asJavascript;
			nextPut: $} ]! !

PackageInfo subclass: #ScriptaculousVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Platform'!

!ScriptaculousVWInfo class methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:43'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'ScriptaculousVW5.st')! !

!ScriptaculousVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:40'!
externalName
	^ 'Scriptaculous'! !

!ScriptaculousVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:40'!
ignoredCategories
	^ #('Platform')! !

!ScriptaculousVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:41'!
includesSystemCategory: aString
	^ (aString beginsWith: 'Scriptaculous-') and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!ScriptaculousVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:42'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*scriptaculous')
		and: [(aString endsWith: 'squeak') not]! !

!ScriptaculousVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:45'!
namespace
	^ 'Seaside'! !

!ScriptaculousVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:42'!
needsNamespace
	^false! !

!ScriptaculousVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 13:42'!
packageName
	^ 'ScriptaculousVW'! !

WAComponent subclass: #SUComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

SUComponent subclass: #SUAllTests
	instanceVariableNames: 'tabs selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUAllTests class methodsFor: 'initialization' stamp: 'lr 3/30/2006 22:10'!
initialize
	(self registerAsApplication: 'scriptaculous')
		libraries add: SUScriptLibrary! !

!SUAllTests methodsFor: 'accessing' stamp: 'lr 3/12/2006 15:29'!
children
	^ selected collect: [ :each | each value ]! !

!SUAllTests methodsFor: 'initialization' stamp: 'lr 4/6/2006 23:39'!
initialize
	super initialize.
	tabs := OrderedCollection new
		add: 'Welcome' -> (Array
			with: 'Welcome' -> SUWelcomeTest new
			with: 'Counter' -> SUCounterTest new);
		add: 'Ajax' -> (Array
			with: 'Periodical' -> SUPeriodicalTest new
			with: 'Insertion' -> SUInsertTest new);
		add: 'Form' -> (Array
			with: 'Elements' -> SUFormTest new);
		add: 'Controls' -> (Array
			with: 'Autocompleter' -> SUAutocompleterTest new
			with: 'In Place Editor' -> SUInPlaceEditorTest new
			with: 'Slider' -> SUSliderTest new);
		add: 'Drag & Drop' -> (Array
			with: 'Drag & Drop' -> SUDragDropTest new
			with: 'Sortable' -> SUSortableTest new
			with: 'Tree' -> SUTreeTest new);
		add: 'Effects' -> (Array
			with: 'Effects' -> SUEffectsTest new
			with: 'Toggles' -> SUTogglesTest new);
		add: 'Misc' -> (Array
			with: 'Encoding' -> SUEncodingTest new);
		yourself.
	selected := tabs first value! !

!SUAllTests methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderChildrenOn: html
	html div id: 'content'; with: [
		selected do: [ :each |
			html heading: each key.
			html paragraph; render: each value.
			each value showSource ifTrue: [
				html paragraph: [
					html popupAnchor
						beResizable;
						name: 'browser';
						extent: 640 @ 480;
						callback: [ WARenderLoop new call: (SUClassBrowser new setClass: each value class) ];
						with: 'View Source' ] ].
			html paragraph ] ]! !

!SUAllTests methodsFor: 'rendering' stamp: 'lr 3/12/2006 16:03'!
renderContentOn: html
	self renderHeaderOn: html.
	self renderMenuOn: html.
	self renderChildrenOn: html! !

!SUAllTests methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderHeaderOn: html
	html div id: 'header'; with: [
		html image
			id: 'logo';
			url: (self resources addToPath: 'logo.gif');
			altText: self title ]! !

!SUAllTests methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderMenuOn: html
	html unorderedList id: 'menu'; with: [
		tabs do: [ :each |
			html listItem: [
				html anchor
					class: (selected = each value
						ifTrue: [ 'active' ]);
					callback: [ selected := each value ];
					with: each key ] ] ]! !

!SUAllTests methodsFor: 'accessing' stamp: 'lr 3/13/2006 20:59'!
title
	^ 'Seaside - script.aculo.us'! !

!SUAllTests methodsFor: 'updating' stamp: 'lr 3/30/2006 22:10'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot
		title: self title;
		linkToStyle: (self resources addToPath: 'style.css')! !

SUComponent subclass: #SUClassBrowser
	instanceVariableNames: 'class category selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUClassBrowser methodsFor: 'accessing' stamp: 'lr 3/12/2006 14:12'!
categories
	^ class organization categories asSortedCollection! !

!SUClassBrowser methodsFor: 'rendering' stamp: 'lr 4/1/2006 11:10'!
renderCategoriesOn: html
	html select
		size: 5;
		id: 'categoryList';
		selected: category;
		list: self categories;
		callback: [ :value | self setCategory: value ];
		onChange: (html ajax
			id: 'selectors';
			evalScripts: true;
			on: #renderSelectorsOn: of: self;
			triggerFormElement: 'categoryList';
			onSuccess: (html ajax
				id: 'source';
				on: #renderSourceOn: of: self))! !

!SUClassBrowser methodsFor: 'rendering' stamp: 'lr 3/12/2006 15:05'!
renderContentOn: html
	html div id: 'content'; with: [
		html div id: 'categories'; with: [ self renderCategoriesOn: html ].
		html div id: 'selectors'; with: [ self renderSelectorsOn: html ].
		html div id: 'source'; with: [ self renderSourceOn: html ] ]! !

!SUClassBrowser methodsFor: 'rendering' stamp: 'lr 4/1/2006 10:43'!
renderSelectorsOn: html
	html select
		size: 5;
		id: 'selectorList';
		selected: selector;
		list: self selectors;
		callback: [ :value | self setSelector: value ];
		onChange: (html ajax
			id: 'source';
			on: #renderSourceOn: of: self;
			triggerFormElement: 'selectorList')! !

!SUClassBrowser methodsFor: 'rendering' stamp: 'lr 4/1/2006 18:08'!
renderSourceOn: html
	| source |
	source := (class sourceCodeAt: selector ifAbsent: [ ^ self ])
		asString readStream.
	html div class: 'source'; with: [
		html strong: class name , '>>' , source nextLine; break.
		[ source atEnd ] whileFalse: [
			[ source peek = Character tab ]
				whileTrue: [ html space; space; space. source next ].
			html render: source nextLine; break ] ]! !

!SUClassBrowser methodsFor: 'accessing' stamp: 'lr 3/12/2006 14:12'!
selectors
	^ (category isNil
		ifTrue: [ class selectors ]
		ifFalse: [ class organization listAtCategoryNamed: category ])
			asSortedCollection! !

!SUClassBrowser methodsFor: 'initialization' stamp: 'lr 3/12/2006 14:20'!
setCategory: aSymbol
	category := aSymbol.
	self setSelector: (self selectors isEmpty
		ifFalse: [ self selectors first ])! !

!SUClassBrowser methodsFor: 'initialization' stamp: 'lr 3/13/2006 22:15'!
setClass: aClass
	class := aClass.
	self setCategory: #rendering.
	self setSelector: #renderContentOn:! !

!SUClassBrowser methodsFor: 'initialization' stamp: 'lr 3/12/2006 14:07'!
setSelector: aSymbol
	selector := aSymbol! !

!SUClassBrowser methodsFor: 'rendering' stamp: 'lr 3/13/2006 23:15'!
style
	^ 'body {
	background: url(http://scriptaculous.seasidehosting.st/resources/demo.gif) repeat white;
}
select {
	width: 100%;
}
#categories, #selectors {
	float: left;
	margin: 5px;
	width: 200px;
}
#source {
	clear: both;
	margin: 5px;
	padding: 5px;
	border: 1px solid #ddd;
	background: #f5f5f5;
	font: 12px Lucida Sans Typewriter, Courier, monospace;
}'! !

!SUClassBrowser methodsFor: 'updating' stamp: 'lr 3/12/2006 14:59'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot title: class name! !

!SUComponent methodsFor: 'accessing' stamp: 'lr 3/30/2006 22:10'!
rendererClass
	^ WARenderCanvas! !

!SUComponent methodsFor: 'accessing-url' stamp: 'lr 3/13/2006 20:59'!
resources
	^ WAUrl new hostname: 'scriptaculous.seasidehosting.st'; addToPath: 'resources'! !

!SUComponent methodsFor: 'accessing-url' stamp: 'lr 3/12/2006 13:04'!
scriptaculous
	^ WAUrl new hostname: 'script.aculo.us'! !

!SUComponent methodsFor: 'accessing-url' stamp: 'lr 3/12/2006 13:04'!
seaside
	^ WAUrl new hostname: 'seaside.st'! !

SUComponent subclass: #SUFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

SUFunctionalTest subclass: #SUAutocompleterTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUAutocompleterTest methodsFor: 'rendering' stamp: 'lr 4/6/2006 22:43'!
renderContentOn: html
	html paragraph: 'Start to type a Smalltalk class-name:'.
	html paragraph: [
		html textInput
			id: 'text';
			value: text;
			callback: [ :value | text := value ];
			script: ((html autocomplete: 'name')
				onHide: (html request 
					triggerFormElement: 'text';
					after: (html effect id: 'name'; fade));
				on: #renderListOn: of: self).
		html div
			id: 'name';
			class: 'autocomplete' ]! !

!SUAutocompleterTest methodsFor: 'rendering' stamp: 'lr 4/3/2006 11:24'!
renderListOn: html
	| items |
	items := Smalltalk allClasses select: [ :each | each name includesSubString: text ].
	html unorderedList list: (items first: (items size min: 10))! !

!SUAutocompleterTest methodsFor: 'rendering' stamp: 'lr 3/13/2006 23:24'!
style
	^ 'div.autocomplete {
	position: absolute;
	background-color: white;
	border: 1px solid #888;
	margin: 0px;
	padding: 0px;
	z-index: 1000;
}
div.autocomplete ul, div.autocomplete ul li {
	list-style-type: none;
	line-height: 1.7;
	margin: 0px;
	padding: 0px;
}
div.autocomplete ul li.selected {
	background-color: #ffb;
}'! !

SUFunctionalTest subclass: #SUCounterTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUCounterTest methodsFor: 'actions' stamp: 'lr 3/12/2006 13:23'!
decrease
	count := count - 1! !

!SUCounterTest methodsFor: 'actions' stamp: 'lr 3/12/2006 13:23'!
increase
	count := count + 1! !

!SUCounterTest methodsFor: 'initialization' stamp: 'lr 3/12/2006 13:23'!
initialize
	super initialize.
	count := 0! !

!SUCounterTest methodsFor: 'rendering' stamp: 'lr 3/17/2006 13:27'!
renderContentOn: html
	html paragraph: [
		html span
			id: 'count';
			with: count.
		html space.
		html anchor
			onClick: (html ajax
				id: 'count';
				callback: [ :render | self increase; renderCountOn: render ]);
			with: '++'.
		html space.
		html anchor
			onClick: (html ajax
				id: 'count';
				callback: [ :render | self decrease; renderCountOn: render ]);
			with: '--' ]! !

!SUCounterTest methodsFor: 'rendering' stamp: 'lr 3/12/2006 13:26'!
renderCountOn: html
	html render: count! !

SUFunctionalTest subclass: #SUDragDropTest
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUDragDropTest methodsFor: 'accessing' stamp: 'lr 3/7/2006 16:52'!
cart
	^ cart ifNil: [ cart := WAStoreCart new ]! !

!SUDragDropTest methodsFor: 'accessing' stamp: 'lr 3/7/2006 16:52'!
inventory
	^ WAStoreInventory default! !

!SUDragDropTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderCartItemsOn: html
	self cart hasItems
		ifFalse: [ ^ html text: 'Drop items here to add them to your cart.' ].
	self cart countsAndItems do: [ :assoc |
		html div
			class: 'cart-item';
			passenger: assoc value;
			script: (html draggable revert: true);
			with: [
				html render: assoc value.
				assoc key > 1
					ifTrue: [ html text: ' ('; render: assoc key; text: ')' ] ] ]! !

!SUDragDropTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 21:39'!
renderCartOn: html
	html div
		id: 'cart';
		script: (html droppable
			accept: 'inventory-item';
			hoverclass: 'hover';
			onDrop: (html ajax
				id: 'cart';
				evalScripts: true;
				triggerPassenger: [ :value | self cart add: value ];
				callback: [ :renderer | self renderCartItemsOn: renderer ]));
		with: [ self renderCartItemsOn: html ]! !

!SUDragDropTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderContentOn: html
	self
		renderInventoryOn: html;
		renderCartOn: html;
		renderTrashOn: html! !

!SUDragDropTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderInventoryOn: html
	html div id: 'inventory'; with: [
		self inventory allItems
			do: [ :each |
				html span
					passenger: each;
					class: 'inventory-item';
					script: (html draggable revert: true);
					with: each ]
			separatedBy: [ html text: ', ' ] ]! !

!SUDragDropTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderTrashOn: html
	html div
		id: 'trash';
		script: (html droppable
			accept: 'cart-item';
			hoverclass: 'hover';
			onDrop: (html ajax
				id: 'cart';
				evalScripts: true;
				triggerPassenger: [ :value | self cart remove: value ];
				callback: [ :renderer | self renderCartItemsOn: renderer ];
				onSuccess: (html effect id: 'cart'; shake)));
		with: 'Drop items here to remove them from the cart.'! !

!SUDragDropTest methodsFor: 'rendering' stamp: 'lr 3/13/2006 23:38'!
style
	^ 'div#inventory {
	margin: 1em;
	cursor: move;
}
div#cart {
	margin: 1em;
	padding: 1em;
	border: 1px dashed #e8a400;
	cursor: move;
}
div#trash {
	margin: 1em;
	padding: 1em;
	border: 1px dashed #c5dea1;
	cursor: move;
}
.hover {
	background-color: #eeeeee;
}'! !

SUFunctionalTest subclass: #SUEffectsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUEffectsTest methodsFor: 'accessing' stamp: 'lr 3/28/2006 23:07'!
effects
	^ #( appear fade puff blindDown blindUp switchOff slideDown slideUp dropOut shake pulsate squish fold grow shrink highlight )! !

!SUEffectsTest methodsFor: 'rendering' stamp: 'lr 3/13/2006 23:00'!
renderContentOn: html
	html paragraph: [
		self effects do: [ :each |
			html anchor
				onClick: (html effect
					id: 'effect';
					perform: each);
				text: (self labelForSelector: each) ]
			separatedBy: [ html text: ', ' ] ].
	self renderBox: 'effect' on: html! !

SUFunctionalTest subclass: #SUEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUEncodingTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderContentOn: html
	| stream |
	stream := (String withAll: Character allCharacters)
		readStream.
	[ stream atEnd ] whileFalse: [
		html div
			style: 'font-family: courier, serif';
			script: (html element
				update: (stream next: 16)) ]! !

SUFunctionalTest subclass: #SUFormTest
	instanceVariableNames: 'textInput textArea checkBox radioButton selectList mutliSelectList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUFormTest methodsFor: 'initialization' stamp: 'lr 3/28/2006 22:19'!
initialize
	super initialize.
	textInput := 'Text Input'.
	textArea := 'Text Area'.
	checkBox := false.
	radioButton := 1.
	selectList := 1.
	mutliSelectList := 1 to: 2! !

!SUFormTest methodsFor: 'rendering-elements' stamp: 'lr 4/3/2006 11:17'!
renderCheckBoxOn: html
	self
		renderLabel: 'Check-Box'
		control: [ :fid :mid |
			html checkbox
				value: checkBox;
				callback: [ :value | checkBox := value ];
				onClick: (html ajax
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render: checkBox ]) ]
		model: checkBox
		on: html! !

!SUFormTest methodsFor: 'rendering' stamp: 'lr 3/28/2006 22:19'!
renderContentOn: html
	self renderTextInputOn: html.
	self renderTextAreaOn: html.
	self renderCheckBoxOn: html.
	self renderRadioButtonOn: html.
	self renderSelectListOn: html.
	self renderMultiSelectListOn: html! !

!SUFormTest methodsFor: 'rendering-utilities' stamp: 'lr 3/30/2006 22:10'!
renderLabel: aString control: aBlock model: anObject on: html
	| fid mid |
	html div class: 'row'; with: [
		html div class: 'label'; with: aString.
		html div class: 'control'; with: [
			html form
				id: (fid := html nextId);
				with: [ aBlock value: fid value: (mid := html nextId) ] ].
		html div class: 'model'; id: mid; with: anObject.
		html div class: 'clear' ]! !

!SUFormTest methodsFor: 'rendering-elements' stamp: 'lr 3/28/2006 22:38'!
renderMultiSelectListOn: html
	self
		renderLabel: 'Multi-Select-List'
		control: [ :fid :mid |
			html select
				size: 3;
				beMultiple;
				list: (1 to: 9);
				selected: mutliSelectList;
				callback: [ :value | mutliSelectList := value ];
				onChange: (html ajax
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render: mutliSelectList ]) ]
		model: mutliSelectList
		on: html! !

!SUFormTest methodsFor: 'rendering-elements' stamp: 'lr 3/28/2006 23:27'!
renderRadioButtonOn: html
	self
		renderLabel: 'Radio-Button'
		control: [ :fid :mid |
			html radioGroup: [ :group |
				1 to: 3 do: [ :each |
					html label: [
						html radioButton
							group: group;
							selected: radioButton = each;
							callback: [ radioButton := each ];
							onClick: (html ajax
								id: mid;
								triggerForm: fid;
								callback: [ :r | r render: radioButton ]).
					 		html text: each ].
					html break ] ] ]
		model: radioButton
		on: html! !

!SUFormTest methodsFor: 'rendering-elements' stamp: 'lr 3/28/2006 22:38'!
renderSelectListOn: html
	self
		renderLabel: 'Select-List'
		control: [ :fid :mid |
			html select
				list: (1 to: 9);
				selected: selectList;
				callback: [ :value | selectList := value ];
				onChange: (html ajax
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render: selectList ]) ]
		model: selectList
		on: html! !

!SUFormTest methodsFor: 'rendering-elements' stamp: 'lr 3/28/2006 22:39'!
renderTextAreaOn: html
	self
		renderLabel: 'Text-Area'
		control: [ :fid :mid |
			html textArea
				value: textArea;
				callback: [ :value | textArea := value ].
			html space.
			html submitButton
				onClick: (html ajax
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render: textArea ];
					returnFalse);
				text: 'Submit' ]
		model: textArea
		on: html! !

!SUFormTest methodsFor: 'rendering-elements' stamp: 'lr 3/30/2006 22:10'!
renderTextInputOn: html
	self
		renderLabel: 'Text-Input'
		control: [ :fid :mid |
			html textInput
				value: textInput;
				callback: [ :value | textInput := value ].
			html space.
			html submitButton
				onClick: (html ajax
					id: mid;
					triggerForm: fid;
					callback: [ :r | r render: textInput ];
					returnFalse);
				text: 'Submit' ]
		model: textInput
		on: html! !

!SUFormTest methodsFor: 'rendering' stamp: 'lr 3/28/2006 22:38'!
style
	^ 'div.row { margin: 5px; }
div.label { float: left; width: 20%; font-weight: bold; }
div.control { float: left; width: 50% }
div.model { float: left; width: 30%; }
div.clear { clear: both; }
select { width: 100px; }'! !

!SUFunctionalTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderBox: aString on: html
	html div id: aString; class: 'box'; with: [
		html div class: 'header'.
		html div
			class: 'content';
			with: 'Smalltalk Enterprise Aubergines' ]! !

!SUFunctionalTest methodsFor: 'testing' stamp: 'lr 3/12/2006 15:36'!
showSource
	^ true! !

SUFunctionalTest subclass: #SUInPlaceEditorTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUInPlaceEditorTest methodsFor: 'initialization' stamp: 'lr 4/2/2006 13:18'!
initialize
	super initialize.
	text := 'Click me, edit me.'! !

!SUInPlaceEditorTest methodsFor: 'rendering' stamp: 'lr 4/7/2006 14:24'!
renderContentOn: html
	html paragraph
		script: (html inPlaceEditor
			callback: [ :value :renderer | renderer render: (text := value) ];
			cancelText: '');
		with: text! !

SUFunctionalTest subclass: #SUInsertTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUInsertTest methodsFor: 'rendering' stamp: 'lr 4/3/2006 11:41'!
renderContentOn: html
	html paragraph: [
		#( insertBefore insertTop insertBottom insertAfter ) do: [ :each |
			html anchor
				onClick: (html ajax
					id: 'element';
					perform: each;
					on: #renderElementOn: of: self);
				text: each.
			html break ] ].
	html div	
		class: 'paragraph';
		with: [ html div id: 'element'; with: 'Target Element' ]! !

!SUInsertTest methodsFor: 'rendering' stamp: 'lr 4/3/2006 11:36'!
renderElementOn: html
	html div: Time now! !

!SUInsertTest methodsFor: 'rendering' stamp: 'lr 4/3/2006 11:34'!
style
	^ '#element { background-color: #fff4d8; }'! !

SUFunctionalTest subclass: #SUPeriodicalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUPeriodicalTest methodsFor: 'rendering' stamp: 'lr 4/1/2006 18:42'!
renderContentOn: html
	html paragraph
		script: (html periodical
			frequency: 1;
			on: #renderTimeOn: of: self).
	html paragraph
		script: (html periodical
			decay: 2;
			on: #renderDateOn: of: self)! !

!SUPeriodicalTest methodsFor: 'rendering' stamp: 'lr 3/12/2006 16:00'!
renderDateOn: html
	html render: Date today! !

!SUPeriodicalTest methodsFor: 'rendering' stamp: 'lr 3/12/2006 16:00'!
renderTimeOn: html
	html render: Time now! !

SUFunctionalTest subclass: #SUSliderTest
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUSliderTest methodsFor: 'initialization' stamp: 'lr 3/20/2006 19:49'!
initialize
	super initialize.
	position := 50! !

!SUSliderTest methodsFor: 'rendering' stamp: 'lr 4/1/2006 11:11'!
renderContentOn: html
	html div id: 'track'; with: [ html div id: 'handle' ].
	html script: (html slider
		handleId: 'handle';
		trackId: 'track';
		value: position;
		range: (0 to: 100);
		onChange: (html ajax
			id: 'position';
			triggerSliderCallback: [ :value | position := value asInteger ];
			callback: [ :renderer | renderer render: position ])).
	html paragraph id: 'position'; with: position! !

!SUSliderTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 20:20'!
style
	^ 'div#track {
	width: 200px; height: 5px;
	background-color: #eee;
}
div#handle {
	width: 5px; height: 10px;
	background-color: #e8a400;
	cursor: move;
}'! !

SUFunctionalTest subclass: #SUSortableTest
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUSortableTest methodsFor: 'private' stamp: 'lr 4/2/2006 12:30'!
classForObject: anObject
	^ anObject species = SmallInteger
		ifFalse: [ 'orange' ]
		ifTrue: [ 'green' ]! !

!SUSortableTest methodsFor: 'private' stamp: 'lr 3/12/2006 17:04'!
labelForObject: anObject
	^ anObject class name , ': ' , anObject displayString! !

!SUSortableTest methodsFor: 'accessing' stamp: 'lr 3/17/2006 13:50'!
left
	^ left ifNil: [ left := $a to: $c ]! !

!SUSortableTest methodsFor: 'accessing' stamp: 'lr 3/17/2006 13:50'!
left: aCollection
	left := aCollection! !

!SUSortableTest methodsFor: 'rendering' stamp: 'lr 4/7/2006 14:22'!
renderContentOn: html
	html div
		style: 'float: left;';
		with: [ self renderList: #left titled: 'Left List' on: html ].
	html div
		style: 'float: left;';
		with: [ self renderList: #right titled: 'Right List' on: html ].
	html div
		style: 'clear: both'! !

!SUSortableTest methodsFor: 'rendering' stamp: 'lr 4/2/2006 12:31'!
renderListItems: aSelector on: html
	html unorderedList
		id: aSelector asString;
		style: 'width: 200px; min-height: 50px;';
		script: (html sortable
			constraint: false;
			dropOnEmpty: true;
			containment: #( left right );
			onUpdate: (html ajax
				id: aSelector , 'status';
				triggerSortable: aSelector asString
					callback: [ :values | self perform: aSelector asMutator with: values ];
				callback: [ :renderer | self renderListModel: aSelector on: renderer ]));
		with: [
			(self perform: aSelector) do: [ :each |
				html listItem
					passenger: each;
					class: (self classForObject: each);
					with: (self labelForObject: each) ] ]! !

!SUSortableTest methodsFor: 'rendering' stamp: 'lr 3/30/2006 22:10'!
renderListModel: aSelector on: html
	html text: 'Model: '.
	(self perform: aSelector)
		do: [ :each | html render: each ]
		separatedBy: [ html text: ', ' ]! !

!SUSortableTest methodsFor: 'rendering' stamp: 'lr 3/17/2006 14:00'!
renderList: aSelector titled: aString on: html
	html heading: aString level: 3.
	html paragraph
		id: aSelector , 'status';
		with: [ self renderListModel: aSelector on: html ].
	self renderListItems: aSelector on: html! !

!SUSortableTest methodsFor: 'accessing' stamp: 'lr 3/17/2006 13:50'!
right
	^ right ifNil: [ right := 1 to: 3 ]! !

!SUSortableTest methodsFor: 'accessing' stamp: 'lr 3/17/2006 13:50'!
right: aCollection
	right := aCollection! !

!SUSortableTest methodsFor: 'rendering' stamp: 'lr 4/2/2006 12:31'!
style
	^ 'li.green, li.orange {
	margin: 4px;
	padding: 2px;
  	cursor: move;
}
li.green {
	background-color: #ecf3e1;
  	border: 1px solid #c5dea1;
}
li.orange {
	background-color: #fff4d8;
  	border: 1px solid #e8a400;
}'! !

SUFunctionalTest subclass: #SUTogglesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUTogglesTest methodsFor: 'rendering' stamp: 'lr 3/13/2006 23:17'!
renderContentOn: html
	html paragraph: [
		self toggles do: [ :each |
			html anchor
				onClick: (html effect
					id: 'toggle';
					perform: each);
				text: (self labelForSelector: each) ]
			separatedBy: [ html text: ', ' ] ].
	self renderBox: 'toggle' on: html! !

!SUTogglesTest methodsFor: 'accessing' stamp: 'lr 3/13/2006 23:17'!
toggles
	^ #( toggleAppear toggleBlind toggleSlide )! !

SUFunctionalTest subclass: #SUTreeTest
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUTreeTest methodsFor: 'initialization' stamp: 'lr 4/7/2006 14:15'!
initialize
	super initialize.
	root := nil -> (OrderedCollection new
		add: ('Eukaryota' -> (OrderedCollection new
			add: ('Opisthokonts' -> (OrderedCollection new
				add: 'Animalia' -> #();
				add: 'Choanoflagellates' -> #();
				add: 'Nucleariids' -> #();
				add: 'Fungi' -> #();
				yourself));
			add: 'Amoebozoa' -> #();
			add: ('Rhizaria' -> (OrderedCollection new
				add: 'Cercozoa' -> #();
				add: 'Foraminifera' -> #();
				add: 'Polycystinea' -> #();
				add: 'Acantharea' -> #();
				add: 'Sticholonche' -> #();
				yourself));
			add: ('Plants' -> (OrderedCollection new
				add: 'Plantae' -> #();
				add: 'Red algae' -> #();
				add: 'Glaucophytes' -> #();
				yourself));
			yourself));
		yourself)! !

!SUTreeTest methodsFor: 'rendering' stamp: 'lr 4/7/2006 14:18'!
renderChildren: aNode on: html
	aNode value do: [ :each | self renderNode: each on: html ]! !

!SUTreeTest methodsFor: 'rendering' stamp: 'lr 4/7/2006 14:16'!
renderContentOn: html
	html unorderedList
		id: 'evolution';
		script: (html sortable
			tree: true;
			onUpdate: (html request
				triggerTree: 'evolution'
				callback: [ :values | root := values ]));
		with: [ self renderChildren: root on: html ]! !

!SUTreeTest methodsFor: 'rendering' stamp: 'lr 4/7/2006 14:19'!
renderNode: aNode on: html
	html listItem passenger: aNode key; with: [
		html text: aNode key.
		aNode value isEmpty ifFalse: [
			html unorderedList: [ 
				self renderChildren: aNode on: html ] ] ]! !

!SUTreeTest methodsFor: 'rendering' stamp: 'lr 4/7/2006 01:08'!
style
	^ 'ul#evolution li {
	list-style: none;
	cursor: move;
}'! !

SUFunctionalTest subclass: #SUWelcomeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUWelcomeTest methodsFor: 'rendering' stamp: 'lr 3/13/2006 22:10'!
renderContentOn: html
	 html paragraph: [
		html anchor url: self seaside; with: 'Seaside'.
		html text: ' provides an almost complete integration of '.
		html anchor url: self scriptaculous; with: 'script.aculo.us'.
		html text: ', allowing the use of the library without having to write a single line of JavaScript code. Everything can be configured and plugged together using Smalltalk objects. Try by yourself, by clicking trough this functional test suite and by browsing the source-code.' ].
	html heading: 'Seaside' level: 2.
	html paragraph: [
		html anchor url: self seaside; with: 'Seaside'.
		html text: ' is a framework for developing sophisticated web applications in Smalltalk. It provides a layered set of abstractions over HTTP and HTML that let you build highly interactive web applications quickly, reusably and maintainably.' ].
	html heading: 'script.aculo.us' level: 2.
	html paragraph: [
		html anchor url: self scriptaculous; with: 'script.aculo.us'.
		html text: ' provides you with easy-to-use, compatible and, ultimately, totally cool JavaScript libraries to make your web sites and web applications fly, Web 2.0 style.' ]! !

!SUWelcomeTest methodsFor: 'testing' stamp: 'lr 3/12/2006 15:36'!
showSource
	^ false! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/30/2006 19:01'!
ajax
	^ SUAjax on: self! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/30/2006 18:58'!
autocomplete: aString
	^ (SUAutocompleter on: self)
		setTarget: aString! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 16:03'!
draggable
	^ SUDraggable new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 16:37'!
droppable
	^ SUDroppable new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'avi 9/21/2005 22:57'!
effect
	^ SUEffect new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'avi 9/24/2005 19:32'!
element
	^ SUElement new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/3/2006 16:48'!
formElement
	^ SUFormElement new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 4/2/2006 13:46'!
inPlaceEditor
	^ SUInPlaceEditor on: self! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/30/2006 18:58'!
periodical
	^ SUPeriodical on: self! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/30/2006 18:58'!
request
	^ SURequest on: self! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/30/2006 20:17'!
slider
	^ SUSlider new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 2/22/2006 07:13'!
sortable
	^ SUSortable new! !

!WASession methodsFor: '*scriptaculous' stamp: 'avi 9/24/2005 19:43'!
effect
	^ self addLoadScript: SUEffect new! !

!Interval methodsFor: '*scriptaculous' stamp: 'lr 4/6/2006 08:11'!
asJavascript
	^ String streamContents: [ :stream |
		stream
			nextPutAll: '$R('; print: self first;
			nextPut: $,; print: self last; nextPut: $) ]! !

WAScriptLibrary subclass: #SUScriptLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 4/6/2006 23:22'!
aPrototype
	^ '/*  Prototype JavaScript framework, version 1.5.0_rc0
 *  (c) 2005 Sam Stephenson <sam@conio.net>
 *
 *  Prototype is freely distributable under the terms of an MIT-style license.
 *  For details, see the Prototype web site: http://prototype.conio.net/
 *
/*--------------------------------------------------------------------------*/

var Prototype = {
  Version: ''1.5.0_rc0'',
  ScriptFragment: ''(?:<script.*?>)((\n|\r|.)*?)(?:<\/script>)'',

  emptyFunction: function() {},
  K: function(x) {return x}
}

var Class = {
  create: function() {
    return function() {
      this.initialize.apply(this, arguments);
    }
  }
}

var Abstract = new Object();

Object.extend = function(destination, source) {
  for (var property in source) {
    destination[property] = source[property];
  }
  return destination;
}

Object.inspect = function(object) {
  try {
    if (object == undefined) return ''undefined'';
    if (object == null) return ''null'';
    return object.inspect ? object.inspect() : object.toString();
  } catch (e) {
    if (e instanceof RangeError) return ''...'';
    throw e;
  }
}

Function.prototype.bind = function() {
  var __method = this, args = $A(arguments), object = args.shift();
  return function() {
    return __method.apply(object, args.concat($A(arguments)));
  }
}

Function.prototype.bindAsEventListener = function(object) {
  var __method = this;
  return function(event) {
    return __method.call(object, event || window.event);
  }
}

Object.extend(Number.prototype, {
  toColorPart: function() {
    var digits = this.toString(16);
    if (this < 16) return ''0'' + digits;
    return digits;
  },

  succ: function() {
    return this + 1;
  },

  times: function(iterator) {
    $R(0, this, true).each(iterator);
    return this;
  }
});

var Try = {
  these: function() {
    var returnValue;

    for (var i = 0; i < arguments.length; i++) {
      var lambda = arguments[i];
      try {
        returnValue = lambda();
        break;
      } catch (e) {}
    }

    return returnValue;
  }
}

/*--------------------------------------------------------------------------*/

var PeriodicalExecuter = Class.create();
PeriodicalExecuter.prototype = {
  initialize: function(callback, frequency) {
    this.callback = callback;
    this.frequency = frequency;
    this.currentlyExecuting = false;

    this.registerCallback();
  },

  registerCallback: function() {
    setInterval(this.onTimerEvent.bind(this), this.frequency * 1000);
  },

  onTimerEvent: function() {
    if (!!this.currentlyExecuting) {
      try {
        this.currentlyExecuting = true;
        this.callback();
      } finally {
        this.currentlyExecuting = false;
      }
    }
  }
}
Object.extend(String.prototype, {
  gsub: function(pattern, replacement) {
    var result = '''', source = this, match;
    replacement = arguments.callee.prepareReplacement(replacement);

    while (source.length > 0) {
      if (match = source.match(pattern)) {
        result += source.slice(0, match.index);
        result += (replacement(match) || '''').toString();
        source  = source.slice(match.index + match[0].length);
      } else {
        result += source, source = '''';
      }
    }
    return result;
  },

  sub: function(pattern, replacement, count) {
    replacement = this.gsub.prepareReplacement(replacement);
    count = count === undefined ? 1 : count;

    return this.gsub(pattern, function(match) {
      if (--count < 0) return match[0];
      return replacement(match);
    });
  },

  scan: function(pattern, iterator) {
    this.gsub(pattern, iterator);
    return this;
  },

  truncate: function(length, truncation) {
    length = length || 30;
    truncation = truncation === undefined ? ''...'' : truncation;
    return this.length > length ?
      this.slice(0, length - truncation.length) + truncation : this;
  },

  strip: function() {
    return this.replace(/^\s+/, '''').replace(/\s+$/, '''');
  },

  stripTags: function() {
    return this.replace(/<\/?[^>]+>/gi, '''');
  },

  stripScripts: function() {
    return this.replace(new RegExp(Prototype.ScriptFragment, ''img''), '''');
  },

  extractScripts: function() {
    var matchAll = new RegExp(Prototype.ScriptFragment, ''img'');
    var matchOne = new RegExp(Prototype.ScriptFragment, ''im'');
    return (this.match(matchAll) || []).map(function(scriptTag) {
      return (scriptTag.match(matchOne) || ['''', ''''])[1];
    });
  },

  evalScripts: function() {
    return this.extractScripts().map(function(script) { return eval(script) });
  },

  escapeHTML: function() {
    var div = document.createElement(''div'');
    var text = document.createTextNode(this);
    div.appendChild(text);
    return div.innerHTML;
  },

  unescapeHTML: function() {
    var div = document.createElement(''div'');
    div.innerHTML = this.stripTags();
    return div.childNodes[0] ? div.childNodes[0].nodeValue : '''';
  },

  toQueryParams: function() {
    var pairs = this.match(/^\??(.*)$/)[1].split(''&'');
    return pairs.inject({}, function(params, pairString) {
      var pair = pairString.split(''='');
      params[pair[0]] = pair[1];
      return params;
    });
  },

  toArray: function() {
    return this.split('''');
  },

  camelize: function() {
    var oStringList = this.split(''-'');
    if (oStringList.length == 1) return oStringList[0];

    var camelizedString = this.indexOf(''-'') == 0
      ? oStringList[0].charAt(0).toUpperCase() + oStringList[0].substring(1)
      : oStringList[0];

    for (var i = 1, len = oStringList.length; i < len; i++) {
      var s = oStringList[i];
      camelizedString += s.charAt(0).toUpperCase() + s.substring(1);
    }

    return camelizedString;
  },

  inspect: function() {
    return "''" + this.replace(/\\/g, ''\\\\'').replace(/''/g, ''\\\'''') + "''";
  }
});

String.prototype.gsub.prepareReplacement = function(replacement) {
  if (typeof replacement == ''function'') return replacement;
  var template = new Template(replacement);
  return function(match) { return template.evaluate(match) };
}

String.prototype.parseQuery = String.prototype.toQueryParams;

var Template = Class.create();
Template.Pattern = /(^|.|\r|\n)(#\{(.*?)\})/;
Template.prototype = {
  initialize: function(template, pattern) {
    this.template = template.toString();
    this.pattern  = pattern || Template.Pattern;
  },

  evaluate: function(object) {
    return this.template.gsub(this.pattern, function(match) {
      var before = match[1];
      if (before == ''\\'') return match[2];
      return before + (object[match[3]] || '''').toString();
    });
  }
}

var $break    = new Object();
var $continue = new Object();

var Enumerable = {
  each: function(iterator) {
    var index = 0;
    try {
      this._each(function(value) {
        try {
          iterator(value, index++);
        } catch (e) {
          if (e !!= $continue) throw e;
        }
      });
    } catch (e) {
      if (e !!= $break) throw e;
    }
  },

  all: function(iterator) {
    var result = true;
    this.each(function(value, index) {
      result = result && !!!!(iterator || Prototype.K)(value, index);
      if (!!result) throw $break;
    });
    return result;
  },

  any: function(iterator) {
    var result = true;
    this.each(function(value, index) {
      if (result = !!!!(iterator || Prototype.K)(value, index))
        throw $break;
    });
    return result;
  },

  collect: function(iterator) {
    var results = [];
    this.each(function(value, index) {
      results.push(iterator(value, index));
    });
    return results;
  },

  detect: function (iterator) {
    var result;
    this.each(function(value, index) {
      if (iterator(value, index)) {
        result = value;
        throw $break;
      }
    });
    return result;
  },

  findAll: function(iterator) {
    var results = [];
    this.each(function(value, index) {
      if (iterator(value, index))
        results.push(value);
    });
    return results;
  },

  grep: function(pattern, iterator) {
    var results = [];
    this.each(function(value, index) {
      var stringValue = value.toString();
      if (stringValue.match(pattern))
        results.push((iterator || Prototype.K)(value, index));
    })
    return results;
  },

  include: function(object) {
    var found = false;
    this.each(function(value) {
      if (value == object) {
        found = true;
        throw $break;
      }
    });
    return found;
  },

  inject: function(memo, iterator) {
    this.each(function(value, index) {
      memo = iterator(memo, value, index);
    });
    return memo;
  },

  invoke: function(method) {
    var args = $A(arguments).slice(1);
    return this.collect(function(value) {
      return value[method].apply(value, args);
    });
  },

  max: function(iterator) {
    var result;
    this.each(function(value, index) {
      value = (iterator || Prototype.K)(value, index);
      if (result == undefined || value >= result)
        result = value;
    });
    return result;
  },

  min: function(iterator) {
    var result;
    this.each(function(value, index) {
      value = (iterator || Prototype.K)(value, index);
      if (result == undefined || value < result)
        result = value;
    });
    return result;
  },

  partition: function(iterator) {
    var trues = [], falses = [];
    this.each(function(value, index) {
      ((iterator || Prototype.K)(value, index) ?
        trues : falses).push(value);
    });
    return [trues, falses];
  },

  pluck: function(property) {
    var results = [];
    this.each(function(value, index) {
      results.push(value[property]);
    });
    return results;
  },

  reject: function(iterator) {
    var results = [];
    this.each(function(value, index) {
      if (!!iterator(value, index))
        results.push(value);
    });
    return results;
  },

  sortBy: function(iterator) {
    return this.collect(function(value, index) {
      return {value: value, criteria: iterator(value, index)};
    }).sort(function(left, right) {
      var a = left.criteria, b = right.criteria;
      return a < b ? -1 : a > b ? 1 : 0;
    }).pluck(''value'');
  },

  toArray: function() {
    return this.collect(Prototype.K);
  },

  zip: function() {
    var iterator = Prototype.K, args = $A(arguments);
    if (typeof args.last() == ''function'')
      iterator = args.pop();

    var collections = [this].concat(args).map($A);
    return this.map(function(value, index) {
      return iterator(collections.pluck(index));
    });
  },

  inspect: function() {
    return ''#<Enumerable:'' + this.toArray().inspect() + ''>'';
  }
}

Object.extend(Enumerable, {
  map:     Enumerable.collect,
  find:    Enumerable.detect,
  select:  Enumerable.findAll,
  member:  Enumerable.include,
  entries: Enumerable.toArray
});
var $A = Array.from = function(iterable) {
  if (!!iterable) return [];
  if (iterable.toArray) {
    return iterable.toArray();
  } else {
    var results = [];
    for (var i = 0; i < iterable.length; i++)
      results.push(iterable[i]);
    return results;
  }
}

Object.extend(Array.prototype, Enumerable);

if (!!Array.prototype._reverse)
  Array.prototype._reverse = Array.prototype.reverse;

Object.extend(Array.prototype, {
  _each: function(iterator) {
    for (var i = 0; i < this.length; i++)
      iterator(this[i]);
  },

  clear: function() {
    this.length = 0;
    return this;
  },

  first: function() {
    return this[0];
  },

  last: function() {
    return this[this.length - 1];
  },

  compact: function() {
    return this.select(function(value) {
      return value !!= undefined || value !!= null;
    });
  },

  flatten: function() {
    return this.inject([], function(array, value) {
      return array.concat(value && value.constructor == Array ?
        value.flatten() : [value]);
    });
  },

  without: function() {
    var values = $A(arguments);
    return this.select(function(value) {
      return !!values.include(value);
    });
  },

  indexOf: function(object) {
    for (var i = 0; i < this.length; i++)
      if (this[i] == object) return i;
    return -1;
  },

  reverse: function(inline) {
    return (inline !!== false ? this : this.toArray())._reverse();
  },

  inspect: function() {
    return ''['' + this.map(Object.inspect).join('', '') + '']'';
  }
});
var Hash = {
  _each: function(iterator) {
    for (var key in this) {
      var value = this[key];
      if (typeof value == ''function'') continue;

      var pair = [key, value];
      pair.key = key;
      pair.value = value;
      iterator(pair);
    }
  },

  keys: function() {
    return this.pluck(''key'');
  },

  values: function() {
    return this.pluck(''value'');
  },

  merge: function(hash) {
    return $H(hash).inject($H(this), function(mergedHash, pair) {
      mergedHash[pair.key] = pair.value;
      return mergedHash;
    });
  },

  toQueryString: function() {
    return this.map(function(pair) {
      return pair.map(encodeURIComponent).join(''='');
    }).join(''&'');
  },

  inspect: function() {
    return ''#<Hash:{'' + this.map(function(pair) {
      return pair.map(Object.inspect).join('': '');
    }).join('', '') + ''}>'';
  }
}

function $H(object) {
  var hash = Object.extend({}, object || {});
  Object.extend(hash, Enumerable);
  Object.extend(hash, Hash);
  return hash;
}
ObjectRange = Class.create();
Object.extend(ObjectRange.prototype, Enumerable);
Object.extend(ObjectRange.prototype, {
  initialize: function(start, end, exclusive) {
    this.start = start;
    this.end = end;
    this.exclusive = exclusive;
  },

  _each: function(iterator) {
    var value = this.start;
    do {
      iterator(value);
      value = value.succ();
    } while (this.include(value));
  },

  include: function(value) {
    if (value < this.start)
      return false;
    if (this.exclusive)
      return value < this.end;
    return value <= this.end;
  }
});

var $R = function(start, end, exclusive) {
  return new ObjectRange(start, end, exclusive);
}

var Ajax = {
  getTransport: function() {
    return Try.these(
      function() {return new XMLHttpRequest()},
      function() {return new ActiveXObject(''Msxml2.XMLHTTP'')},
      function() {return new ActiveXObject(''Microsoft.XMLHTTP'')}
    ) || false;
  },

  activeRequestCount: 0
}

Ajax.Responders = {
  responders: [],

  _each: function(iterator) {
    this.responders._each(iterator);
  },

  register: function(responderToAdd) {
    if (!!this.include(responderToAdd))
      this.responders.push(responderToAdd);
  },

  unregister: function(responderToRemove) {
    this.responders = this.responders.without(responderToRemove);
  },

  dispatch: function(callback, request, transport, json) {
    this.each(function(responder) {
      if (responder[callback] && typeof responder[callback] == ''function'') {
        try {
          responder[callback].apply(responder, [request, transport, json]);
        } catch (e) {}
      }
    });
  }
};

Object.extend(Ajax.Responders, Enumerable);

Ajax.Responders.register({
  onCreate: function() {
    Ajax.activeRequestCount++;
  },

  onComplete: function() {
    Ajax.activeRequestCount--;
  }
});

Ajax.Base = function() {};
Ajax.Base.prototype = {
  setOptions: function(options) {
    this.options = {
      method:       ''post'',
      asynchronous: true,
      contentType:  ''application/x-www-form-urlencoded'',
      parameters:   ''''
    }
    Object.extend(this.options, options || {});
  },

  responseIsSuccess: function() {
    return this.transport.status == undefined
        || this.transport.status == 0
        || (this.transport.status >= 200 && this.transport.status < 300);
  },

  responseIsFailure: function() {
    return !!this.responseIsSuccess();
  }
}

Ajax.Request = Class.create();
Ajax.Request.Events =
  [''Uninitialized'', ''Loading'', ''Loaded'', ''Interactive'', ''Complete''];

Ajax.Request.prototype = Object.extend(new Ajax.Base(), {
  initialize: function(url, options) {
    this.transport = Ajax.getTransport();
    this.setOptions(options);
    this.request(url);
  },

  request: function(url) {
    var parameters = this.options.parameters || '''';
    if (parameters.length > 0) parameters += ''&_='';

    try {
      this.url = url;
      if (this.options.method == ''get'' && parameters.length > 0)
        this.url += (this.url.match(/\?/) ? ''&'' : ''?'') + parameters;

      Ajax.Responders.dispatch(''onCreate'', this, this.transport);

      this.transport.open(this.options.method, this.url,
        this.options.asynchronous);

      if (this.options.asynchronous) {
        this.transport.onreadystatechange = this.onStateChange.bind(this);
        setTimeout((function() {this.respondToReadyState(1)}).bind(this), 10);
      }

      this.setRequestHeaders();

      var body = this.options.postBody ? this.options.postBody : parameters;
      this.transport.send(this.options.method == ''post'' ? body : null);

    } catch (e) {
      this.dispatchException(e);
    }
  },

  setRequestHeaders: function() {
    var requestHeaders =
      [''X-Requested-With'', ''XMLHttpRequest'',
       ''X-Prototype-Version'', Prototype.Version,
       ''Accept'', ''text/javascript, text/html, application/xml, text/xml, */*''];

    if (this.options.method == ''post'') {
      requestHeaders.push(''Content-type'', this.options.contentType);

      /* Force "Connection: close" for Mozilla browsers to work around
       * a bug where XMLHttpReqeuest sends an incorrect Content-length
       * header. See Mozilla Bugzilla #246651.
       */
      if (this.transport.overrideMimeType)
        requestHeaders.push(''Connection'', ''close'');
    }

    if (this.options.requestHeaders)
      requestHeaders.push.apply(requestHeaders, this.options.requestHeaders);

    for (var i = 0; i < requestHeaders.length; i += 2)
      this.transport.setRequestHeader(requestHeaders[i], requestHeaders[i+1]);
  },

  onStateChange: function() {
    var readyState = this.transport.readyState;
    if (readyState !!= 1)
      this.respondToReadyState(this.transport.readyState);
  },

  header: function(name) {
    try {
      return this.transport.getResponseHeader(name);
    } catch (e) {}
  },

  evalJSON: function() {
    try {
      return eval(''('' + this.header(''X-JSON'') + '')'');
    } catch (e) {}
  },

  evalResponse: function() {
    try {
      return eval(this.transport.responseText);
    } catch (e) {
      this.dispatchException(e);
    }
  },

  respondToReadyState: function(readyState) {
    var event = Ajax.Request.Events[readyState];
    var transport = this.transport, json = this.evalJSON();

    if (event == ''Complete'') {
      try {
        (this.options[''on'' + this.transport.status]
         || this.options[''on'' + (this.responseIsSuccess() ? ''Success'' : ''Failure'')]
         || Prototype.emptyFunction)(transport, json);
      } catch (e) {
        this.dispatchException(e);
      }

      if ((this.header(''Content-type'') || '''').match(/^text\/javascript/i))
        this.evalResponse();
    }

    try {
      (this.options[''on'' + event] || Prototype.emptyFunction)(transport, json);
      Ajax.Responders.dispatch(''on'' + event, this, transport, json);
    } catch (e) {
      this.dispatchException(e);
    }

    /* Avoid memory leak in MSIE: clean up the oncomplete event handler */
    if (event == ''Complete'')
      this.transport.onreadystatechange = Prototype.emptyFunction;
  },

  dispatchException: function(exception) {
    (this.options.onException || Prototype.emptyFunction)(this, exception);
    Ajax.Responders.dispatch(''onException'', this, exception);
  }
});

Ajax.Updater = Class.create();

Object.extend(Object.extend(Ajax.Updater.prototype, Ajax.Request.prototype), {
  initialize: function(container, url, options) {
    this.containers = {
      success: container.success ? $(container.success) : $(container),
      failure: container.failure ? $(container.failure) :
        (container.success ? null : $(container))
    }

    this.transport = Ajax.getTransport();
    this.setOptions(options);

    var onComplete = this.options.onComplete || Prototype.emptyFunction;
    this.options.onComplete = (function(transport, object) {
      this.updateContent();
      onComplete(transport, object);
    }).bind(this);

    this.request(url);
  },

  updateContent: function() {
    var receiver = this.responseIsSuccess() ?
      this.containers.success : this.containers.failure;
    var response = this.transport.responseText;

    if (!!this.options.evalScripts)
      response = response.stripScripts();

    if (receiver) {
      if (this.options.insertion) {
        new this.options.insertion(receiver, response);
      } else {
        Element.update(receiver, response);
      }
    }

    if (this.responseIsSuccess()) {
      if (this.onComplete)
        setTimeout(this.onComplete.bind(this), 10);
    }
  }
});

Ajax.PeriodicalUpdater = Class.create();
Ajax.PeriodicalUpdater.prototype = Object.extend(new Ajax.Base(), {
  initialize: function(container, url, options) {
    this.setOptions(options);
    this.onComplete = this.options.onComplete;

    this.frequency = (this.options.frequency || 2);
    this.decay = (this.options.decay || 1);

    this.updater = {};
    this.container = container;
    this.url = url;

    this.start();
  },

  start: function() {
    this.options.onComplete = this.updateComplete.bind(this);
    this.onTimerEvent();
  },

  stop: function() {
    this.updater.onComplete = undefined;
    clearTimeout(this.timer);
    (this.onComplete || Prototype.emptyFunction).apply(this, arguments);
  },

  updateComplete: function(request) {
    if (this.options.decay) {
      this.decay = (request.responseText == this.lastText ?
        this.decay * this.options.decay : 1);

      this.lastText = request.responseText;
    }
    this.timer = setTimeout(this.onTimerEvent.bind(this),
      this.decay * this.frequency * 1000);
  },

  onTimerEvent: function() {
    this.updater = new Ajax.Updater(this.container, this.url, this.options);
  }
});
function $() {
  var results = [], element;
  for (var i = 0; i < arguments.length; i++) {
    element = arguments[i];
    if (typeof element == ''string'')
      element = document.getElementById(element);
    results.push(Element.extend(element));
  }
  return results.length < 2 ? results[0] : results;
}

document.getElementsByClassName = function(className, parentElement) {
  var children = ($(parentElement) || document.body).getElementsByTagName(''*'');
  return $A(children).inject([], function(elements, child) {
    if (child.className.match(new RegExp("(^|\\s)" + className + "(\\s|$)")))
      elements.push(Element.extend(child));
    return elements;
  });
}

/*--------------------------------------------------------------------------*/

if (!!window.Element)
  var Element = new Object();

Element.extend = function(element) {
  if (!!element) return;
  if (_nativeExtensions) return element;

  if (!!element._extended && element.tagName && element !!= window) {
    var methods = Element.Methods, cache = Element.extend.cache;
    for (property in methods) {
      var value = methods[property];
      if (typeof value == ''function'')
        element[property] = cache.findOrStore(value);
    }
  }

  element._extended = true;
  return element;
}

Element.extend.cache = {
  findOrStore: function(value) {
    return this[value] = this[value] || function() {
      return value.apply(null, [this].concat($A(arguments)));
    }
  }
}

Element.Methods = {
  visible: function(element) {
    return $(element).style.display !!= ''none'';
  },

  toggle: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      Element[Element.visible(element) ? ''hide'' : ''show''](element);
    }
  },

  hide: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      element.style.display = ''none'';
    }
  },

  show: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      element.style.display = '''';
    }
  },

  remove: function(element) {
    element = $(element);
    element.parentNode.removeChild(element);
  },

  update: function(element, html) {
    $(element).innerHTML = html.stripScripts();
    setTimeout(function() {html.evalScripts()}, 10);
  },

  replace: function(element, html) {
    element = $(element);
    if (element.outerHTML) {
      element.outerHTML = html.stripScripts();
    } else {
      var range = element.ownerDocument.createRange();
      range.selectNodeContents(element);
      element.parentNode.replaceChild(
        range.createContextualFragment(html.stripScripts()), element);
    }
    setTimeout(function() {html.evalScripts()}, 10);
  },

  getHeight: function(element) {
    element = $(element);
    return element.offsetHeight;
  },

  classNames: function(element) {
    return new Element.ClassNames(element);
  },

  hasClassName: function(element, className) {
    if (!!(element = $(element))) return;
    return Element.classNames(element).include(className);
  },

  addClassName: function(element, className) {
    if (!!(element = $(element))) return;
    return Element.classNames(element).add(className);
  },

  removeClassName: function(element, className) {
    if (!!(element = $(element))) return;
    return Element.classNames(element).remove(className);
  },

  // removes whitespace-only text node children
  cleanWhitespace: function(element) {
    element = $(element);
    for (var i = 0; i < element.childNodes.length; i++) {
      var node = element.childNodes[i];
      if (node.nodeType == 3 && !!/\S/.test(node.nodeValue))
        Element.remove(node);
    }
  },

  empty: function(element) {
    return $(element).innerHTML.match(/^\s*$/);
  },

  childOf: function(element, ancestor) {
    element = $(element), ancestor = $(ancestor);
    while (element = element.parentNode)
      if (element == ancestor) return true;
    return false;
  },

  scrollTo: function(element) {
    element = $(element);
    var x = element.x ? element.x : element.offsetLeft,
        y = element.y ? element.y : element.offsetTop;
    window.scrollTo(x, y);
  },

  getStyle: function(element, style) {
    element = $(element);
    var value = element.style[style.camelize()];
    if (!!value) {
      if (document.defaultView && document.defaultView.getComputedStyle) {
        var css = document.defaultView.getComputedStyle(element, null);
        value = css ? css.getPropertyValue(style) : null;
      } else if (element.currentStyle) {
        value = element.currentStyle[style.camelize()];
      }
    }

    if (window.opera && [''left'', ''top'', ''right'', ''bottom''].include(style))
      if (Element.getStyle(element, ''position'') == ''static'') value = ''auto'';

    return value == ''auto'' ? null : value;
  },

  setStyle: function(element, style) {
    element = $(element);
    for (var name in style)
      element.style[name.camelize()] = style[name];
  },

  getDimensions: function(element) {
    element = $(element);
    if (Element.getStyle(element, ''display'') !!= ''none'')
      return {width: element.offsetWidth, height: element.offsetHeight};

    // All *Width and *Height properties give 0 on elements with display none,
    // so enable the element temporarily
    var els = element.style;
    var originalVisibility = els.visibility;
    var originalPosition = els.position;
    els.visibility = ''hidden'';
    els.position = ''absolute'';
    els.display = '''';
    var originalWidth = element.clientWidth;
    var originalHeight = element.clientHeight;
    els.display = ''none'';
    els.position = originalPosition;
    els.visibility = originalVisibility;
    return {width: originalWidth, height: originalHeight};
  },

  makePositioned: function(element) {
    element = $(element);
    var pos = Element.getStyle(element, ''position'');
    if (pos == ''static'' || !!pos) {
      element._madePositioned = true;
      element.style.position = ''relative'';
      // Opera returns the offset relative to the positioning context, when an
      // element is position relative but top and left have not been defined
      if (window.opera) {
        element.style.top = 0;
        element.style.left = 0;
      }
    }
  },

  undoPositioned: function(element) {
    element = $(element);
    if (element._madePositioned) {
      element._madePositioned = undefined;
      element.style.position =
        element.style.top =
        element.style.left =
        element.style.bottom =
        element.style.right = '''';
    }
  },

  makeClipping: function(element) {
    element = $(element);
    if (element._overflow) return;
    element._overflow = element.style.overflow;
    if ((Element.getStyle(element, ''overflow'') || ''visible'') !!= ''hidden'')
      element.style.overflow = ''hidden'';
  },

  undoClipping: function(element) {
    element = $(element);
    if (element._overflow) return;
    element.style.overflow = element._overflow;
    element._overflow = undefined;
  }
}

Object.extend(Element, Element.Methods);

var _nativeExtensions = false;

if(!!HTMLElement && /Konqueror|Safari|KHTML/.test(navigator.userAgent)) {
  var HTMLElement = {}
  HTMLElement.prototype = document.createElement(''div'').__proto__;
}

Element.addMethods = function(methods) {
  Object.extend(Element.Methods, methods || {});

  if(typeof HTMLElement !!= ''undefined'') {
    var methods = Element.Methods, cache = Element.extend.cache;
    for (property in methods) {
      var value = methods[property];
      if (typeof value == ''function'')
        HTMLElement.prototype[property] = cache.findOrStore(value);
    }
    _nativeExtensions = true;
  }
}

Element.addMethods();

var Toggle = new Object();
Toggle.display = Element.toggle;

/*--------------------------------------------------------------------------*/

Abstract.Insertion = function(adjacency) {
  this.adjacency = adjacency;
}

Abstract.Insertion.prototype = {
  initialize: function(element, content) {
    this.element = $(element);
    this.content = content.stripScripts();

    if (this.adjacency && this.element.insertAdjacentHTML) {
      try {
        this.element.insertAdjacentHTML(this.adjacency, this.content);
      } catch (e) {
        var tagName = this.element.tagName.toLowerCase();
        if (tagName == ''tbody'' || tagName == ''tr'') {
          this.insertContent(this.contentFromAnonymousTable());
        } else {
          throw e;
        }
      }
    } else {
      this.range = this.element.ownerDocument.createRange();
      if (this.initializeRange) this.initializeRange();
      this.insertContent([this.range.createContextualFragment(this.content)]);
    }

    setTimeout(function() {content.evalScripts()}, 10);
  },

  contentFromAnonymousTable: function() {
    var div = document.createElement(''div'');
    div.innerHTML = ''<table><tbody>'' + this.content + ''</tbody></table>'';
    return $A(div.childNodes[0].childNodes[0].childNodes);
  }
}

var Insertion = new Object();

Insertion.Before = Class.create();
Insertion.Before.prototype = Object.extend(new Abstract.Insertion(''beforeBegin''), {
  initializeRange: function() {
    this.range.setStartBefore(this.element);
  },

  insertContent: function(fragments) {
    fragments.each((function(fragment) {
      this.element.parentNode.insertBefore(fragment, this.element);
    }).bind(this));
  }
});

Insertion.Top = Class.create();
Insertion.Top.prototype = Object.extend(new Abstract.Insertion(''afterBegin''), {
  initializeRange: function() {
    this.range.selectNodeContents(this.element);
    this.range.collapse(true);
  },

  insertContent: function(fragments) {
    fragments.reverse(false).each((function(fragment) {
      this.element.insertBefore(fragment, this.element.firstChild);
    }).bind(this));
  }
});

Insertion.Bottom = Class.create();
Insertion.Bottom.prototype = Object.extend(new Abstract.Insertion(''beforeEnd''), {
  initializeRange: function() {
    this.range.selectNodeContents(this.element);
    this.range.collapse(this.element);
  },

  insertContent: function(fragments) {
    fragments.each((function(fragment) {
      this.element.appendChild(fragment);
    }).bind(this));
  }
});

Insertion.After = Class.create();
Insertion.After.prototype = Object.extend(new Abstract.Insertion(''afterEnd''), {
  initializeRange: function() {
    this.range.setStartAfter(this.element);
  },

  insertContent: function(fragments) {
    fragments.each((function(fragment) {
      this.element.parentNode.insertBefore(fragment,
        this.element.nextSibling);
    }).bind(this));
  }
});

/*--------------------------------------------------------------------------*/

Element.ClassNames = Class.create();
Element.ClassNames.prototype = {
  initialize: function(element) {
    this.element = $(element);
  },

  _each: function(iterator) {
    this.element.className.split(/\s+/).select(function(name) {
      return name.length > 0;
    })._each(iterator);
  },

  set: function(className) {
    this.element.className = className;
  },

  add: function(classNameToAdd) {
    if (this.include(classNameToAdd)) return;
    this.set(this.toArray().concat(classNameToAdd).join('' ''));
  },

  remove: function(classNameToRemove) {
    if (!!this.include(classNameToRemove)) return;
    this.set(this.select(function(className) {
      return className !!= classNameToRemove;
    }).join('' ''));
  },

  toString: function() {
    return this.toArray().join('' '');
  }
}

Object.extend(Element.ClassNames.prototype, Enumerable);
var Selector = Class.create();
Selector.prototype = {
  initialize: function(expression) {
    this.params = {classNames: []};
    this.expression = expression.toString().strip();
    this.parseExpression();
    this.compileMatcher();
  },

  parseExpression: function() {
    function abort(message) { throw ''Parse error in selector: '' + message; }

    if (this.expression == '''')  abort(''empty expression'');

    var params = this.params, expr = this.expression, match, modifier, clause, rest;
    while (match = expr.match(/^(.*)\[([a-z0-9_:-]+?)(?:([~\|!!]?=)(?:"([^"]*)"|([^\]\s]*)))?\]$/i)) {
      params.attributes = params.attributes || [];
      params.attributes.push({name: match[2], operator: match[3], value: match[4] || match[5] || ''''});
      expr = match[1];
    }

    if (expr == ''*'') return this.params.wildcard = true;

    while (match = expr.match(/^([^a-z0-9_-])?([a-z0-9_-]+)(.*)/i)) {
      modifier = match[1], clause = match[2], rest = match[3];
      switch (modifier) {
        case ''#'':       params.id = clause; break;
        case ''.'':       params.classNames.push(clause); break;
        case '''':
        case undefined: params.tagName = clause.toUpperCase(); break;
        default:        abort(expr.inspect());
      }
      expr = rest;
    }

    if (expr.length > 0) abort(expr.inspect());
  },

  buildMatchExpression: function() {
    var params = this.params, conditions = [], clause;

    if (params.wildcard)
      conditions.push(''true'');
    if (clause = params.id)
      conditions.push(''element.id == '' + clause.inspect());
    if (clause = params.tagName)
      conditions.push(''element.tagName.toUpperCase() == '' + clause.inspect());
    if ((clause = params.classNames).length > 0)
      for (var i = 0; i < clause.length; i++)
        conditions.push(''Element.hasClassName(element, '' + clause[i].inspect() + '')'');
    if (clause = params.attributes) {
      clause.each(function(attribute) {
        var value = ''element.getAttribute('' + attribute.name.inspect() + '')'';
        var splitValueBy = function(delimiter) {
          return value + '' && '' + value + ''.split('' + delimiter.inspect() + '')'';
        }

        switch (attribute.operator) {
          case ''='':       conditions.push(value + '' == '' + attribute.value.inspect()); break;
          case ''~='':      conditions.push(splitValueBy('' '') + ''.include('' + attribute.value.inspect() + '')''); break;
          case ''|='':      conditions.push(
                            splitValueBy(''-'') + ''.first().toUpperCase() == '' + attribute.value.toUpperCase().inspect()
                          ); break;
          case ''!!='':      conditions.push(value + '' !!= '' + attribute.value.inspect()); break;
          case '''':
          case undefined: conditions.push(value + '' !!= null''); break;
          default:        throw ''Unknown operator '' + attribute.operator + '' in selector'';
        }
      });
    }

    return conditions.join('' && '');
  },

  compileMatcher: function() {
    this.match = new Function(''element'', ''if (!!element.tagName) return false; \
      return '' + this.buildMatchExpression());
  },

  findElements: function(scope) {
    var element;

    if (element = $(this.params.id))
      if (this.match(element))
        if (!!scope || Element.childOf(element, scope))
          return [element];

    scope = (scope || document).getElementsByTagName(this.params.tagName || ''*'');

    var results = [];
    for (var i = 0; i < scope.length; i++)
      if (this.match(element = scope[i]))
        results.push(Element.extend(element));

    return results;
  },

  toString: function() {
    return this.expression;
  }
}

function $$() {
  return $A(arguments).map(function(expression) {
    return expression.strip().split(/\s+/).inject([null], function(results, expr) {
      var selector = new Selector(expr);
      return results.map(selector.findElements.bind(selector)).flatten();
    });
  }).flatten();
}
var Field = {
  clear: function() {
    for (var i = 0; i < arguments.length; i++)
      $(arguments[i]).value = '''';
  },

  focus: function(element) {
    $(element).focus();
  },

  present: function() {
    for (var i = 0; i < arguments.length; i++)
      if ($(arguments[i]).value == '''') return false;
    return true;
  },

  select: function(element) {
    $(element).select();
  },

  activate: function(element) {
    element = $(element);
    element.focus();
    if (element.select)
      element.select();
  }
}

/*--------------------------------------------------------------------------*/

var Form = {
  serialize: function(form) {
    var elements = Form.getElements($(form));
    var queryComponents = new Array();

    for (var i = 0; i < elements.length; i++) {
      var queryComponent = Form.Element.serialize(elements[i]);
      if (queryComponent)
        queryComponents.push(queryComponent);
    }

    return queryComponents.join(''&'');
  },

  getElements: function(form) {
    form = $(form);
    var elements = new Array();

    for (var tagName in Form.Element.Serializers) {
      var tagElements = form.getElementsByTagName(tagName);
      for (var j = 0; j < tagElements.length; j++)
        elements.push(tagElements[j]);
    }
    return elements;
  },

  getInputs: function(form, typeName, name) {
    form = $(form);
    var inputs = form.getElementsByTagName(''input'');

    if (!!typeName && !!name)
      return inputs;

    var matchingInputs = new Array();
    for (var i = 0; i < inputs.length; i++) {
      var input = inputs[i];
      if ((typeName && input.type !!= typeName) ||
          (name && input.name !!= name))
        continue;
      matchingInputs.push(input);
    }

    return matchingInputs;
  },

  disable: function(form) {
    var elements = Form.getElements(form);
    for (var i = 0; i < elements.length; i++) {
      var element = elements[i];
      element.blur();
      element.disabled = ''true'';
    }
  },

  enable: function(form) {
    var elements = Form.getElements(form);
    for (var i = 0; i < elements.length; i++) {
      var element = elements[i];
      element.disabled = '''';
    }
  },

  findFirstElement: function(form) {
    return Form.getElements(form).find(function(element) {
      return element.type !!= ''hidden'' && !!element.disabled &&
        [''input'', ''select'', ''textarea''].include(element.tagName.toLowerCase());
    });
  },

  focusFirstElement: function(form) {
    Field.activate(Form.findFirstElement(form));
  },

  reset: function(form) {
    $(form).reset();
  }
}

Form.Element = {
  serialize: function(element) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    var parameter = Form.Element.Serializers[method](element);

    if (parameter) {
      var key = encodeURIComponent(parameter[0]);
      if (key.length == 0) return;

      if (parameter[1].constructor !!= Array)
        parameter[1] = [parameter[1]];

      return parameter[1].map(function(value) {
        return key + ''='' + encodeURIComponent(value);
      }).join(''&'');
    }
  },

  getValue: function(element) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    var parameter = Form.Element.Serializers[method](element);

    if (parameter)
      return parameter[1];
  }
}

Form.Element.Serializers = {
  input: function(element) {
    switch (element.type.toLowerCase()) {
      case ''submit'':
      case ''hidden'':
      case ''password'':
      case ''text'':
        return Form.Element.Serializers.textarea(element);
      case ''checkbox'':
      case ''radio'':
        return Form.Element.Serializers.inputSelector(element);
    }
    return false;
  },

  inputSelector: function(element) {
    if (element.checked)
      return [element.name, element.value];
  },

  textarea: function(element) {
    return [element.name, element.value];
  },

  select: function(element) {
    return Form.Element.Serializers[element.type == ''select-one'' ?
      ''selectOne'' : ''selectMany''](element);
  },

  selectOne: function(element) {
    var value = '''', opt, index = element.selectedIndex;
    if (index >= 0) {
      opt = element.options[index];
      value = opt.value || opt.text;
    }
    return [element.name, value];
  },

  selectMany: function(element) {
    var value = [];
    for (var i = 0; i < element.length; i++) {
      var opt = element.options[i];
      if (opt.selected)
        value.push(opt.value || opt.text);
    }
    return [element.name, value];
  }
}

/*--------------------------------------------------------------------------*/

var $F = Form.Element.getValue;

/*--------------------------------------------------------------------------*/

Abstract.TimedObserver = function() {}
Abstract.TimedObserver.prototype = {
  initialize: function(element, frequency, callback) {
    this.frequency = frequency;
    this.element   = $(element);
    this.callback  = callback;

    this.lastValue = this.getValue();
    this.registerCallback();
  },

  registerCallback: function() {
    setInterval(this.onTimerEvent.bind(this), this.frequency * 1000);
  },

  onTimerEvent: function() {
    var value = this.getValue();
    if (this.lastValue !!= value) {
      this.callback(this.element, value);
      this.lastValue = value;
    }
  }
}

Form.Element.Observer = Class.create();
Form.Element.Observer.prototype = Object.extend(new Abstract.TimedObserver(), {
  getValue: function() {
    return Form.Element.getValue(this.element);
  }
});

Form.Observer = Class.create();
Form.Observer.prototype = Object.extend(new Abstract.TimedObserver(), {
  getValue: function() {
    return Form.serialize(this.element);
  }
});

/*--------------------------------------------------------------------------*/

Abstract.EventObserver = function() {}
Abstract.EventObserver.prototype = {
  initialize: function(element, callback) {
    this.element  = $(element);
    this.callback = callback;

    this.lastValue = this.getValue();
    if (this.element.tagName.toLowerCase() == ''form'')
      this.registerFormCallbacks();
    else
      this.registerCallback(this.element);
  },

  onElementEvent: function() {
    var value = this.getValue();
    if (this.lastValue !!= value) {
      this.callback(this.element, value);
      this.lastValue = value;
    }
  },

  registerFormCallbacks: function() {
    var elements = Form.getElements(this.element);
    for (var i = 0; i < elements.length; i++)
      this.registerCallback(elements[i]);
  },

  registerCallback: function(element) {
    if (element.type) {
      switch (element.type.toLowerCase()) {
        case ''checkbox'':
        case ''radio'':
          Event.observe(element, ''click'', this.onElementEvent.bind(this));
          break;
        case ''password'':
        case ''text'':
        case ''textarea'':
        case ''select-one'':
        case ''select-multiple'':
          Event.observe(element, ''change'', this.onElementEvent.bind(this));
          break;
      }
    }
  }
}

Form.Element.EventObserver = Class.create();
Form.Element.EventObserver.prototype = Object.extend(new Abstract.EventObserver(), {
  getValue: function() {
    return Form.Element.getValue(this.element);
  }
});

Form.EventObserver = Class.create();
Form.EventObserver.prototype = Object.extend(new Abstract.EventObserver(), {
  getValue: function() {
    return Form.serialize(this.element);
  }
});
if (!!window.Event) {
  var Event = new Object();
}

Object.extend(Event, {
  KEY_BACKSPACE: 8,
  KEY_TAB:       9,
  KEY_RETURN:   13,
  KEY_ESC:      27,
  KEY_LEFT:     37,
  KEY_UP:       38,
  KEY_RIGHT:    39,
  KEY_DOWN:     40,
  KEY_DELETE:   46,

  element: function(event) {
    return event.target || event.srcElement;
  },

  isLeftClick: function(event) {
    return (((event.which) && (event.which == 1)) ||
            ((event.button) && (event.button == 1)));
  },

  pointerX: function(event) {
    return event.pageX || (event.clientX +
      (document.documentElement.scrollLeft || document.body.scrollLeft));
  },

  pointerY: function(event) {
    return event.pageY || (event.clientY +
      (document.documentElement.scrollTop || document.body.scrollTop));
  },

  stop: function(event) {
    if (event.preventDefault) {
      event.preventDefault();
      event.stopPropagation();
    } else {
      event.returnValue = false;
      event.cancelBubble = true;
    }
  },

  // find the first node with the given tagName, starting from the
  // node the event was triggered on; traverses the DOM upwards
  findElement: function(event, tagName) {
    var element = Event.element(event);
    while (element.parentNode && (!!element.tagName ||
        (element.tagName.toUpperCase() !!= tagName.toUpperCase())))
      element = element.parentNode;
    return element;
  },

  observers: false,

  _observeAndCache: function(element, name, observer, useCapture) {
    if (!!this.observers) this.observers = [];
    if (element.addEventListener) {
      this.observers.push([element, name, observer, useCapture]);
      element.addEventListener(name, observer, useCapture);
    } else if (element.attachEvent) {
      this.observers.push([element, name, observer, useCapture]);
      element.attachEvent(''on'' + name, observer);
    }
  },

  unloadCache: function() {
    if (!!Event.observers) return;
    for (var i = 0; i < Event.observers.length; i++) {
      Event.stopObserving.apply(this, Event.observers[i]);
      Event.observers[i][0] = null;
    }
    Event.observers = false;
  },

  observe: function(element, name, observer, useCapture) {
    var element = $(element);
    useCapture = useCapture || false;

    if (name == ''keypress'' &&
        (navigator.appVersion.match(/Konqueror|Safari|KHTML/)
        || element.attachEvent))
      name = ''keydown'';

    this._observeAndCache(element, name, observer, useCapture);
  },

  stopObserving: function(element, name, observer, useCapture) {
    var element = $(element);
    useCapture = useCapture || false;

    if (name == ''keypress'' &&
        (navigator.appVersion.match(/Konqueror|Safari|KHTML/)
        || element.detachEvent))
      name = ''keydown'';

    if (element.removeEventListener) {
      element.removeEventListener(name, observer, useCapture);
    } else if (element.detachEvent) {
      element.detachEvent(''on'' + name, observer);
    }
  }
});

/* prevent memory leaks in IE */
if (navigator.appVersion.match(/\bMSIE\b/))
  Event.observe(window, ''unload'', Event.unloadCache, false);
var Position = {
  // set to true if needed, warning: firefox performance problems
  // NOT neeeded for page scrolling, only if draggable contained in
  // scrollable elements
  includeScrollOffsets: false,

  // must be called before calling withinIncludingScrolloffset, every time the
  // page is scrolled
  prepare: function() {
    this.deltaX =  window.pageXOffset
                || document.documentElement.scrollLeft
                || document.body.scrollLeft
                || 0;
    this.deltaY =  window.pageYOffset
                || document.documentElement.scrollTop
                || document.body.scrollTop
                || 0;
  },

  realOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.scrollTop  || 0;
      valueL += element.scrollLeft || 0;
      element = element.parentNode;
    } while (element);
    return [valueL, valueT];
  },

  cumulativeOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
    } while (element);
    return [valueL, valueT];
  },

  positionedOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
      if (element) {
        p = Element.getStyle(element, ''position'');
        if (p == ''relative'' || p == ''absolute'') break;
      }
    } while (element);
    return [valueL, valueT];
  },

  offsetParent: function(element) {
    if (element.offsetParent) return element.offsetParent;
    if (element == document.body) return element;

    while ((element = element.parentNode) && element !!= document.body)
      if (Element.getStyle(element, ''position'') !!= ''static'')
        return element;

    return document.body;
  },

  // caches x/y coordinate pair to use with overlap
  within: function(element, x, y) {
    if (this.includeScrollOffsets)
      return this.withinIncludingScrolloffsets(element, x, y);
    this.xcomp = x;
    this.ycomp = y;
    this.offset = this.cumulativeOffset(element);

    return (y >= this.offset[1] &&
            y <  this.offset[1] + element.offsetHeight &&
            x >= this.offset[0] &&
            x <  this.offset[0] + element.offsetWidth);
  },

  withinIncludingScrolloffsets: function(element, x, y) {
    var offsetcache = this.realOffset(element);

    this.xcomp = x + offsetcache[0] - this.deltaX;
    this.ycomp = y + offsetcache[1] - this.deltaY;
    this.offset = this.cumulativeOffset(element);

    return (this.ycomp >= this.offset[1] &&
            this.ycomp <  this.offset[1] + element.offsetHeight &&
            this.xcomp >= this.offset[0] &&
            this.xcomp <  this.offset[0] + element.offsetWidth);
  },

  // within must be called directly before
  overlap: function(mode, element) {
    if (!!mode) return 0;
    if (mode == ''vertical'')
      return ((this.offset[1] + element.offsetHeight) - this.ycomp) /
        element.offsetHeight;
    if (mode == ''horizontal'')
      return ((this.offset[0] + element.offsetWidth) - this.xcomp) /
        element.offsetWidth;
  },

  clone: function(source, target) {
    source = $(source);
    target = $(target);
    target.style.position = ''absolute'';
    var offsets = this.cumulativeOffset(source);
    target.style.top    = offsets[1] + ''px'';
    target.style.left   = offsets[0] + ''px'';
    target.style.width  = source.offsetWidth + ''px'';
    target.style.height = source.offsetHeight + ''px'';
  },

  page: function(forElement) {
    var valueT = 0, valueL = 0;

    var element = forElement;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;

      // Safari fix
      if (element.offsetParent==document.body)
        if (Element.getStyle(element,''position'')==''absolute'') break;

    } while (element = element.offsetParent);

    element = forElement;
    do {
      valueT -= element.scrollTop  || 0;
      valueL -= element.scrollLeft || 0;
    } while (element = element.parentNode);

    return [valueL, valueT];
  },

  clone: function(source, target) {
    var options = Object.extend({
      setLeft:    true,
      setTop:     true,
      setWidth:   true,
      setHeight:  true,
      offsetTop:  0,
      offsetLeft: 0
    }, arguments[2] || {})

    // find page position of source
    source = $(source);
    var p = Position.page(source);

    // find coordinate system to use
    target = $(target);
    var delta = [0, 0];
    var parent = null;
    // delta [0,0] will do fine with position: fixed elements,
    // position:absolute needs offsetParent deltas
    if (Element.getStyle(target,''position'') == ''absolute'') {
      parent = Position.offsetParent(target);
      delta = Position.page(parent);
    }

    // correct by body offsets (fixes Safari)
    if (parent == document.body) {
      delta[0] -= document.body.offsetLeft;
      delta[1] -= document.body.offsetTop;
    }

    // set position
    if(options.setLeft)   target.style.left  = (p[0] - delta[0] + options.offsetLeft) + ''px'';
    if(options.setTop)    target.style.top   = (p[1] - delta[1] + options.offsetTop) + ''px'';
    if(options.setWidth)  target.style.width = source.offsetWidth + ''px'';
    if(options.setHeight) target.style.height = source.offsetHeight + ''px'';
  },

  absolutize: function(element) {
    element = $(element);
    if (element.style.position == ''absolute'') return;
    Position.prepare();

    var offsets = Position.positionedOffset(element);
    var top     = offsets[1];
    var left    = offsets[0];
    var width   = element.clientWidth;
    var height  = element.clientHeight;

    element._originalLeft   = left - parseFloat(element.style.left  || 0);
    element._originalTop    = top  - parseFloat(element.style.top || 0);
    element._originalWidth  = element.style.width;
    element._originalHeight = element.style.height;

    element.style.position = ''absolute'';
    element.style.top    = top + ''px'';;
    element.style.left   = left + ''px'';;
    element.style.width  = width + ''px'';;
    element.style.height = height + ''px'';;
  },

  relativize: function(element) {
    element = $(element);
    if (element.style.position == ''relative'') return;
    Position.prepare();

    element.style.position = ''relative'';
    var top  = parseFloat(element.style.top  || 0) - (element._originalTop || 0);
    var left = parseFloat(element.style.left || 0) - (element._originalLeft || 0);

    element.style.top    = top + ''px'';
    element.style.left   = left + ''px'';
    element.style.height = element._originalHeight;
    element.style.width  = element._originalWidth;
  }
}

// Safari returns margins on body which is incorrect if the child is absolutely
// positioned.  For performance reasons, redefine Position.cumulativeOffset for
// KHTML/WebKit only.
if (/Konqueror|Safari|KHTML/.test(navigator.userAgent)) {
  Position.cumulativeOffset = function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      if (element.offsetParent == document.body)
        if (Element.getStyle(element, ''position'') == ''absolute'') break;

      element = element.offsetParent;
    } while (element);

    return [valueL, valueT];
  }
}'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 4/6/2006 23:23'!
bBuilder
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
//
// See scriptaculous.js for full license.

var Builder = {
  NODEMAP: {
    AREA: ''map'',
    CAPTION: ''table'',
    COL: ''table'',
    COLGROUP: ''table'',
    LEGEND: ''fieldset'',
    OPTGROUP: ''select'',
    OPTION: ''select'',
    PARAM: ''object'',
    TBODY: ''table'',
    TD: ''table'',
    TFOOT: ''table'',
    TH: ''table'',
    THEAD: ''table'',
    TR: ''table''
  },
  // note: For Firefox < 1.5, OPTION and OPTGROUP tags are currently broken,
  //       due to a Firefox bug
  node: function(elementName) {
    elementName = elementName.toUpperCase();
    
    // try innerHTML approach
    var parentTag = this.NODEMAP[elementName] || ''div'';
    var parentElement = document.createElement(parentTag);
    try { // prevent IE "feature": http://dev.rubyonrails.org/ticket/2707
      parentElement.innerHTML = "<" + elementName + "></" + elementName + ">";
    } catch(e) {}
    var element = parentElement.firstChild || null;
      
    // see if browser added wrapping tags
    if(element && (element.tagName !!= elementName))
      element = element.getElementsByTagName(elementName)[0];
    
    // fallback to createElement approach
    if(!!element) element = document.createElement(elementName);
    
    // abort if nothing could be created
    if(!!element) return;

    // attributes (or text)
    if(arguments[1])
      if(this._isStringOrNumber(arguments[1]) ||
        (arguments[1] instanceof Array)) {
          this._children(element, arguments[1]);
        } else {
          var attrs = this._attributes(arguments[1]);
          if(attrs.length) {
            try { // prevent IE "feature": http://dev.rubyonrails.org/ticket/2707
              parentElement.innerHTML = "<" +elementName + " " +
                attrs + "></" + elementName + ">";
            } catch(e) {}
            element = parentElement.firstChild || null;
            // workaround firefox 1.0.X bug
            if(!!element) {
              element = document.createElement(elementName);
              for(attr in arguments[1]) 
                element[attr == ''class'' ? ''className'' : attr] = arguments[1][attr];
            }
            if(element.tagName !!= elementName)
              element = parentElement.getElementsByTagName(elementName)[0];
            }
        } 

    // text, or array of children
    if(arguments[2])
      this._children(element, arguments[2]);

     return element;
  },
  _text: function(text) {
     return document.createTextNode(text);
  },
  _attributes: function(attributes) {
    var attrs = [];
    for(attribute in attributes)
      attrs.push((attribute==''className'' ? ''class'' : attribute) +
          ''="'' + attributes[attribute].toString().escapeHTML() + ''"'');
    return attrs.join(" ");
  },
  _children: function(element, children) {
    if(typeof children==''object'') { // array can hold nodes and text
      children.flatten().each( function(e) {
        if(typeof e==''object'')
          element.appendChild(e)
        else
          if(Builder._isStringOrNumber(e))
            element.appendChild(Builder._text(e));
      });
    } else
      if(Builder._isStringOrNumber(children)) 
         element.appendChild(Builder._text(children));
  },
  _isStringOrNumber: function(param) {
    return(typeof param==''string'' || typeof param==''number'');
  }
}'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 4/6/2006 23:23'!
cEffects
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
// Contributors:
//  Justin Palmer (http://encytemedia.com/)
//  Mark Pilgrim (http://diveintomark.org/)
//  Martin Bialasinki
// 
// See scriptaculous.js for full license.  

// converts rgb() and #xxx to #xxxxxx format,  
// returns self (or first argument) if not convertable  
String.prototype.parseColor = function() {  
  var color = ''#'';  
  if(this.slice(0,4) == ''rgb('') {  
    var cols = this.slice(4,this.length-1).split('','');  
    var i=0; do { color += parseInt(cols[i]).toColorPart() } while (++i<3);  
  } else {  
    if(this.slice(0,1) == ''#'') {  
      if(this.length==4) for(var i=1;i<4;i++) color += (this.charAt(i) + this.charAt(i)).toLowerCase();  
      if(this.length==7) color = this.toLowerCase();  
    }  
  }  
  return(color.length==7 ? color : (arguments[0] || this));  
}

/*--------------------------------------------------------------------------*/

Element.collectTextNodes = function(element) {  
  return $A($(element).childNodes).collect( function(node) {
    return (node.nodeType==3 ? node.nodeValue : 
      (node.hasChildNodes() ? Element.collectTextNodes(node) : ''''));
  }).flatten().join('''');
}

Element.collectTextNodesIgnoreClass = function(element, className) {  
  return $A($(element).childNodes).collect( function(node) {
    return (node.nodeType==3 ? node.nodeValue : 
      ((node.hasChildNodes() && !!Element.hasClassName(node,className)) ? 
        Element.collectTextNodesIgnoreClass(node, className) : ''''));
  }).flatten().join('''');
}

Element.setContentZoom = function(element, percent) {
  element = $(element);  
  Element.setStyle(element, {fontSize: (percent/100) + ''em''});   
  if(navigator.appVersion.indexOf(''AppleWebKit'')>0) window.scrollBy(0,0);
}

Element.getOpacity = function(element){  
  var opacity;
  if (opacity = Element.getStyle(element, ''opacity''))  
    return parseFloat(opacity);  
  if (opacity = (Element.getStyle(element, ''filter'') || '''').match(/alpha\(opacity=(.*)\)/))  
    if(opacity[1]) return parseFloat(opacity[1]) / 100;  
  return 1.0;  
}

Element.setOpacity = function(element, value){  
  element= $(element);  
  if (value == 1){
    Element.setStyle(element, { opacity: 
      (/Gecko/.test(navigator.userAgent) && !!/Konqueror|Safari|KHTML/.test(navigator.userAgent)) ? 
      0.999999 : null });
    if(/MSIE/.test(navigator.userAgent))  
      Element.setStyle(element, {filter: Element.getStyle(element,''filter'').replace(/alpha\([^\)]*\)/gi,'''')});  
  } else {  
    if(value < 0.00001) value = 0;  
    Element.setStyle(element, {opacity: value});
    if(/MSIE/.test(navigator.userAgent))  
     Element.setStyle(element, 
       { filter: Element.getStyle(element,''filter'').replace(/alpha\([^\)]*\)/gi,'''') +
                 ''alpha(opacity=''+value*100+'')'' });  
  }
}  
 
Element.getInlineOpacity = function(element){  
  return $(element).style.opacity || '''';
}  

Element.childrenWithClassName = function(element, className, findFirst) {
  var classNameRegExp = new RegExp("(^|\\s)" + className + "(\\s|$)");
  var results = $A($(element).getElementsByTagName(''*''))[findFirst ? ''detect'' : ''select'']( function(c) { 
    return (c.className && c.className.match(classNameRegExp));
  });
  if(!!results) results = [];
  return results;
}

Element.forceRerendering = function(element) {
  try {
    element = $(element);
    var n = document.createTextNode('' '');
    element.appendChild(n);
    element.removeChild(n);
  } catch(e) { }
};

/*--------------------------------------------------------------------------*/

Array.prototype.call = function() {
  var args = arguments;
  this.each(function(f){ f.apply(this, args) });
}

/*--------------------------------------------------------------------------*/

var Effect = {
  tagifyText: function(element) {
    var tagifyStyle = ''position:relative'';
    if(/MSIE/.test(navigator.userAgent)) tagifyStyle += '';zoom:1'';
    element = $(element);
    $A(element.childNodes).each( function(child) {
      if(child.nodeType==3) {
        child.nodeValue.toArray().each( function(character) {
          element.insertBefore(
            Builder.node(''span'',{style: tagifyStyle},
              character == '' '' ? String.fromCharCode(160) : character), 
              child);
        });
        Element.remove(child);
      }
    });
  },
  multiple: function(element, effect) {
    var elements;
    if(((typeof element == ''object'') || 
        (typeof element == ''function'')) && 
       (element.length))
      elements = element;
    else
      elements = $(element).childNodes;
      
    var options = Object.extend({
      speed: 0.1,
      delay: 0.0
    }, arguments[2] || {});
    var masterDelay = options.delay;

    $A(elements).each( function(element, index) {
      new effect(element, Object.extend(options, { delay: index * options.speed + masterDelay }));
    });
  },
  PAIRS: {
    ''slide'':  [''SlideDown'',''SlideUp''],
    ''blind'':  [''BlindDown'',''BlindUp''],
    ''appear'': [''Appear'',''Fade'']
  },
  toggle: function(element, effect) {
    element = $(element);
    effect = (effect || ''appear'').toLowerCase();
    var options = Object.extend({
      queue: { position:''end'', scope:(element.id || ''global''), limit: 1 }
    }, arguments[2] || {});
    Effect[element.visible() ? 
      Effect.PAIRS[effect][1] : Effect.PAIRS[effect][0]](element, options);
  }
};

var Effect2 = Effect; // deprecated

/* ------------- transitions ------------- */

Effect.Transitions = {}

Effect.Transitions.linear = function(pos) {
  return pos;
}
Effect.Transitions.sinoidal = function(pos) {
  return (-Math.cos(pos*Math.PI)/2) + 0.5;
}
Effect.Transitions.reverse  = function(pos) {
  return 1-pos;
}
Effect.Transitions.flicker = function(pos) {
  return ((-Math.cos(pos*Math.PI)/4) + 0.75) + Math.random()/4;
}
Effect.Transitions.wobble = function(pos) {
  return (-Math.cos(pos*Math.PI*(9*pos))/2) + 0.5;
}
Effect.Transitions.pulse = function(pos) {
  return (Math.floor(pos*10) % 2 == 0 ? 
    (pos*10-Math.floor(pos*10)) : 1-(pos*10-Math.floor(pos*10)));
}
Effect.Transitions.none = function(pos) {
  return 0;
}
Effect.Transitions.full = function(pos) {
  return 1;
}

/* ------------- core effects ------------- */

Effect.ScopedQueue = Class.create();
Object.extend(Object.extend(Effect.ScopedQueue.prototype, Enumerable), {
  initialize: function() {
    this.effects  = [];
    this.interval = null;
  },
  _each: function(iterator) {
    this.effects._each(iterator);
  },
  add: function(effect) {
    var timestamp = new Date().getTime();
    
    var position = (typeof effect.options.queue == ''string'') ? 
      effect.options.queue : effect.options.queue.position;
    
    switch(position) {
      case ''front'':
        // move unstarted effects after this effect  
        this.effects.findAll(function(e){ return e.state==''idle'' }).each( function(e) {
            e.startOn  += effect.finishOn;
            e.finishOn += effect.finishOn;
          });
        break;
      case ''end'':
        // start effect after last queued effect has finished
        timestamp = this.effects.pluck(''finishOn'').max() || timestamp;
        break;
    }
    
    effect.startOn  += timestamp;
    effect.finishOn += timestamp;

    if(!!effect.options.queue.limit || (this.effects.length < effect.options.queue.limit))
      this.effects.push(effect);
    
    if(!!this.interval) 
      this.interval = setInterval(this.loop.bind(this), 40);
  },
  remove: function(effect) {
    this.effects = this.effects.reject(function(e) { return e==effect });
    if(this.effects.length == 0) {
      clearInterval(this.interval);
      this.interval = null;
    }
  },
  loop: function() {
    var timePos = new Date().getTime();
    this.effects.invoke(''loop'', timePos);
  }
});

Effect.Queues = {
  instances: $H(),
  get: function(queueName) {
    if(typeof queueName !!= ''string'') return queueName;
    
    if(!!this.instances[queueName])
      this.instances[queueName] = new Effect.ScopedQueue();
      
    return this.instances[queueName];
  }
}
Effect.Queue = Effect.Queues.get(''global'');

Effect.DefaultOptions = {
  transition: Effect.Transitions.sinoidal,
  duration:   1.0,   // seconds
  fps:        25.0,  // max. 25fps due to Effect.Queue implementation
  sync:       false, // true for combining
  from:       0.0,
  to:         1.0,
  delay:      0.0,
  queue:      ''parallel''
}

Effect.Base = function() {};
Effect.Base.prototype = {
  position: null,
  start: function(options) {
    this.options      = Object.extend(Object.extend({},Effect.DefaultOptions), options || {});
    this.currentFrame = 0;
    this.state        = ''idle'';
    this.startOn      = this.options.delay*1000;
    this.finishOn     = this.startOn + (this.options.duration*1000);
    this.event(''beforeStart'');
    if(!!this.options.sync)
      Effect.Queues.get(typeof this.options.queue == ''string'' ? 
        ''global'' : this.options.queue.scope).add(this);
  },
  loop: function(timePos) {
    if(timePos >= this.startOn) {
      if(timePos >= this.finishOn) {
        this.render(1.0);
        this.cancel();
        this.event(''beforeFinish'');
        if(this.finish) this.finish(); 
        this.event(''afterFinish'');
        return;  
      }
      var pos   = (timePos - this.startOn) / (this.finishOn - this.startOn);
      var frame = Math.round(pos * this.options.fps * this.options.duration);
      if(frame > this.currentFrame) {
        this.render(pos);
        this.currentFrame = frame;
      }
    }
  },
  render: function(pos) {
    if(this.state == ''idle'') {
      this.state = ''running'';
      this.event(''beforeSetup'');
      if(this.setup) this.setup();
      this.event(''afterSetup'');
    }
    if(this.state == ''running'') {
      if(this.options.transition) pos = this.options.transition(pos);
      pos *= (this.options.to-this.options.from);
      pos += this.options.from;
      this.position = pos;
      this.event(''beforeUpdate'');
      if(this.update) this.update(pos);
      this.event(''afterUpdate'');
    }
  },
  cancel: function() {
    if(!!this.options.sync)
      Effect.Queues.get(typeof this.options.queue == ''string'' ? 
        ''global'' : this.options.queue.scope).remove(this);
    this.state = ''finished'';
  },
  event: function(eventName) {
    if(this.options[eventName + ''Internal'']) this.options[eventName + ''Internal''](this);
    if(this.options[eventName]) this.options[eventName](this);
  },
  inspect: function() {
    return ''#<Effect:'' + $H(this).inspect() + '',options:'' + $H(this.options).inspect() + ''>'';
  }
}

Effect.Parallel = Class.create();
Object.extend(Object.extend(Effect.Parallel.prototype, Effect.Base.prototype), {
  initialize: function(effects) {
    this.effects = effects || [];
    this.start(arguments[1]);
  },
  update: function(position) {
    this.effects.invoke(''render'', position);
  },
  finish: function(position) {
    this.effects.each( function(effect) {
      effect.render(1.0);
      effect.cancel();
      effect.event(''beforeFinish'');
      if(effect.finish) effect.finish(position);
      effect.event(''afterFinish'');
    });
  }
});

Effect.Opacity = Class.create();
Object.extend(Object.extend(Effect.Opacity.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    // make this work on IE on elements without ''layout''
    if(/MSIE/.test(navigator.userAgent) && (!!this.element.hasLayout))
      this.element.setStyle({zoom: 1});
    var options = Object.extend({
      from: this.element.getOpacity() || 0.0,
      to:   1.0
    }, arguments[1] || {});
    this.start(options);
  },
  update: function(position) {
    this.element.setOpacity(position);
  }
});

Effect.Move = Class.create();
Object.extend(Object.extend(Effect.Move.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    var options = Object.extend({
      x:    0,
      y:    0,
      mode: ''relative''
    }, arguments[1] || {});
    this.start(options);
  },
  setup: function() {
    // Bug in Opera: Opera returns the "real" position of a static element or
    // relative element that does not have top/left explicitly set.
    // ==> Always set top and left for position relative elements in your stylesheets 
    // (to 0 if you do not need them) 
    this.element.makePositioned();
    this.originalLeft = parseFloat(this.element.getStyle(''left'') || ''0'');
    this.originalTop  = parseFloat(this.element.getStyle(''top'')  || ''0'');
    if(this.options.mode == ''absolute'') {
      // absolute movement, so we need to calc deltaX and deltaY
      this.options.x = this.options.x - this.originalLeft;
      this.options.y = this.options.y - this.originalTop;
    }
  },
  update: function(position) {
    this.element.setStyle({
      left: this.options.x  * position + this.originalLeft + ''px'',
      top:  this.options.y  * position + this.originalTop  + ''px''
    });
  }
});

// for backwards compatibility
Effect.MoveBy = function(element, toTop, toLeft) {
  return new Effect.Move(element, 
    Object.extend({ x: toLeft, y: toTop }, arguments[3] || {}));
};

Effect.Scale = Class.create();
Object.extend(Object.extend(Effect.Scale.prototype, Effect.Base.prototype), {
  initialize: function(element, percent) {
    this.element = $(element)
    var options = Object.extend({
      scaleX: true,
      scaleY: true,
      scaleContent: true,
      scaleFromCenter: false,
      scaleMode: ''box'',        // ''box'' or ''contents'' or {} with provided values
      scaleFrom: 100.0,
      scaleTo:   percent
    }, arguments[2] || {});
    this.start(options);
  },
  setup: function() {
    this.restoreAfterFinish = this.options.restoreAfterFinish || false;
    this.elementPositioning = this.element.getStyle(''position'');
    
    this.originalStyle = {};
    [''top'',''left'',''width'',''height'',''fontSize''].each( function(k) {
      this.originalStyle[k] = this.element.style[k];
    }.bind(this));
      
    this.originalTop  = this.element.offsetTop;
    this.originalLeft = this.element.offsetLeft;
    
    var fontSize = this.element.getStyle(''font-size'') || ''100%'';
    [''em'',''px'',''%''].each( function(fontSizeType) {
      if(fontSize.indexOf(fontSizeType)>0) {
        this.fontSize     = parseFloat(fontSize);
        this.fontSizeType = fontSizeType;
      }
    }.bind(this));
    
    this.factor = (this.options.scaleTo - this.options.scaleFrom)/100;
    
    this.dims = null;
    if(this.options.scaleMode==''box'')
      this.dims = [this.element.offsetHeight, this.element.offsetWidth];
    if(/^content/.test(this.options.scaleMode))
      this.dims = [this.element.scrollHeight, this.element.scrollWidth];
    if(!!this.dims)
      this.dims = [this.options.scaleMode.originalHeight,
                   this.options.scaleMode.originalWidth];
  },
  update: function(position) {
    var currentScale = (this.options.scaleFrom/100.0) + (this.factor * position);
    if(this.options.scaleContent && this.fontSize)
      this.element.setStyle({fontSize: this.fontSize * currentScale + this.fontSizeType });
    this.setDimensions(this.dims[0] * currentScale, this.dims[1] * currentScale);
  },
  finish: function(position) {
    if (this.restoreAfterFinish) this.element.setStyle(this.originalStyle);
  },
  setDimensions: function(height, width) {
    var d = {};
    if(this.options.scaleX) d.width = width + ''px'';
    if(this.options.scaleY) d.height = height + ''px'';
    if(this.options.scaleFromCenter) {
      var topd  = (height - this.dims[0])/2;
      var leftd = (width  - this.dims[1])/2;
      if(this.elementPositioning == ''absolute'') {
        if(this.options.scaleY) d.top = this.originalTop-topd + ''px'';
        if(this.options.scaleX) d.left = this.originalLeft-leftd + ''px'';
      } else {
        if(this.options.scaleY) d.top = -topd + ''px'';
        if(this.options.scaleX) d.left = -leftd + ''px'';
      }
    }
    this.element.setStyle(d);
  }
});

Effect.Highlight = Class.create();
Object.extend(Object.extend(Effect.Highlight.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    var options = Object.extend({ startcolor: ''#ffff99'' }, arguments[1] || {});
    this.start(options);
  },
  setup: function() {
    // Prevent executing on elements not in the layout flow
    if(this.element.getStyle(''display'')==''none'') { this.cancel(); return; }
    // Disable background image during the effect
    this.oldStyle = {
      backgroundImage: this.element.getStyle(''background-image'') };
    this.element.setStyle({backgroundImage: ''none''});
    if(!!this.options.endcolor)
      this.options.endcolor = this.element.getStyle(''background-color'').parseColor(''#ffffff'');
    if(!!this.options.restorecolor)
      this.options.restorecolor = this.element.getStyle(''background-color'');
    // init color calculations
    this._base  = $R(0,2).map(function(i){ return parseInt(this.options.startcolor.slice(i*2+1,i*2+3),16) }.bind(this));
    this._delta = $R(0,2).map(function(i){ return parseInt(this.options.endcolor.slice(i*2+1,i*2+3),16)-this._base[i] }.bind(this));
  },
  update: function(position) {
    this.element.setStyle({backgroundColor: $R(0,2).inject(''#'',function(m,v,i){
      return m+(Math.round(this._base[i]+(this._delta[i]*position)).toColorPart()); }.bind(this)) });
  },
  finish: function() {
    this.element.setStyle(Object.extend(this.oldStyle, {
      backgroundColor: this.options.restorecolor
    }));
  }
});

Effect.ScrollTo = Class.create();
Object.extend(Object.extend(Effect.ScrollTo.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    this.start(arguments[1] || {});
  },
  setup: function() {
    Position.prepare();
    var offsets = Position.cumulativeOffset(this.element);
    if(this.options.offset) offsets[1] += this.options.offset;
    var max = window.innerHeight ? 
      window.height - window.innerHeight :
      document.body.scrollHeight - 
        (document.documentElement.clientHeight ? 
          document.documentElement.clientHeight : document.body.clientHeight);
    this.scrollStart = Position.deltaY;
    this.delta = (offsets[1] > max ? max : offsets[1]) - this.scrollStart;
  },
  update: function(position) {
    Position.prepare();
    window.scrollTo(Position.deltaX, 
      this.scrollStart + (position*this.delta));
  }
});

/* ------------- combination effects ------------- */

Effect.Fade = function(element) {
  element = $(element);
  var oldOpacity = element.getInlineOpacity();
  var options = Object.extend({
  from: element.getOpacity() || 1.0,
  to:   0.0,
  afterFinishInternal: function(effect) { 
    if(effect.options.to!!=0) return;
    effect.element.hide();
    effect.element.setStyle({opacity: oldOpacity}); 
  }}, arguments[1] || {});
  return new Effect.Opacity(element,options);
}

Effect.Appear = function(element) {
  element = $(element);
  var options = Object.extend({
  from: (element.getStyle(''display'') == ''none'' ? 0.0 : element.getOpacity() || 0.0),
  to:   1.0,
  // force Safari to render floated elements properly
  afterFinishInternal: function(effect) {
    effect.element.forceRerendering();
  },
  beforeSetup: function(effect) {
    effect.element.setOpacity(effect.options.from);
    effect.element.show(); 
  }}, arguments[1] || {});
  return new Effect.Opacity(element,options);
}

Effect.Puff = function(element) {
  element = $(element);
  var oldStyle = { opacity: element.getInlineOpacity(), position: element.getStyle(''position'') };
  return new Effect.Parallel(
   [ new Effect.Scale(element, 200, 
      { sync: true, scaleFromCenter: true, scaleContent: true, restoreAfterFinish: true }), 
     new Effect.Opacity(element, { sync: true, to: 0.0 } ) ], 
     Object.extend({ duration: 1.0, 
      beforeSetupInternal: function(effect) {
        effect.effects[0].element.setStyle({position: ''absolute''}); },
      afterFinishInternal: function(effect) {
         effect.effects[0].element.hide();
         effect.effects[0].element.setStyle(oldStyle); }
     }, arguments[1] || {})
   );
}

Effect.BlindUp = function(element) {
  element = $(element);
  element.makeClipping();
  return new Effect.Scale(element, 0, 
    Object.extend({ scaleContent: false, 
      scaleX: false, 
      restoreAfterFinish: true,
      afterFinishInternal: function(effect) {
        effect.element.hide();
        effect.element.undoClipping();
      } 
    }, arguments[1] || {})
  );
}

Effect.BlindDown = function(element) {
  element = $(element);
  var elementDimensions = element.getDimensions();
  return new Effect.Scale(element, 100, 
    Object.extend({ scaleContent: false, 
      scaleX: false,
      scaleFrom: 0,
      scaleMode: {originalHeight: elementDimensions.height, originalWidth: elementDimensions.width},
      restoreAfterFinish: true,
      afterSetup: function(effect) {
        effect.element.makeClipping();
        effect.element.setStyle({height: ''0px''});
        effect.element.show(); 
      },  
      afterFinishInternal: function(effect) {
        effect.element.undoClipping();
      }
    }, arguments[1] || {})
  );
}

Effect.SwitchOff = function(element) {
  element = $(element);
  var oldOpacity = element.getInlineOpacity();
  return new Effect.Appear(element, { 
    duration: 0.4,
    from: 0,
    transition: Effect.Transitions.flicker,
    afterFinishInternal: function(effect) {
      new Effect.Scale(effect.element, 1, { 
        duration: 0.3, scaleFromCenter: true,
        scaleX: false, scaleContent: false, restoreAfterFinish: true,
        beforeSetup: function(effect) { 
          effect.element.makePositioned();
          effect.element.makeClipping();
        },
        afterFinishInternal: function(effect) {
          effect.element.hide();
          effect.element.undoClipping();
          effect.element.undoPositioned();
          effect.element.setStyle({opacity: oldOpacity});
        }
      })
    }
  });
}

Effect.DropOut = function(element) {
  element = $(element);
  var oldStyle = {
    top: element.getStyle(''top''),
    left: element.getStyle(''left''),
    opacity: element.getInlineOpacity() };
  return new Effect.Parallel(
    [ new Effect.Move(element, {x: 0, y: 100, sync: true }), 
      new Effect.Opacity(element, { sync: true, to: 0.0 }) ],
    Object.extend(
      { duration: 0.5,
        beforeSetup: function(effect) {
          effect.effects[0].element.makePositioned(); 
        },
        afterFinishInternal: function(effect) {
          effect.effects[0].element.hide();
          effect.effects[0].element.undoPositioned();
          effect.effects[0].element.setStyle(oldStyle);
        } 
      }, arguments[1] || {}));
}

Effect.Shake = function(element) {
  element = $(element);
  var oldStyle = {
    top: element.getStyle(''top''),
    left: element.getStyle(''left'') };
    return new Effect.Move(element, 
      { x:  20, y: 0, duration: 0.05, afterFinishInternal: function(effect) {
    new Effect.Move(effect.element,
      { x: -40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
    new Effect.Move(effect.element,
      { x:  40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
    new Effect.Move(effect.element,
      { x: -40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
    new Effect.Move(effect.element,
      { x:  40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
    new Effect.Move(effect.element,
      { x: -20, y: 0, duration: 0.05, afterFinishInternal: function(effect) {
        effect.element.undoPositioned();
        effect.element.setStyle(oldStyle);
  }}) }}) }}) }}) }}) }});
}

Effect.SlideDown = function(element) {
  element = $(element);
  element.cleanWhitespace();
  // SlideDown need to have the content of the element wrapped in a container element with fixed height!!
  var oldInnerBottom = $(element.firstChild).getStyle(''bottom'');
  var elementDimensions = element.getDimensions();
  return new Effect.Scale(element, 100, Object.extend({ 
    scaleContent: false, 
    scaleX: false, 
    scaleFrom: window.opera ? 0 : 1,
    scaleMode: {originalHeight: elementDimensions.height, originalWidth: elementDimensions.width},
    restoreAfterFinish: true,
    afterSetup: function(effect) {
      effect.element.makePositioned();
      effect.element.firstChild.makePositioned();
      if(window.opera) effect.element.setStyle({top: ''''});
      effect.element.makeClipping();
      effect.element.setStyle({height: ''0px''});
      effect.element.show(); },
    afterUpdateInternal: function(effect) {
      effect.element.firstChild.setStyle({bottom:
        (effect.dims[0] - effect.element.clientHeight) + ''px'' }); 
    },
    afterFinishInternal: function(effect) {
      effect.element.undoClipping(); 
      // IE will crash if child is undoPositioned first
      if(/MSIE/.test(navigator.userAgent)){
        effect.element.undoPositioned();
        effect.element.firstChild.undoPositioned();
      }else{
        effect.element.firstChild.undoPositioned();
        effect.element.undoPositioned();
      }
      effect.element.firstChild.setStyle({bottom: oldInnerBottom}); }
    }, arguments[1] || {})
  );
}
  
Effect.SlideUp = function(element) {
  element = $(element);
  element.cleanWhitespace();
  var oldInnerBottom = $(element.firstChild).getStyle(''bottom'');
  return new Effect.Scale(element, window.opera ? 0 : 1,
   Object.extend({ scaleContent: false, 
    scaleX: false, 
    scaleMode: ''box'',
    scaleFrom: 100,
    restoreAfterFinish: true,
    beforeStartInternal: function(effect) {
      effect.element.makePositioned();
      effect.element.firstChild.makePositioned();
      if(window.opera) effect.element.setStyle({top: ''''});
      effect.element.makeClipping();
      effect.element.show(); },  
    afterUpdateInternal: function(effect) {
      effect.element.firstChild.setStyle({bottom:
        (effect.dims[0] - effect.element.clientHeight) + ''px'' }); },
    afterFinishInternal: function(effect) {
      effect.element.hide();
      effect.element.undoClipping();
      effect.element.firstChild.undoPositioned();
      effect.element.undoPositioned();
      effect.element.setStyle({bottom: oldInnerBottom}); }
   }, arguments[1] || {})
  );
}

// Bug in opera makes the TD containing this element expand for a instance after finish 
Effect.Squish = function(element) {
  return new Effect.Scale(element, window.opera ? 1 : 0, 
    { restoreAfterFinish: true,
      beforeSetup: function(effect) {
        effect.element.makeClipping(effect.element); },  
      afterFinishInternal: function(effect) {
        effect.element.hide(effect.element); 
        effect.element.undoClipping(effect.element); }
  });
}

Effect.Grow = function(element) {
  element = $(element);
  var options = Object.extend({
    direction: ''center'',
    moveTransition: Effect.Transitions.sinoidal,
    scaleTransition: Effect.Transitions.sinoidal,
    opacityTransition: Effect.Transitions.full
  }, arguments[1] || {});
  var oldStyle = {
    top: element.style.top,
    left: element.style.left,
    height: element.style.height,
    width: element.style.width,
    opacity: element.getInlineOpacity() };

  var dims = element.getDimensions();    
  var initialMoveX, initialMoveY;
  var moveX, moveY;
  
  switch (options.direction) {
    case ''top-left'':
      initialMoveX = initialMoveY = moveX = moveY = 0; 
      break;
    case ''top-right'':
      initialMoveX = dims.width;
      initialMoveY = moveY = 0;
      moveX = -dims.width;
      break;
    case ''bottom-left'':
      initialMoveX = moveX = 0;
      initialMoveY = dims.height;
      moveY = -dims.height;
      break;
    case ''bottom-right'':
      initialMoveX = dims.width;
      initialMoveY = dims.height;
      moveX = -dims.width;
      moveY = -dims.height;
      break;
    case ''center'':
      initialMoveX = dims.width / 2;
      initialMoveY = dims.height / 2;
      moveX = -dims.width / 2;
      moveY = -dims.height / 2;
      break;
  }
  
  return new Effect.Move(element, {
    x: initialMoveX,
    y: initialMoveY,
    duration: 0.01, 
    beforeSetup: function(effect) {
      effect.element.hide();
      effect.element.makeClipping();
      effect.element.makePositioned();
    },
    afterFinishInternal: function(effect) {
      new Effect.Parallel(
        [ new Effect.Opacity(effect.element, { sync: true, to: 1.0, from: 0.0, transition: options.opacityTransition }),
          new Effect.Move(effect.element, { x: moveX, y: moveY, sync: true, transition: options.moveTransition }),
          new Effect.Scale(effect.element, 100, {
            scaleMode: { originalHeight: dims.height, originalWidth: dims.width }, 
            sync: true, scaleFrom: window.opera ? 1 : 0, transition: options.scaleTransition, restoreAfterFinish: true})
        ], Object.extend({
             beforeSetup: function(effect) {
               effect.effects[0].element.setStyle({height: ''0px''});
               effect.effects[0].element.show(); 
             },
             afterFinishInternal: function(effect) {
               effect.effects[0].element.undoClipping();
               effect.effects[0].element.undoPositioned();
               effect.effects[0].element.setStyle(oldStyle); 
             }
           }, options)
      )
    }
  });
}

Effect.Shrink = function(element) {
  element = $(element);
  var options = Object.extend({
    direction: ''center'',
    moveTransition: Effect.Transitions.sinoidal,
    scaleTransition: Effect.Transitions.sinoidal,
    opacityTransition: Effect.Transitions.none
  }, arguments[1] || {});
  var oldStyle = {
    top: element.style.top,
    left: element.style.left,
    height: element.style.height,
    width: element.style.width,
    opacity: element.getInlineOpacity() };

  var dims = element.getDimensions();
  var moveX, moveY;
  
  switch (options.direction) {
    case ''top-left'':
      moveX = moveY = 0;
      break;
    case ''top-right'':
      moveX = dims.width;
      moveY = 0;
      break;
    case ''bottom-left'':
      moveX = 0;
      moveY = dims.height;
      break;
    case ''bottom-right'':
      moveX = dims.width;
      moveY = dims.height;
      break;
    case ''center'':  
      moveX = dims.width / 2;
      moveY = dims.height / 2;
      break;
  }
  
  return new Effect.Parallel(
    [ new Effect.Opacity(element, { sync: true, to: 0.0, from: 1.0, transition: options.opacityTransition }),
      new Effect.Scale(element, window.opera ? 1 : 0, { sync: true, transition: options.scaleTransition, restoreAfterFinish: true}),
      new Effect.Move(element, { x: moveX, y: moveY, sync: true, transition: options.moveTransition })
    ], Object.extend({            
         beforeStartInternal: function(effect) {
           effect.effects[0].element.makePositioned();
           effect.effects[0].element.makeClipping(); },
         afterFinishInternal: function(effect) {
           effect.effects[0].element.hide();
           effect.effects[0].element.undoClipping();
           effect.effects[0].element.undoPositioned();
           effect.effects[0].element.setStyle(oldStyle); }
       }, options)
  );
}

Effect.Pulsate = function(element) {
  element = $(element);
  var options    = arguments[1] || {};
  var oldOpacity = element.getInlineOpacity();
  var transition = options.transition || Effect.Transitions.sinoidal;
  var reverser   = function(pos){ return transition(1-Effect.Transitions.pulse(pos)) };
  reverser.bind(transition);
  return new Effect.Opacity(element, 
    Object.extend(Object.extend({  duration: 3.0, from: 0,
      afterFinishInternal: function(effect) { effect.element.setStyle({opacity: oldOpacity}); }
    }, options), {transition: reverser}));
}

Effect.Fold = function(element) {
  element = $(element);
  var oldStyle = {
    top: element.style.top,
    left: element.style.left,
    width: element.style.width,
    height: element.style.height };
  Element.makeClipping(element);
  return new Effect.Scale(element, 5, Object.extend({   
    scaleContent: false,
    scaleX: false,
    afterFinishInternal: function(effect) {
    new Effect.Scale(element, 1, { 
      scaleContent: false, 
      scaleY: false,
      afterFinishInternal: function(effect) {
        effect.element.hide();
        effect.element.undoClipping(); 
        effect.element.setStyle(oldStyle);
      } });
  }}, arguments[1] || {}));
};

[''setOpacity'',''getOpacity'',''getInlineOpacity'',''forceRerendering'',''setContentZoom'',
 ''collectTextNodes'',''collectTextNodesIgnoreClass'',''childrenWithClassName''].each( 
  function(f) { Element.Methods[f] = Element[f]; }
);

Element.Methods.visualEffect = function(element, effect, options) {
  s = effect.gsub(/_/, ''-'').camelize();
  effect_class = s.charAt(0).toUpperCase() + s.substring(1);
  new Effect[effect_class](element, options);
  return $(element);
};

Element.addMethods();'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 4/6/2006 23:24'!
dDragDrop
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
//           (c) 2005 Sammi Williams (http://www.oriontransfer.co.nz, sammi@oriontransfer.co.nz)
// 
// See scriptaculous.js for full license.

/*--------------------------------------------------------------------------*/

var Droppables = {
  drops: [],

  remove: function(element) {
    this.drops = this.drops.reject(function(d) { return d.element==$(element) });
  },

  add: function(element) {
    element = $(element);
    var options = Object.extend({
      greedy:     true,
      hoverclass: null,
      tree:       false
    }, arguments[1] || {});

    // cache containers
    if(options.containment) {
      options._containers = [];
      var containment = options.containment;
      if((typeof containment == ''object'') && 
        (containment.constructor == Array)) {
        containment.each( function(c) { options._containers.push($(c)) });
      } else {
        options._containers.push($(containment));
      }
    }
    
    if(options.accept) options.accept = [options.accept].flatten();

    Element.makePositioned(element); // fix IE
    options.element = element;

    this.drops.push(options);
  },
  
  findDeepestChild: function(drops) {
    deepest = drops[0];
      
    for (i = 1; i < drops.length; ++i)
      if (Element.isParent(drops[i].element, deepest.element))
        deepest = drops[i];
    
    return deepest;
  },

  isContained: function(element, drop) {
    var containmentNode;
    if(drop.tree) {
      containmentNode = element.treeNode; 
    } else {
      containmentNode = element.parentNode;
    }
    return drop._containers.detect(function(c) { return containmentNode == c });
  },
  
  isAffected: function(point, element, drop) {
    return (
      (drop.element!!=element) &&
      ((!!drop._containers) ||
        this.isContained(element, drop)) &&
      ((!!drop.accept) ||
        (Element.classNames(element).detect( 
          function(v) { return drop.accept.include(v) } ) )) &&
      Position.within(drop.element, point[0], point[1]) );
  },

  deactivate: function(drop) {
    if(drop.hoverclass)
      Element.removeClassName(drop.element, drop.hoverclass);
    this.last_active = null;
  },

  activate: function(drop) {
    if(drop.hoverclass)
      Element.addClassName(drop.element, drop.hoverclass);
    this.last_active = drop;
  },

  show: function(point, element) {
    if(!!this.drops.length) return;
    var affected = [];
    
    if(this.last_active) this.deactivate(this.last_active);
    this.drops.each( function(drop) {
      if(Droppables.isAffected(point, element, drop))
        affected.push(drop);
    });
        
    if(affected.length>0) {
      drop = Droppables.findDeepestChild(affected);
      Position.within(drop.element, point[0], point[1]);
      if(drop.onHover)
        drop.onHover(element, drop.element, Position.overlap(drop.overlap, drop.element));
      
      Droppables.activate(drop);
    }
  },

  fire: function(event, element) {
    if(!!this.last_active) return;
    Position.prepare();

    if (this.isAffected([Event.pointerX(event), Event.pointerY(event)], element, this.last_active))
      if (this.last_active.onDrop) 
        this.last_active.onDrop(element, this.last_active.element, event);
  },

  reset: function() {
    if(this.last_active)
      this.deactivate(this.last_active);
  }
}

var Draggables = {
  drags: [],
  observers: [],
  
  register: function(draggable) {
    if(this.drags.length == 0) {
      this.eventMouseUp   = this.endDrag.bindAsEventListener(this);
      this.eventMouseMove = this.updateDrag.bindAsEventListener(this);
      this.eventKeypress  = this.keyPress.bindAsEventListener(this);
      
      Event.observe(document, "mouseup", this.eventMouseUp);
      Event.observe(document, "mousemove", this.eventMouseMove);
      Event.observe(document, "keypress", this.eventKeypress);
    }
    this.drags.push(draggable);
  },
  
  unregister: function(draggable) {
    this.drags = this.drags.reject(function(d) { return d==draggable });
    if(this.drags.length == 0) {
      Event.stopObserving(document, "mouseup", this.eventMouseUp);
      Event.stopObserving(document, "mousemove", this.eventMouseMove);
      Event.stopObserving(document, "keypress", this.eventKeypress);
    }
  },
  
  activate: function(draggable) {
    window.focus(); // allows keypress events if window isn''t currently focused, fails for Safari
    this.activeDraggable = draggable;
  },
  
  deactivate: function() {
    this.activeDraggable = null;
  },
  
  updateDrag: function(event) {
    if(!!this.activeDraggable) return;
    var pointer = [Event.pointerX(event), Event.pointerY(event)];
    // Mozilla-based browsers fire successive mousemove events with
    // the same coordinates, prevent needless redrawing (moz bug?)
    if(this._lastPointer && (this._lastPointer.inspect() == pointer.inspect())) return;
    this._lastPointer = pointer;
    this.activeDraggable.updateDrag(event, pointer);
  },
  
  endDrag: function(event) {
    if(!!this.activeDraggable) return;
    this._lastPointer = null;
    this.activeDraggable.endDrag(event);
    this.activeDraggable = null;
  },
  
  keyPress: function(event) {
    if(this.activeDraggable)
      this.activeDraggable.keyPress(event);
  },
  
  addObserver: function(observer) {
    this.observers.push(observer);
    this._cacheObserverCallbacks();
  },
  
  removeObserver: function(element) {  // element instead of observer fixes mem leaks
    this.observers = this.observers.reject( function(o) { return o.element==element });
    this._cacheObserverCallbacks();
  },
  
  notify: function(eventName, draggable, event) {  // ''onStart'', ''onEnd'', ''onDrag''
    if(this[eventName+''Count''] > 0)
      this.observers.each( function(o) {
        if(o[eventName]) o[eventName](eventName, draggable, event);
      });
  },
  
  _cacheObserverCallbacks: function() {
    [''onStart'',''onEnd'',''onDrag''].each( function(eventName) {
      Draggables[eventName+''Count''] = Draggables.observers.select(
        function(o) { return o[eventName]; }
      ).length;
    });
  }
}

/*--------------------------------------------------------------------------*/

var Draggable = Class.create();
Draggable.prototype = {
  initialize: function(element) {
    var options = Object.extend({
      handle: false,
      starteffect: function(element) {
        element._opacity = Element.getOpacity(element); 
        new Effect.Opacity(element, {duration:0.2, from:element._opacity, to:0.7}); 
      },
      reverteffect: function(element, top_offset, left_offset) {
        var dur = Math.sqrt(Math.abs(top_offset^2)+Math.abs(left_offset^2))*0.02;
        element._revert = new Effect.Move(element, { x: -left_offset, y: -top_offset, duration: dur});
      },
      endeffect: function(element) {
        var toOpacity = typeof element._opacity == ''number'' ? element._opacity : 1.0
        new Effect.Opacity(element, {duration:0.2, from:0.7, to:toOpacity}); 
      },
      zindex: 1000,
      revert: false,
      scroll: false,
      scrollSensitivity: 20,
      scrollSpeed: 15,
      snap: false   // false, or xy or [x,y] or function(x,y){ return [x,y] }
    }, arguments[1] || {});

    this.element = $(element);
    
    if(options.handle && (typeof options.handle == ''string'')) {
      var h = Element.childrenWithClassName(this.element, options.handle, true);
      if(h.length>0) this.handle = h[0];
    }
    if(!!this.handle) this.handle = $(options.handle);
    if(!!this.handle) this.handle = this.element;
    
    if(options.scroll && !!options.scroll.scrollTo && !!options.scroll.outerHTML)
      options.scroll = $(options.scroll);

    Element.makePositioned(this.element); // fix IE    

    this.delta    = this.currentDelta();
    this.options  = options;
    this.dragging = false;   

    this.eventMouseDown = this.initDrag.bindAsEventListener(this);
    Event.observe(this.handle, "mousedown", this.eventMouseDown);
    
    Draggables.register(this);
  },
  
  destroy: function() {
    Event.stopObserving(this.handle, "mousedown", this.eventMouseDown);
    Draggables.unregister(this);
  },
  
  currentDelta: function() {
    return([
      parseInt(Element.getStyle(this.element,''left'') || ''0''),
      parseInt(Element.getStyle(this.element,''top'') || ''0'')]);
  },
  
  initDrag: function(event) {
    if(Event.isLeftClick(event)) {    
      // abort on form elements, fixes a Firefox issue
      var src = Event.element(event);
      if(src.tagName && (
        src.tagName==''INPUT'' ||
        src.tagName==''SELECT'' ||
        src.tagName==''OPTION'' ||
        src.tagName==''BUTTON'' ||
        src.tagName==''TEXTAREA'')) return;
        
      if(this.element._revert) {
        this.element._revert.cancel();
        this.element._revert = null;
      }
      
      var pointer = [Event.pointerX(event), Event.pointerY(event)];
      var pos     = Position.cumulativeOffset(this.element);
      this.offset = [0,1].map( function(i) { return (pointer[i] - pos[i]) });
      
      Draggables.activate(this);
      Event.stop(event);
    }
  },
  
  startDrag: function(event) {
    this.dragging = true;
    
    if(this.options.zindex) {
      this.originalZ = parseInt(Element.getStyle(this.element,''z-index'') || 0);
      this.element.style.zIndex = this.options.zindex;
    }
    
    if(this.options.ghosting) {
      this._clone = this.element.cloneNode(true);
      Position.absolutize(this.element);
      this.element.parentNode.insertBefore(this._clone, this.element);
    }
    
    if(this.options.scroll) {
      if (this.options.scroll == window) {
        var where = this._getWindowScroll(this.options.scroll);
        this.originalScrollLeft = where.left;
        this.originalScrollTop = where.top;
      } else {
        this.originalScrollLeft = this.options.scroll.scrollLeft;
        this.originalScrollTop = this.options.scroll.scrollTop;
      }
    }
    
    Draggables.notify(''onStart'', this, event);
    if(this.options.starteffect) this.options.starteffect(this.element);
  },
  
  updateDrag: function(event, pointer) {
    if(!!this.dragging) this.startDrag(event);
    Position.prepare();
    Droppables.show(pointer, this.element);
    Draggables.notify(''onDrag'', this, event);
    this.draw(pointer);
    if(this.options.change) this.options.change(this);
    
    if(this.options.scroll) {
      this.stopScrolling();
      
      var p;
      if (this.options.scroll == window) {
        with(this._getWindowScroll(this.options.scroll)) { p = [ left, top, left+width, top+height ]; }
      } else {
        p = Position.page(this.options.scroll);
        p[0] += this.options.scroll.scrollLeft;
        p[1] += this.options.scroll.scrollTop;
        p.push(p[0]+this.options.scroll.offsetWidth);
        p.push(p[1]+this.options.scroll.offsetHeight);
      }
      var speed = [0,0];
      if(pointer[0] < (p[0]+this.options.scrollSensitivity)) speed[0] = pointer[0]-(p[0]+this.options.scrollSensitivity);
      if(pointer[1] < (p[1]+this.options.scrollSensitivity)) speed[1] = pointer[1]-(p[1]+this.options.scrollSensitivity);
      if(pointer[0] > (p[2]-this.options.scrollSensitivity)) speed[0] = pointer[0]-(p[2]-this.options.scrollSensitivity);
      if(pointer[1] > (p[3]-this.options.scrollSensitivity)) speed[1] = pointer[1]-(p[3]-this.options.scrollSensitivity);
      this.startScrolling(speed);
    }
    
    // fix AppleWebKit rendering
    if(navigator.appVersion.indexOf(''AppleWebKit'')>0) window.scrollBy(0,0);
    
    Event.stop(event);
  },
  
  finishDrag: function(event, success) {
    this.dragging = false;

    if(this.options.ghosting) {
      Position.relativize(this.element);
      Element.remove(this._clone);
      this._clone = null;
    }

    if(success) Droppables.fire(event, this.element);
    Draggables.notify(''onEnd'', this, event);

    var revert = this.options.revert;
    if(revert && typeof revert == ''function'') revert = revert(this.element);
    
    var d = this.currentDelta();
    if(revert && this.options.reverteffect) {
      this.options.reverteffect(this.element, 
        d[1]-this.delta[1], d[0]-this.delta[0]);
    } else {
      this.delta = d;
    }

    if(this.options.zindex)
      this.element.style.zIndex = this.originalZ;

    if(this.options.endeffect) 
      this.options.endeffect(this.element);

    Draggables.deactivate(this);
    Droppables.reset();
  },
  
  keyPress: function(event) {
    if(event.keyCode!!=Event.KEY_ESC) return;
    this.finishDrag(event, false);
    Event.stop(event);
  },
  
  endDrag: function(event) {
    if(!!this.dragging) return;
    this.stopScrolling();
    this.finishDrag(event, true);
    Event.stop(event);
  },
  
  draw: function(point) {
    var pos = Position.cumulativeOffset(this.element);
    var d = this.currentDelta();
    pos[0] -= d[0]; pos[1] -= d[1];
    
    if(this.options.scroll && (this.options.scroll !!= window)) {
      pos[0] -= this.options.scroll.scrollLeft-this.originalScrollLeft;
      pos[1] -= this.options.scroll.scrollTop-this.originalScrollTop;
    }
    
    var p = [0,1].map(function(i){ 
      return (point[i]-pos[i]-this.offset[i]) 
    }.bind(this));
    
    if(this.options.snap) {
      if(typeof this.options.snap == ''function'') {
        p = this.options.snap(p[0],p[1],this);
      } else {
      if(this.options.snap instanceof Array) {
        p = p.map( function(v, i) {
          return Math.round(v/this.options.snap[i])*this.options.snap[i] }.bind(this))
      } else {
        p = p.map( function(v) {
          return Math.round(v/this.options.snap)*this.options.snap }.bind(this))
      }
    }}
    
    var style = this.element.style;
    if((!!this.options.constraint) || (this.options.constraint==''horizontal''))
      style.left = p[0] + "px";
    if((!!this.options.constraint) || (this.options.constraint==''vertical''))
      style.top  = p[1] + "px";
    if(style.visibility=="hidden") style.visibility = ""; // fix gecko rendering
  },
  
  stopScrolling: function() {
    if(this.scrollInterval) {
      clearInterval(this.scrollInterval);
      this.scrollInterval = null;
      Draggables._lastScrollPointer = null;
    }
  },
  
  startScrolling: function(speed) {
    this.scrollSpeed = [speed[0]*this.options.scrollSpeed,speed[1]*this.options.scrollSpeed];
    this.lastScrolled = new Date();
    this.scrollInterval = setInterval(this.scroll.bind(this), 10);
  },
  
  scroll: function() {
    var current = new Date();
    var delta = current - this.lastScrolled;
    this.lastScrolled = current;
    if(this.options.scroll == window) {
      with (this._getWindowScroll(this.options.scroll)) {
        if (this.scrollSpeed[0] || this.scrollSpeed[1]) {
          var d = delta / 1000;
          this.options.scroll.scrollTo( left + d*this.scrollSpeed[0], top + d*this.scrollSpeed[1] );
        }
      }
    } else {
      this.options.scroll.scrollLeft += this.scrollSpeed[0] * delta / 1000;
      this.options.scroll.scrollTop  += this.scrollSpeed[1] * delta / 1000;
    }
    
    Position.prepare();
    Droppables.show(Draggables._lastPointer, this.element);
    Draggables.notify(''onDrag'', this);
    Draggables._lastScrollPointer = Draggables._lastScrollPointer || $A(Draggables._lastPointer);
    Draggables._lastScrollPointer[0] += this.scrollSpeed[0] * delta / 1000;
    Draggables._lastScrollPointer[1] += this.scrollSpeed[1] * delta / 1000;
    if (Draggables._lastScrollPointer[0] < 0)
      Draggables._lastScrollPointer[0] = 0;
    if (Draggables._lastScrollPointer[1] < 0)
      Draggables._lastScrollPointer[1] = 0;
    this.draw(Draggables._lastScrollPointer);
    
    if(this.options.change) this.options.change(this);
  },
  
  _getWindowScroll: function(w) {
    var T, L, W, H;
    with (w.document) {
      if (w.document.documentElement && documentElement.scrollTop) {
        T = documentElement.scrollTop;
        L = documentElement.scrollLeft;
      } else if (w.document.body) {
        T = body.scrollTop;
        L = body.scrollLeft;
      }
      if (w.innerWidth) {
        W = w.innerWidth;
        H = w.innerHeight;
      } else if (w.document.documentElement && documentElement.clientWidth) {
        W = documentElement.clientWidth;
        H = documentElement.clientHeight;
      } else {
        W = body.offsetWidth;
        H = body.offsetHeight
      }
    }
    return { top: T, left: L, width: W, height: H };
  }
}

/*--------------------------------------------------------------------------*/

var SortableObserver = Class.create();
SortableObserver.prototype = {
  initialize: function(element, observer) {
    this.element   = $(element);
    this.observer  = observer;
    this.lastValue = Sortable.serialize(this.element);
  },
  
  onStart: function() {
    this.lastValue = Sortable.serialize(this.element);
  },
  
  onEnd: function() {
    Sortable.unmark();
    if(this.lastValue !!= Sortable.serialize(this.element))
      this.observer(this.element)
  }
}

var Sortable = {
  sortables: {},
  
  _findRootElement: function(element) {
    while (element.tagName !!= "BODY") {  
      if(element.id && Sortable.sortables[element.id]) return element;
      element = element.parentNode;
    }
  },

  options: function(element) {
    element = Sortable._findRootElement($(element));
    if(!!element) return;
    return Sortable.sortables[element.id];
  },
  
  destroy: function(element){
    var s = Sortable.options(element);
    
    if(s) {
      Draggables.removeObserver(s.element);
      s.droppables.each(function(d){ Droppables.remove(d) });
      s.draggables.invoke(''destroy'');
      
      delete Sortable.sortables[s.element.id];
    }
  },

  create: function(element) {
    element = $(element);
    var options = Object.extend({ 
      element:     element,
      tag:         ''li'',       // assumes li children, override with tag: ''tagname''
      dropOnEmpty: false,
      tree:        false,
      treeTag:     ''ul'',
      overlap:     ''vertical'', // one of ''vertical'', ''horizontal''
      constraint:  ''vertical'', // one of ''vertical'', ''horizontal'', false
      containment: element,    // also takes array of elements (or id''s); or false
      handle:      false,      // or a CSS class
      only:        false,
      hoverclass:  null,
      ghosting:    false,
      scroll:      false,
      scrollSensitivity: 20,
      scrollSpeed: 15,
      format:      /^[^_]*_(.*)$/,
      onChange:    Prototype.emptyFunction,
      onUpdate:    Prototype.emptyFunction
    }, arguments[1] || {});

    // clear any old sortable with same element
    this.destroy(element);

    // build options for the draggables
    var options_for_draggable = {
      revert:      true,
      scroll:      options.scroll,
      scrollSpeed: options.scrollSpeed,
      scrollSensitivity: options.scrollSensitivity,
      ghosting:    options.ghosting,
      constraint:  options.constraint,
      handle:      options.handle };

    if(options.starteffect)
      options_for_draggable.starteffect = options.starteffect;

    if(options.reverteffect)
      options_for_draggable.reverteffect = options.reverteffect;
    else
      if(options.ghosting) options_for_draggable.reverteffect = function(element) {
        element.style.top  = 0;
        element.style.left = 0;
      };

    if(options.endeffect)
      options_for_draggable.endeffect = options.endeffect;

    if(options.zindex)
      options_for_draggable.zindex = options.zindex;

    // build options for the droppables  
    var options_for_droppable = {
      overlap:     options.overlap,
      containment: options.containment,
      tree:        options.tree,
      hoverclass:  options.hoverclass,
      onHover:     Sortable.onHover
      //greedy:      !!options.dropOnEmpty
    }
    
    var options_for_tree = {
      onHover:      Sortable.onEmptyHover,
      overlap:      options.overlap,
      containment:  options.containment,
      hoverclass:   options.hoverclass
    }

    // fix for gecko engine
    Element.cleanWhitespace(element); 

    options.draggables = [];
    options.droppables = [];

    // drop on empty handling
    if(options.dropOnEmpty || options.tree) {
      Droppables.add(element, options_for_tree);
      options.droppables.push(element);
    }

    (this.findElements(element, options) || []).each( function(e) {
      // handles are per-draggable
      var handle = options.handle ? 
        Element.childrenWithClassName(e, options.handle)[0] : e;    
      options.draggables.push(
        new Draggable(e, Object.extend(options_for_draggable, { handle: handle })));
      Droppables.add(e, options_for_droppable);
      if(options.tree) e.treeNode = element;
      options.droppables.push(e);      
    });
    
    if(options.tree) {
      (Sortable.findTreeElements(element, options) || []).each( function(e) {
        Droppables.add(e, options_for_tree);
        e.treeNode = element;
        options.droppables.push(e);
      });
    }

    // keep reference
    this.sortables[element.id] = options;

    // for onupdate
    Draggables.addObserver(new SortableObserver(element, options.onUpdate));

  },

  // return all suitable-for-sortable elements in a guaranteed order
  findElements: function(element, options) {
    return Element.findChildren(
      element, options.only, options.tree ? true : false, options.tag);
  },
  
  findTreeElements: function(element, options) {
    return Element.findChildren(
      element, options.only, options.tree ? true : false, options.treeTag);
  },

  onHover: function(element, dropon, overlap) {
    if(Element.isParent(dropon, element)) return;

    if(overlap > .33 && overlap < .66 && Sortable.options(dropon).tree) {
      return;
    } else if(overlap>0.5) {
      Sortable.mark(dropon, ''before'');
      if(dropon.previousSibling !!= element) {
        var oldParentNode = element.parentNode;
        element.style.visibility = "hidden"; // fix gecko rendering
        dropon.parentNode.insertBefore(element, dropon);
        if(dropon.parentNode!!=oldParentNode) 
          Sortable.options(oldParentNode).onChange(element);
        Sortable.options(dropon.parentNode).onChange(element);
      }
    } else {
      Sortable.mark(dropon, ''after'');
      var nextElement = dropon.nextSibling || null;
      if(nextElement !!= element) {
        var oldParentNode = element.parentNode;
        element.style.visibility = "hidden"; // fix gecko rendering
        dropon.parentNode.insertBefore(element, nextElement);
        if(dropon.parentNode!!=oldParentNode) 
          Sortable.options(oldParentNode).onChange(element);
        Sortable.options(dropon.parentNode).onChange(element);
      }
    }
  },
  
  onEmptyHover: function(element, dropon, overlap) {
    var oldParentNode = element.parentNode;
    var droponOptions = Sortable.options(dropon);
        
    if(!!Element.isParent(dropon, element)) {
      var index;
      
      var children = Sortable.findElements(dropon, {tag: droponOptions.tag});
      var child = null;
            
      if(children) {
        var offset = Element.offsetSize(dropon, droponOptions.overlap) * (1.0 - overlap);
        
        for (index = 0; index < children.length; index += 1) {
          if (offset - Element.offsetSize (children[index], droponOptions.overlap) >= 0) {
            offset -= Element.offsetSize (children[index], droponOptions.overlap);
          } else if (offset - (Element.offsetSize (children[index], droponOptions.overlap) / 2) >= 0) {
            child = index + 1 < children.length ? children[index + 1] : null;
            break;
          } else {
            child = children[index];
            break;
          }
        }
      }
      
      dropon.insertBefore(element, child);
      
      Sortable.options(oldParentNode).onChange(element);
      droponOptions.onChange(element);
    }
  },

  unmark: function() {
    if(Sortable._marker) Element.hide(Sortable._marker);
  },

  mark: function(dropon, position) {
    // mark on ghosting only
    var sortable = Sortable.options(dropon.parentNode);
    if(sortable && !!sortable.ghosting) return; 

    if(!!Sortable._marker) {
      Sortable._marker = $(''dropmarker'') || document.createElement(''DIV'');
      Element.hide(Sortable._marker);
      Element.addClassName(Sortable._marker, ''dropmarker'');
      Sortable._marker.style.position = ''absolute'';
      document.getElementsByTagName("body").item(0).appendChild(Sortable._marker);
    }    
    var offsets = Position.cumulativeOffset(dropon);
    Sortable._marker.style.left = offsets[0] + ''px'';
    Sortable._marker.style.top = offsets[1] + ''px'';
    
    if(position==''after'')
      if(sortable.overlap == ''horizontal'') 
        Sortable._marker.style.left = (offsets[0]+dropon.clientWidth) + ''px'';
      else
        Sortable._marker.style.top = (offsets[1]+dropon.clientHeight) + ''px'';
    
    Element.show(Sortable._marker);
  },
  
  _tree: function(element, options, parent) {
    var children = Sortable.findElements(element, options) || [];
  
    for (var i = 0; i < children.length; ++i) {
      var match = children[i].id.match(options.format);

      if (!!match) continue;
      
      var child = {
        id: encodeURIComponent(match ? match[1] : null),
        element: element,
        parent: parent,
        children: new Array,
        position: parent.children.length,
        container: Sortable._findChildrenElement(children[i], options.treeTag.toUpperCase())
      }
      
      /* Get the element containing the children and recurse over it */
      if (child.container)
        this._tree(child.container, options, child)
      
      parent.children.push (child);
    }

    return parent; 
  },

  /* Finds the first element of the given tag type within a parent element.
    Used for finding the first LI[ST] within a L[IST]I[TEM].*/
  _findChildrenElement: function (element, containerTag) {
    if (element && element.hasChildNodes)
      for (var i = 0; i < element.childNodes.length; ++i)
        if (element.childNodes[i].tagName == containerTag)
          return element.childNodes[i];
  
    return null;
  },

  tree: function(element) {
    element = $(element);
    var sortableOptions = this.options(element);
    var options = Object.extend({
      tag: sortableOptions.tag,
      treeTag: sortableOptions.treeTag,
      only: sortableOptions.only,
      name: element.id,
      format: sortableOptions.format
    }, arguments[1] || {});
    
    var root = {
      id: null,
      parent: null,
      children: new Array,
      container: element,
      position: 0
    }
    
    return Sortable._tree (element, options, root);
  },

  /* Construct a [i] index for a particular node */
  _constructIndex: function(node) {
    var index = '''';
    do {
      if (node.id) index = ''['' + node.position + '']'' + index;
    } while ((node = node.parent) !!= null);
    return index;
  },

  sequence: function(element) {
    element = $(element);
    var options = Object.extend(this.options(element), arguments[1] || {});
    
    return $(this.findElements(element, options) || []).map( function(item) {
      return item.id.match(options.format) ? item.id.match(options.format)[1] : '''';
    });
  },

  setSequence: function(element, new_sequence) {
    element = $(element);
    var options = Object.extend(this.options(element), arguments[2] || {});
    
    var nodeMap = {};
    this.findElements(element, options).each( function(n) {
        if (n.id.match(options.format))
            nodeMap[n.id.match(options.format)[1]] = [n, n.parentNode];
        n.parentNode.removeChild(n);
    });
   
    new_sequence.each(function(ident) {
      var n = nodeMap[ident];
      if (n) {
        n[1].appendChild(n[0]);
        delete nodeMap[ident];
      }
    });
  },
  
  serialize: function(element) {
    element = $(element);
    var options = Object.extend(Sortable.options(element), arguments[1] || {});
    var name = encodeURIComponent(
      (arguments[1] && arguments[1].name) ? arguments[1].name : element.id);
    
    if (options.tree) {
      return Sortable.tree(element, arguments[1]).children.map( function (item) {
        return [name + Sortable._constructIndex(item) + "=" + 
                encodeURIComponent(item.id)].concat(item.children.map(arguments.callee));
      }).flatten().join(''&'');
    } else {
      return Sortable.sequence(element, arguments[1]).map( function(item) {
        return name + "[]=" + encodeURIComponent(item);
      }).join(''&'');
    }
  }
}

/* Returns true if child is contained within element */
Element.isParent = function(child, element) {
  if (!!child.parentNode || child == element) return false;

  if (child.parentNode == element) return true;

  return Element.isParent(child.parentNode, element);
}

Element.findChildren = function(element, only, recursive, tagName) {    
  if(!!element.hasChildNodes()) return null;
  tagName = tagName.toUpperCase();
  if(only) only = [only].flatten();
  var elements = [];
  $A(element.childNodes).each( function(e) {
    if(e.tagName && e.tagName.toUpperCase()==tagName &&
      (!!only || (Element.classNames(e).detect(function(v) { return only.include(v) }))))
        elements.push(e);
    if(recursive) {
      var grandchildren = Element.findChildren(e, only, recursive, tagName);
      if(grandchildren) elements.push(grandchildren);
    }
  });

  return (elements.length>0 ? elements.flatten() : []);
}

Element.offsetSize = function (element, type) {
  if (type == ''vertical'' || type == ''height'')
    return element.offsetHeight;
  else
    return element.offsetWidth;
}'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 4/6/2006 23:25'!
eControls
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
//           (c) 2005 Ivan Krstic (http://blogs.law.harvard.edu/ivan)
//           (c) 2005 Jon Tirsen (http://www.tirsen.com)
// Contributors:
//  Richard Livsey
//  Rahul Bhargava
//  Rob Wills
// 
// See scriptaculous.js for full license.

// Autocompleter.Base handles all the autocompletion functionality 
// that''s independent of the data source for autocompletion. This
// includes drawing the autocompletion menu, observing keyboard
// and mouse events, and similar.
//
// Specific autocompleters need to provide, at the very least, 
// a getUpdatedChoices function that will be invoked every time
// the text inside the monitored textbox changes. This method 
// should get the text for which to provide autocompletion by
// invoking this.getToken(), NOT by directly accessing
// this.element.value. This is to allow incremental tokenized
// autocompletion. Specific auto-completion logic (AJAX, etc)
// belongs in getUpdatedChoices.
//
// Tokenized incremental autocompletion is enabled automatically
// when an autocompleter is instantiated with the ''tokens'' option
// in the options parameter, e.g.:
// new Ajax.Autocompleter(''id'',''upd'', ''/url/'', { tokens: '','' });
// will incrementally autocomplete with a comma as the token.
// Additionally, '','' in the above example can be replaced with
// a token array, e.g. { tokens: ['','', ''\n''] } which
// enables autocompletion on multiple tokens. This is most 
// useful when one of the tokens is \n (a newline), as it 
// allows smart autocompletion after linebreaks.

var Autocompleter = {}
Autocompleter.Base = function() {};
Autocompleter.Base.prototype = {
  baseInitialize: function(element, update, options) {
    this.element     = $(element); 
    this.update      = $(update);  
    this.hasFocus    = false; 
    this.changed     = false; 
    this.active      = false; 
    this.index       = 0;     
    this.entryCount  = 0;

    if (this.setOptions)
      this.setOptions(options);
    else
      this.options = options || {};

    this.options.paramName    = this.options.paramName || this.element.name;
    this.options.tokens       = this.options.tokens || [];
    this.options.frequency    = this.options.frequency || 0.4;
    this.options.minChars     = this.options.minChars || 1;
    this.options.onShow       = this.options.onShow || 
    function(element, update){ 
      if(!!update.style.position || update.style.position==''absolute'') {
        update.style.position = ''absolute'';
        Position.clone(element, update, {setHeight: false, offsetTop: element.offsetHeight});
      }
      Effect.Appear(update,{duration:0.15});
    };
    this.options.onHide = this.options.onHide || 
    function(element, update){ new Effect.Fade(update,{duration:0.15}) };

    if (typeof(this.options.tokens) == ''string'') 
      this.options.tokens = new Array(this.options.tokens);

    this.observer = null;
    
    this.element.setAttribute(''autocomplete'',''off'');

    Element.hide(this.update);

    Event.observe(this.element, "blur", this.onBlur.bindAsEventListener(this));
    Event.observe(this.element, "keypress", this.onKeyPress.bindAsEventListener(this));
  },

  show: function() {
    if(Element.getStyle(this.update, ''display'')==''none'') this.options.onShow(this.element, this.update);
    if(!!this.iefix && 
      (navigator.appVersion.indexOf(''MSIE'')>0) &&
      (navigator.userAgent.indexOf(''Opera'')<0) &&
      (Element.getStyle(this.update, ''position'')==''absolute'')) {
      new Insertion.After(this.update, 
       ''<iframe id="'' + this.update.id + ''_iefix" ''+
       ''style="display:none;position:absolute;filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0);" '' +
       ''src="javascript:false;" frameborder="0" scrolling="no"></iframe>'');
      this.iefix = $(this.update.id+''_iefix'');
    }
    if(this.iefix) setTimeout(this.fixIEOverlapping.bind(this), 50);
  },
  
  fixIEOverlapping: function() {
    Position.clone(this.update, this.iefix);
    this.iefix.style.zIndex = 1;
    this.update.style.zIndex = 2;
    Element.show(this.iefix);
  },

  hide: function() {
    this.stopIndicator();
    if(Element.getStyle(this.update, ''display'')!!=''none'') this.options.onHide(this.element, this.update);
    if(this.iefix) Element.hide(this.iefix);
  },

  startIndicator: function() {
    if(this.options.indicator) Element.show(this.options.indicator);
  },

  stopIndicator: function() {
    if(this.options.indicator) Element.hide(this.options.indicator);
  },

  onKeyPress: function(event) {
    if(this.active)
      switch(event.keyCode) {
       case Event.KEY_TAB:
       case Event.KEY_RETURN:
         this.selectEntry();
         Event.stop(event);
       case Event.KEY_ESC:
         this.hide();
         this.active = false;
         Event.stop(event);
         return;
       case Event.KEY_LEFT:
       case Event.KEY_RIGHT:
         return;
       case Event.KEY_UP:
         this.markPrevious();
         this.render();
         if(navigator.appVersion.indexOf(''AppleWebKit'')>0) Event.stop(event);
         return;
       case Event.KEY_DOWN:
         this.markNext();
         this.render();
         if(navigator.appVersion.indexOf(''AppleWebKit'')>0) Event.stop(event);
         return;
      }
     else 
       if(event.keyCode==Event.KEY_TAB || event.keyCode==Event.KEY_RETURN || 
         (navigator.appVersion.indexOf(''AppleWebKit'') > 0 && event.keyCode == 0)) return;

    this.changed = true;
    this.hasFocus = true;

    if(this.observer) clearTimeout(this.observer);
      this.observer = 
        setTimeout(this.onObserverEvent.bind(this), this.options.frequency*1000);
  },

  activate: function() {
    this.changed = false;
    this.hasFocus = true;
    this.getUpdatedChoices();
  },

  onHover: function(event) {
    var element = Event.findElement(event, ''LI'');
    if(this.index !!= element.autocompleteIndex) 
    {
        this.index = element.autocompleteIndex;
        this.render();
    }
    Event.stop(event);
  },
  
  onClick: function(event) {
    var element = Event.findElement(event, ''LI'');
    this.index = element.autocompleteIndex;
    this.selectEntry();
    this.hide();
  },
  
  onBlur: function(event) {
    // needed to make click events working
    setTimeout(this.hide.bind(this), 250);
    this.hasFocus = false;
    this.active = false;     
  }, 
  
  render: function() {
    if(this.entryCount > 0) {
      for (var i = 0; i < this.entryCount; i++)
        this.index==i ? 
          Element.addClassName(this.getEntry(i),"selected") : 
          Element.removeClassName(this.getEntry(i),"selected");
        
      if(this.hasFocus) { 
        this.show();
        this.active = true;
      }
    } else {
      this.active = false;
      this.hide();
    }
  },
  
  markPrevious: function() {
    if(this.index > 0) this.index--
      else this.index = this.entryCount-1;
  },
  
  markNext: function() {
    if(this.index < this.entryCount-1) this.index++
      else this.index = 0;
  },
  
  getEntry: function(index) {
    return this.update.firstChild.childNodes[index];
  },
  
  getCurrentEntry: function() {
    return this.getEntry(this.index);
  },
  
  selectEntry: function() {
    this.active = false;
    this.updateElement(this.getCurrentEntry());
  },

  updateElement: function(selectedElement) {
    if (this.options.updateElement) {
      this.options.updateElement(selectedElement);
      return;
    }
    var value = '''';
    if (this.options.select) {
      var nodes = document.getElementsByClassName(this.options.select, selectedElement) || [];
      if(nodes.length>0) value = Element.collectTextNodes(nodes[0], this.options.select);
    } else
      value = Element.collectTextNodesIgnoreClass(selectedElement, ''informal'');
    
    var lastTokenPos = this.findLastToken();
    if (lastTokenPos !!= -1) {
      var newValue = this.element.value.substr(0, lastTokenPos + 1);
      var whitespace = this.element.value.substr(lastTokenPos + 1).match(/^\s+/);
      if (whitespace)
        newValue += whitespace[0];
      this.element.value = newValue + value;
    } else {
      this.element.value = value;
    }
    this.element.focus();
    
    if (this.options.afterUpdateElement)
      this.options.afterUpdateElement(this.element, selectedElement);
  },

  updateChoices: function(choices) {
    if(!!this.changed && this.hasFocus) {
      this.update.innerHTML = choices;
      Element.cleanWhitespace(this.update);
      Element.cleanWhitespace(this.update.firstChild);

      if(this.update.firstChild && this.update.firstChild.childNodes) {
        this.entryCount = 
          this.update.firstChild.childNodes.length;
        for (var i = 0; i < this.entryCount; i++) {
          var entry = this.getEntry(i);
          entry.autocompleteIndex = i;
          this.addObservers(entry);
        }
      } else { 
        this.entryCount = 0;
      }

      this.stopIndicator();

      this.index = 0;
      this.render();
    }
  },

  addObservers: function(element) {
    Event.observe(element, "mouseover", this.onHover.bindAsEventListener(this));
    Event.observe(element, "click", this.onClick.bindAsEventListener(this));
  },

  onObserverEvent: function() {
    this.changed = false;   
    if(this.getToken().length>=this.options.minChars) {
      this.startIndicator();
      this.getUpdatedChoices();
    } else {
      this.active = false;
      this.hide();
    }
  },

  getToken: function() {
    var tokenPos = this.findLastToken();
    if (tokenPos !!= -1)
      var ret = this.element.value.substr(tokenPos + 1).replace(/^\s+/,'''').replace(/\s+$/,'''');
    else
      var ret = this.element.value;

    return /\n/.test(ret) ? '''' : ret;
  },

  findLastToken: function() {
    var lastTokenPos = -1;

    for (var i=0; i<this.options.tokens.length; i++) {
      var thisTokenPos = this.element.value.lastIndexOf(this.options.tokens[i]);
      if (thisTokenPos > lastTokenPos)
        lastTokenPos = thisTokenPos;
    }
    return lastTokenPos;
  }
}

Ajax.Autocompleter = Class.create();
Object.extend(Object.extend(Ajax.Autocompleter.prototype, Autocompleter.Base.prototype), {
  initialize: function(element, update, url, options) {
    this.baseInitialize(element, update, options);
    this.options.asynchronous  = true;
    this.options.onComplete    = this.onComplete.bind(this);
    this.options.defaultParams = this.options.parameters || null;
    this.url                   = url;
  },

  getUpdatedChoices: function() {
    entry = encodeURIComponent(this.options.paramName) + ''='' + 
      encodeURIComponent(this.getToken());

    this.options.parameters = this.options.callback ?
      this.options.callback(this.element, entry) : entry;

    if(this.options.defaultParams) 
      this.options.parameters += ''&'' + this.options.defaultParams;

    new Ajax.Request(this.url, this.options);
  },

  onComplete: function(request) {
    this.updateChoices(request.responseText);
  }

});

// The local array autocompleter. Used when you''d prefer to
// inject an array of autocompletion options into the page, rather
// than sending out Ajax queries, which can be quite slow sometimes.
//
// The constructor takes four parameters. The first two are, as usual,
// the id of the monitored textbox, and id of the autocompletion menu.
// The third is the array you want to autocomplete from, and the fourth
// is the options block.
//
// Extra local autocompletion options:
// - choices - How many autocompletion choices to offer
//
// - partialSearch - If false, the autocompleter will match entered
//                    text only at the beginning of strings in the 
//                    autocomplete array. Defaults to true, which will
//                    match text at the beginning of any *word* in the
//                    strings in the autocomplete array. If you want to
//                    search anywhere in the string, additionally set
//                    the option fullSearch to true (default: off).
//
// - fullSsearch - Search anywhere in autocomplete array strings.
//
// - partialChars - How many characters to enter before triggering
//                   a partial match (unlike minChars, which defines
//                   how many characters are required to do any match
//                   at all). Defaults to 2.
//
// - ignoreCase - Whether to ignore case when autocompleting.
//                 Defaults to true.
//
// It''s possible to pass in a custom function as the ''selector'' 
// option, if you prefer to write your own autocompletion logic.
// In that case, the other options above will not apply unless
// you support them.

Autocompleter.Local = Class.create();
Autocompleter.Local.prototype = Object.extend(new Autocompleter.Base(), {
  initialize: function(element, update, array, options) {
    this.baseInitialize(element, update, options);
    this.options.array = array;
  },

  getUpdatedChoices: function() {
    this.updateChoices(this.options.selector(this));
  },

  setOptions: function(options) {
    this.options = Object.extend({
      choices: 10,
      partialSearch: true,
      partialChars: 2,
      ignoreCase: true,
      fullSearch: false,
      selector: function(instance) {
        var ret       = []; // Beginning matches
        var partial   = []; // Inside matches
        var entry     = instance.getToken();
        var count     = 0;

        for (var i = 0; i < instance.options.array.length &&  
          ret.length < instance.options.choices ; i++) { 

          var elem = instance.options.array[i];
          var foundPos = instance.options.ignoreCase ? 
            elem.toLowerCase().indexOf(entry.toLowerCase()) : 
            elem.indexOf(entry);

          while (foundPos !!= -1) {
            if (foundPos == 0 && elem.length !!= entry.length) { 
              ret.push("<li><strong>" + elem.substr(0, entry.length) + "</strong>" + 
                elem.substr(entry.length) + "</li>");
              break;
            } else if (entry.length >= instance.options.partialChars && 
              instance.options.partialSearch && foundPos !!= -1) {
              if (instance.options.fullSearch || /\s/.test(elem.substr(foundPos-1,1))) {
                partial.push("<li>" + elem.substr(0, foundPos) + "<strong>" +
                  elem.substr(foundPos, entry.length) + "</strong>" + elem.substr(
                  foundPos + entry.length) + "</li>");
                break;
              }
            }

            foundPos = instance.options.ignoreCase ? 
              elem.toLowerCase().indexOf(entry.toLowerCase(), foundPos + 1) : 
              elem.indexOf(entry, foundPos + 1);

          }
        }
        if (partial.length)
          ret = ret.concat(partial.slice(0, instance.options.choices - ret.length))
        return "<ul>" + ret.join('''') + "</ul>";
      }
    }, options || {});
  }
});

// AJAX in-place editor
//
// see documentation on http://wiki.script.aculo.us/scriptaculous/show/Ajax.InPlaceEditor

// Use this if you notice weird scrolling problems on some browsers,
// the DOM might be a bit confused when this gets called so do this
// waits 1 ms (with setTimeout) until it does the activation
Field.scrollFreeActivate = function(field) {
  setTimeout(function() {
    Field.activate(field);
  }, 1);
}

Ajax.InPlaceEditor = Class.create();
Ajax.InPlaceEditor.defaultHighlightColor = "#FFFF99";
Ajax.InPlaceEditor.prototype = {
  initialize: function(element, url, options) {
    this.url = url;
    this.element = $(element);

    this.options = Object.extend({
      okButton: true,
      okText: "ok",
      cancelLink: true,
      cancelText: "cancel",
      savingText: "Saving...",
      clickToEditText: "Click to edit",
      okText: "ok",
      rows: 1,
      onComplete: function(transport, element) {
        new Effect.Highlight(element, {startcolor: this.options.highlightcolor});
      },
      onFailure: function(transport) {
        alert("Error communicating with the server: " + transport.responseText.stripTags());
      },
      callback: function(form) {
        return Form.serialize(form);
      },
      handleLineBreaks: true,
      loadingText: ''Loading...'',
      savingClassName: ''inplaceeditor-saving'',
      loadingClassName: ''inplaceeditor-loading'',
      formClassName: ''inplaceeditor-form'',
      highlightcolor: Ajax.InPlaceEditor.defaultHighlightColor,
      highlightendcolor: "#FFFFFF",
      externalControl: null,
      submitOnBlur: false,
      ajaxOptions: {},
      evalScripts: false
    }, options || {});

    if(!!this.options.formId && this.element.id) {
      this.options.formId = this.element.id + "-inplaceeditor";
      if ($(this.options.formId)) {
        // there''s already a form with that name, don''t specify an id
        this.options.formId = null;
      }
    }
    
    if (this.options.externalControl) {
      this.options.externalControl = $(this.options.externalControl);
    }
    
    this.originalBackground = Element.getStyle(this.element, ''background-color'');
    if (!!this.originalBackground) {
      this.originalBackground = "transparent";
    }
    
    this.element.title = this.options.clickToEditText;
    
    this.onclickListener = this.enterEditMode.bindAsEventListener(this);
    this.mouseoverListener = this.enterHover.bindAsEventListener(this);
    this.mouseoutListener = this.leaveHover.bindAsEventListener(this);
    Event.observe(this.element, ''click'', this.onclickListener);
    Event.observe(this.element, ''mouseover'', this.mouseoverListener);
    Event.observe(this.element, ''mouseout'', this.mouseoutListener);
    if (this.options.externalControl) {
      Event.observe(this.options.externalControl, ''click'', this.onclickListener);
      Event.observe(this.options.externalControl, ''mouseover'', this.mouseoverListener);
      Event.observe(this.options.externalControl, ''mouseout'', this.mouseoutListener);
    }
  },
  enterEditMode: function(evt) {
    if (this.saving) return;
    if (this.editing) return;
    this.editing = true;
    this.onEnterEditMode();
    if (this.options.externalControl) {
      Element.hide(this.options.externalControl);
    }
    Element.hide(this.element);
    this.createForm();
    this.element.parentNode.insertBefore(this.form, this.element);
    Field.scrollFreeActivate(this.editField);
    // stop the event to avoid a page refresh in Safari
    if (evt) {
      Event.stop(evt);
    }
    return false;
  },
  createForm: function() {
    this.form = document.createElement("form");
    this.form.id = this.options.formId;
    Element.addClassName(this.form, this.options.formClassName)
    this.form.onsubmit = this.onSubmit.bind(this);

    this.createEditField();

    if (this.options.textarea) {
      var br = document.createElement("br");
      this.form.appendChild(br);
    }

    if (this.options.okButton) {
      okButton = document.createElement("input");
      okButton.type = "submit";
      okButton.value = this.options.okText;
      okButton.className = ''editor_ok_button'';
      this.form.appendChild(okButton);
    }

    if (this.options.cancelLink) {
      cancelLink = document.createElement("a");
      cancelLink.href = "#";
      cancelLink.appendChild(document.createTextNode(this.options.cancelText));
      cancelLink.onclick = this.onclickCancel.bind(this);
      cancelLink.className = ''editor_cancel'';      
      this.form.appendChild(cancelLink);
    }
  },
  hasHTMLLineBreaks: function(string) {
    if (!!this.options.handleLineBreaks) return false;
    return string.match(/<br/i) || string.match(/<p>/i);
  },
  convertHTMLLineBreaks: function(string) {
    return string.replace(/<br>/gi, "\n").replace(/<br\/>/gi, "\n").replace(/<\/p>/gi, "\n").replace(/<p>/gi, "");
  },
  createEditField: function() {
    var text;
    if(this.options.loadTextURL) {
      text = this.options.loadingText;
    } else {
      text = this.getText();
    }

    var obj = this;
    
    if (this.options.rows == 1 && !!this.hasHTMLLineBreaks(text)) {
      this.options.textarea = false;
      var textField = document.createElement("input");
      textField.obj = this;
      textField.type = "text";
      textField.name = "value";
      textField.value = text;
      textField.style.backgroundColor = this.options.highlightcolor;
      textField.className = ''editor_field'';
      var size = this.options.size || this.options.cols || 0;
      if (size !!= 0) textField.size = size;
      if (this.options.submitOnBlur)
        textField.onblur = this.onSubmit.bind(this);
      this.editField = textField;
    } else {
      this.options.textarea = true;
      var textArea = document.createElement("textarea");
      textArea.obj = this;
      textArea.name = "value";
      textArea.value = this.convertHTMLLineBreaks(text);
      textArea.rows = this.options.rows;
      textArea.cols = this.options.cols || 40;
      textArea.className = ''editor_field'';      
      if (this.options.submitOnBlur)
        textArea.onblur = this.onSubmit.bind(this);
      this.editField = textArea;
    }
    
    if(this.options.loadTextURL) {
      this.loadExternalText();
    }
    this.form.appendChild(this.editField);
  },
  getText: function() {
    return this.element.innerHTML;
  },
  loadExternalText: function() {
    Element.addClassName(this.form, this.options.loadingClassName);
    this.editField.disabled = true;
    new Ajax.Request(
      this.options.loadTextURL,
      Object.extend({
        asynchronous: true,
        onComplete: this.onLoadedExternalText.bind(this)
      }, this.options.ajaxOptions)
    );
  },
  onLoadedExternalText: function(transport) {
    Element.removeClassName(this.form, this.options.loadingClassName);
    this.editField.disabled = false;
    this.editField.value = transport.responseText.stripTags();
  },
  onclickCancel: function() {
    this.onComplete();
    this.leaveEditMode();
    return false;
  },
  onFailure: function(transport) {
    this.options.onFailure(transport);
    if (this.oldInnerHTML) {
      this.element.innerHTML = this.oldInnerHTML;
      this.oldInnerHTML = null;
    }
    return false;
  },
  onSubmit: function() {
    // onLoading resets these so we need to save them away for the Ajax call
    var form = this.form;
    var value = this.editField.value;
    
    // do this first, sometimes the ajax call returns before we get a chance to switch on Saving...
    // which means this will actually switch on Saving... *after* we''ve left edit mode causing Saving...
    // to be displayed indefinitely
    this.onLoading();
    
    if (this.options.evalScripts) {
      new Ajax.Request(
        this.url, Object.extend({
          parameters: this.options.callback(form, value),
          onComplete: this.onComplete.bind(this),
          onFailure: this.onFailure.bind(this),
          asynchronous:true, 
          evalScripts:true
        }, this.options.ajaxOptions));
    } else  {
      new Ajax.Updater(
        { success: this.element,
          // don''t update on failure (this could be an option)
          failure: null }, 
        this.url, Object.extend({
          parameters: this.options.callback(form, value),
          onComplete: this.onComplete.bind(this),
          onFailure: this.onFailure.bind(this)
        }, this.options.ajaxOptions));
    }
    // stop the event to avoid a page refresh in Safari
    if (arguments.length > 1) {
      Event.stop(arguments[0]);
    }
    return false;
  },
  onLoading: function() {
    this.saving = true;
    this.removeForm();
    this.leaveHover();
    this.showSaving();
  },
  showSaving: function() {
    this.oldInnerHTML = this.element.innerHTML;
    this.element.innerHTML = this.options.savingText;
    Element.addClassName(this.element, this.options.savingClassName);
    this.element.style.backgroundColor = this.originalBackground;
    Element.show(this.element);
  },
  removeForm: function() {
    if(this.form) {
      if (this.form.parentNode) Element.remove(this.form);
      this.form = null;
    }
  },
  enterHover: function() {
    if (this.saving) return;
    this.element.style.backgroundColor = this.options.highlightcolor;
    if (this.effect) {
      this.effect.cancel();
    }
    Element.addClassName(this.element, this.options.hoverClassName)
  },
  leaveHover: function() {
    if (this.options.backgroundColor) {
      this.element.style.backgroundColor = this.oldBackground;
    }
    Element.removeClassName(this.element, this.options.hoverClassName)
    if (this.saving) return;
    this.effect = new Effect.Highlight(this.element, {
      startcolor: this.options.highlightcolor,
      endcolor: this.options.highlightendcolor,
      restorecolor: this.originalBackground
    });
  },
  leaveEditMode: function() {
    Element.removeClassName(this.element, this.options.savingClassName);
    this.removeForm();
    this.leaveHover();
    this.element.style.backgroundColor = this.originalBackground;
    Element.show(this.element);
    if (this.options.externalControl) {
      Element.show(this.options.externalControl);
    }
    this.editing = false;
    this.saving = false;
    this.oldInnerHTML = null;
    this.onLeaveEditMode();
  },
  onComplete: function(transport) {
    this.leaveEditMode();
    this.options.onComplete.bind(this)(transport, this.element);
  },
  onEnterEditMode: function() {},
  onLeaveEditMode: function() {},
  dispose: function() {
    if (this.oldInnerHTML) {
      this.element.innerHTML = this.oldInnerHTML;
    }
    this.leaveEditMode();
    Event.stopObserving(this.element, ''click'', this.onclickListener);
    Event.stopObserving(this.element, ''mouseover'', this.mouseoverListener);
    Event.stopObserving(this.element, ''mouseout'', this.mouseoutListener);
    if (this.options.externalControl) {
      Event.stopObserving(this.options.externalControl, ''click'', this.onclickListener);
      Event.stopObserving(this.options.externalControl, ''mouseover'', this.mouseoverListener);
      Event.stopObserving(this.options.externalControl, ''mouseout'', this.mouseoutListener);
    }
  }
};

Ajax.InPlaceCollectionEditor = Class.create();
Object.extend(Ajax.InPlaceCollectionEditor.prototype, Ajax.InPlaceEditor.prototype);
Object.extend(Ajax.InPlaceCollectionEditor.prototype, {
  createEditField: function() {
    if (!!this.cached_selectTag) {
      var selectTag = document.createElement("select");
      var collection = this.options.collection || [];
      var optionTag;
      collection.each(function(e,i) {
        optionTag = document.createElement("option");
        optionTag.value = (e instanceof Array) ? e[0] : e;
        if(this.options.value==optionTag.value) optionTag.selected = true;
        optionTag.appendChild(document.createTextNode((e instanceof Array) ? e[1] : e));
        selectTag.appendChild(optionTag);
      }.bind(this));
      this.cached_selectTag = selectTag;
    }

    this.editField = this.cached_selectTag;
    if(this.options.loadTextURL) this.loadExternalText();
    this.form.appendChild(this.editField);
    this.options.callback = function(form, value) {
      return "value=" + encodeURIComponent(value);
    }
  }
});

// Delayed observer, like Form.Element.Observer, 
// but waits for delay after last key input
// Ideal for live-search fields

Form.Element.DelayedObserver = Class.create();
Form.Element.DelayedObserver.prototype = {
  initialize: function(element, delay, callback) {
    this.delay     = delay || 0.5;
    this.element   = $(element);
    this.callback  = callback;
    this.timer     = null;
    this.lastValue = $F(this.element); 
    Event.observe(this.element,''keyup'',this.delayedListener.bindAsEventListener(this));
  },
  delayedListener: function(event) {
    if(this.lastValue == $F(this.element)) return;
    if(this.timer) clearTimeout(this.timer);
    this.timer = setTimeout(this.onTimerEvent.bind(this), this.delay * 1000);
    this.lastValue = $F(this.element);
  },
  onTimerEvent: function() {
    this.timer = null;
    this.callback(this.element, $F(this.element));
  }
};'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 4/6/2006 23:25'!
fSlider
	^ '// Copyright (c) 2005 Marty Haught, Thomas Fuchs 
//
// See http://script.aculo.us for more info
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

if(!!Control) var Control = {};
Control.Slider = Class.create();

// options:
//  axis: ''vertical'', or ''horizontal'' (default)
//
// callbacks:
//  onChange(value)
//  onSlide(value)
Control.Slider.prototype = {
  initialize: function(handle, track, options) {
    var slider = this;
    
    if(handle instanceof Array) {
      this.handles = handle.collect( function(e) { return $(e) });
    } else {
      this.handles = [$(handle)];
    }
    
    this.track   = $(track);
    this.options = options || {};

    this.axis      = this.options.axis || ''horizontal'';
    this.increment = this.options.increment || 1;
    this.step      = parseInt(this.options.step || ''1'');
    this.range     = this.options.range || $R(0,1);
    
    this.value     = 0; // assure backwards compat
    this.values    = this.handles.map( function() { return 0 });
    this.spans     = this.options.spans ? this.options.spans.map(function(s){ return $(s) }) : false;
    this.options.startSpan = $(this.options.startSpan || null);
    this.options.endSpan   = $(this.options.endSpan || null);

    this.restricted = this.options.restricted || false;

    this.maximum   = this.options.maximum || this.range.end;
    this.minimum   = this.options.minimum || this.range.start;

    // Will be used to align the handle onto the track, if necessary
    this.alignX = parseInt(this.options.alignX || ''0'');
    this.alignY = parseInt(this.options.alignY || ''0'');
    
    this.trackLength = this.maximumOffset() - this.minimumOffset();
    this.handleLength = this.isVertical() ? this.handles[0].offsetHeight : this.handles[0].offsetWidth;

    this.active   = false;
    this.dragging = false;
    this.disabled = false;

    if(this.options.disabled) this.setDisabled();

    // Allowed values array
    this.allowedValues = this.options.values ? this.options.values.sortBy(Prototype.K) : false;
    if(this.allowedValues) {
      this.minimum = this.allowedValues.min();
      this.maximum = this.allowedValues.max();
    }

    this.eventMouseDown = this.startDrag.bindAsEventListener(this);
    this.eventMouseUp   = this.endDrag.bindAsEventListener(this);
    this.eventMouseMove = this.update.bindAsEventListener(this);

    // Initialize handles in reverse (make sure first handle is active)
    this.handles.each( function(h,i) {
      i = slider.handles.length-1-i;
      slider.setValue(parseFloat(
        (slider.options.sliderValue instanceof Array ? 
          slider.options.sliderValue[i] : slider.options.sliderValue) || 
         slider.range.start), i);
      Element.makePositioned(h); // fix IE
      Event.observe(h, "mousedown", slider.eventMouseDown);
    });
    
    Event.observe(this.track, "mousedown", this.eventMouseDown);
    Event.observe(document, "mouseup", this.eventMouseUp);
    Event.observe(document, "mousemove", this.eventMouseMove);
    
    this.initialized = true;
  },
  dispose: function() {
    var slider = this;    
    Event.stopObserving(this.track, "mousedown", this.eventMouseDown);
    Event.stopObserving(document, "mouseup", this.eventMouseUp);
    Event.stopObserving(document, "mousemove", this.eventMouseMove);
    this.handles.each( function(h) {
      Event.stopObserving(h, "mousedown", slider.eventMouseDown);
    });
  },
  setDisabled: function(){
    this.disabled = true;
  },
  setEnabled: function(){
    this.disabled = false;
  },  
  getNearestValue: function(value){
    if(this.allowedValues){
      if(value >= this.allowedValues.max()) return(this.allowedValues.max());
      if(value <= this.allowedValues.min()) return(this.allowedValues.min());
      
      var offset = Math.abs(this.allowedValues[0] - value);
      var newValue = this.allowedValues[0];
      this.allowedValues.each( function(v) {
        var currentOffset = Math.abs(v - value);
        if(currentOffset <= offset){
          newValue = v;
          offset = currentOffset;
        } 
      });
      return newValue;
    }
    if(value > this.range.end) return this.range.end;
    if(value < this.range.start) return this.range.start;
    return value;
  },
  setValue: function(sliderValue, handleIdx){
    if(!!this.active) {
      this.activeHandle    = this.handles[handleIdx];
      this.activeHandleIdx = handleIdx;
      this.updateStyles();
    }
    handleIdx = handleIdx || this.activeHandleIdx || 0;
    if(this.initialized && this.restricted) {
      if((handleIdx>0) && (sliderValue<this.values[handleIdx-1]))
        sliderValue = this.values[handleIdx-1];
      if((handleIdx < (this.handles.length-1)) && (sliderValue>this.values[handleIdx+1]))
        sliderValue = this.values[handleIdx+1];
    }
    sliderValue = this.getNearestValue(sliderValue);
    this.values[handleIdx] = sliderValue;
    this.value = this.values[0]; // assure backwards compat
    
    this.handles[handleIdx].style[this.isVertical() ? ''top'' : ''left''] = 
      this.translateToPx(sliderValue);
    
    this.drawSpans();
    if(!!this.dragging || !!this.event) this.updateFinished();
  },
  setValueBy: function(delta, handleIdx) {
    this.setValue(this.values[handleIdx || this.activeHandleIdx || 0] + delta, 
      handleIdx || this.activeHandleIdx || 0);
  },
  translateToPx: function(value) {
    return Math.round(
      ((this.trackLength-this.handleLength)/(this.range.end-this.range.start)) * 
      (value - this.range.start)) + "px";
  },
  translateToValue: function(offset) {
    return ((offset/(this.trackLength-this.handleLength) * 
      (this.range.end-this.range.start)) + this.range.start);
  },
  getRange: function(range) {
    var v = this.values.sortBy(Prototype.K); 
    range = range || 0;
    return $R(v[range],v[range+1]);
  },
  minimumOffset: function(){
    return(this.isVertical() ? this.alignY : this.alignX);
  },
  maximumOffset: function(){
    return(this.isVertical() ?
      this.track.offsetHeight - this.alignY : this.track.offsetWidth - this.alignX);
  },  
  isVertical:  function(){
    return (this.axis == ''vertical'');
  },
  drawSpans: function() {
    var slider = this;
    if(this.spans)
      $R(0, this.spans.length-1).each(function(r) { slider.setSpan(slider.spans[r], slider.getRange(r)) });
    if(this.options.startSpan)
      this.setSpan(this.options.startSpan,
        $R(0, this.values.length>1 ? this.getRange(0).min() : this.value ));
    if(this.options.endSpan)
      this.setSpan(this.options.endSpan, 
        $R(this.values.length>1 ? this.getRange(this.spans.length-1).max() : this.value, this.maximum));
  },
  setSpan: function(span, range) {
    if(this.isVertical()) {
      span.style.top = this.translateToPx(range.start);
      span.style.height = this.translateToPx(range.end - range.start + this.range.start);
    } else {
      span.style.left = this.translateToPx(range.start);
      span.style.width = this.translateToPx(range.end - range.start + this.range.start);
    }
  },
  updateStyles: function() {
    this.handles.each( function(h){ Element.removeClassName(h, ''selected'') });
    Element.addClassName(this.activeHandle, ''selected'');
  },
  startDrag: function(event) {
    if(Event.isLeftClick(event)) {
      if(!!this.disabled){
        this.active = true;
        
        var handle = Event.element(event);
        var pointer  = [Event.pointerX(event), Event.pointerY(event)];
        if(handle==this.track) {
          var offsets  = Position.cumulativeOffset(this.track); 
          this.event = event;
          this.setValue(this.translateToValue( 
           (this.isVertical() ? pointer[1]-offsets[1] : pointer[0]-offsets[0])-(this.handleLength/2)
          ));
          var offsets  = Position.cumulativeOffset(this.activeHandle);
          this.offsetX = (pointer[0] - offsets[0]);
          this.offsetY = (pointer[1] - offsets[1]);
        } else {
          // find the handle (prevents issues with Safari)
          while((this.handles.indexOf(handle) == -1) && handle.parentNode) 
            handle = handle.parentNode;
        
          this.activeHandle    = handle;
          this.activeHandleIdx = this.handles.indexOf(this.activeHandle);
          this.updateStyles();
        
          var offsets  = Position.cumulativeOffset(this.activeHandle);
          this.offsetX = (pointer[0] - offsets[0]);
          this.offsetY = (pointer[1] - offsets[1]);
        }
      }
      Event.stop(event);
    }
  },
  update: function(event) {
   if(this.active) {
      if(!!this.dragging) this.dragging = true;
      this.draw(event);
      // fix AppleWebKit rendering
      if(navigator.appVersion.indexOf(''AppleWebKit'')>0) window.scrollBy(0,0);
      Event.stop(event);
   }
  },
  draw: function(event) {
    var pointer = [Event.pointerX(event), Event.pointerY(event)];
    var offsets = Position.cumulativeOffset(this.track);
    pointer[0] -= this.offsetX + offsets[0];
    pointer[1] -= this.offsetY + offsets[1];
    this.event = event;
    this.setValue(this.translateToValue( this.isVertical() ? pointer[1] : pointer[0] ));
    if(this.initialized && this.options.onSlide)
      this.options.onSlide(this.values.length>1 ? this.values : this.value, this);
  },
  endDrag: function(event) {
    if(this.active && this.dragging) {
      this.finishDrag(event, true);
      Event.stop(event);
    }
    this.active = false;
    this.dragging = false;
  },  
  finishDrag: function(event, success) {
    this.active = false;
    this.dragging = false;
    this.updateFinished();
  },
  updateFinished: function() {
    if(this.initialized && this.options.onChange) 
      this.options.onChange(this.values.length>1 ? this.values : this.value, this);
    this.event = null;
  }
}'! !

!SUScriptLibrary methodsFor: 'extensions' stamp: 'lr 4/7/2006 10:35'!
xTree
	^ 'Object.extend(Sortable, {
	treeSequence: function(element, options) {
		return Sortable.tree(element, options).children.map(function(each) {
			return [encodeURIComponent(each.parent.id) + ":" + encodeURIComponent(each.id)]
				.concat(each.children.map(arguments.callee));
		}).flatten().join(","); } });'! !

!String methodsFor: '*scriptaculous' stamp: 'lr 4/1/2006 11:29'!
asJavascript
	^ SUJavascript encode: self! !

!Collection methodsFor: '*scriptaculous' stamp: 'lr 4/6/2006 08:09'!
asJavascript
	^ String streamContents: [ :stream |
		stream nextPut: $[.
		self 
			do: [ :each | stream nextPutAll: each asJavascript ]
			separatedBy: [ stream nextPut: $, ].
		stream nextPut: $] ]! !

!WATagBrush methodsFor: '*scriptaculous' stamp: 'lr 4/7/2006 13:57'!
passenger: anObject
	self id: SUSortable passengerPrefix , (canvas context storePassenger: anObject)! !

!WATagBrush methodsFor: '*scriptaculous' stamp: 'lr 3/30/2006 21:47'!
script: aPrototype
	aPrototype id: self ensureId.
	aPrototype session addLoadScript: aPrototype! !

!Association methodsFor: '*scriptaculous' stamp: 'lr 4/6/2006 18:46'!
asJavascript
	^ String streamContents: [ :stream |
		stream nextPut: $'; nextPutAll: self key.
		self value isNil
			ifTrue: [ stream nextPut: $' ]
			ifFalse: [ 
				stream nextPut: $=.
				self value isString
					ifTrue: [ stream nextPutAll: self value; nextPut: $' ]
					ifFalse: [ stream nextPut: $'; nextPut: $+; nextPutAll: self value asJavascript ] ] ]! !
SUJavascript initialize!
SUAllTests initialize!
